import { isVue2, markRaw } from 'vue-demi';
import { registApi } from '../core/registApi';
import { FetchSymbol, setActiveFetch } from './rootFetch';
export function createFetch(client, options) {
    var registApis = registApi(client, options.apis, options.prefix);
    var fetch = markRaw({
        install: function (app) {
            // this allows calling useFetch() outside of a component setup after
            setActiveFetch(fetch);
            if (!isVue2) {
                fetch._a = app;
                app.provide(FetchSymbol, fetch);
                app.config.globalProperties.$fetch = fetch;
            }
        },
        client: client,
        registApis: registApis,
        // it's actually undefined here
        // @ts-expect-error
        _a: null,
        _o: options,
    });
    return fetch;
}
//# sourceMappingURL=createFetch.js.map