import { getCurrentInstance, inject } from 'vue-demi';
import { debug } from '../env';
/**
 * activeFetch must be called to handle SSR at the top of functions like
 * `fetch`, `setup`, `serverPrefetch` and others
 */
export var activeFetch;
/**
 * Set or unset active fetch, Used in SSR and internally when calling
 * actions and getters
 * @param fetch Fetch instance
 */
export var setActiveFetch = function (fetch) { return (activeFetch = fetch); };
/**
 * Get the currently active fetch if there is any.
 */
export var getActiveFetch = function () {
    return ((getCurrentInstance() && inject(FetchSymbol)) || activeFetch);
};
export var FetchSymbol = debug ? Symbol.for('__Fetch__') : Symbol();
//# sourceMappingURL=rootFetch.js.map