import { FetchSymbol } from './rootFetch';
export function FetchVuePlugin(Vue) {
    // Used to avoid multiple mixins being setup
    // when in dev mode and hot module reload
    // https://github.com/vuejs/vue/issues/5089#issuecomment-284260111
    if (Vue.$__fetch_installed__)
        return;
    // eslint-disable-next-line @typescript-eslint/camelcase
    Vue.$__fetch_installed__ = true;
    // Equivalent of
    // app.config.globalProperties.$fetch = fetch
    Vue.mixin({
        beforeCreate: function () {
            var options = this.$options;
            if (options.fetch) {
                var fetch_1 = options.fetch;
                // HACK: taken from provide(): https://github.com/vuejs/composition-api/blob/main/src/apis/inject.ts#L31
                if (!this._provided) {
                    var provideCache_1 = {};
                    Object.defineProperty(this, '_provided', {
                        get: function () { return provideCache_1; },
                        set: function (v) { return Object.assign(provideCache_1, v); },
                    });
                }
                this._provided[FetchSymbol] = fetch_1;
                // propagate the fetch instance in an SSR friendly way
                // avoid adding it to nuxt twice
                if (!this.$pinia) {
                    this.$fetch = fetch_1;
                }
                fetch_1._a = this;
            }
            else {
                this.$fetch = (options.parent && options.parent.$fetch) || this;
            }
        },
    });
}
// Auto install if it is not done yet and `window` has `Vue` in Vue2.
// To allow users to avoid auto-installation in some cases,
if (typeof window !== 'undefined' && window.Vue) {
    window.Vue.use(FetchVuePlugin);
}
//# sourceMappingURL=vue2-plugin.js.map