"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createFetch = void 0;
var vue_demi_1 = require("vue-demi");
var registApi_1 = require("../core/registApi");
var rootFetch_1 = require("./rootFetch");
function createFetch(client, options) {
    var registApis = (0, registApi_1.registApi)(client, options.apis, options.prefix);
    var fetch = (0, vue_demi_1.markRaw)({
        install: function (app) {
            // this allows calling useFetch() outside of a component setup after
            (0, rootFetch_1.setActiveFetch)(fetch);
            if (!vue_demi_1.isVue2) {
                fetch._a = app;
                app.provide(rootFetch_1.FetchSymbol, fetch);
                app.config.globalProperties.$fetch = fetch;
            }
        },
        client: client,
        registApis: registApis,
        // it's actually undefined here
        // @ts-expect-error
        _a: null,
        _o: options,
    });
    return fetch;
}
exports.createFetch = createFetch;
//# sourceMappingURL=createFetch.js.map