"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.FetchSymbol = exports.getActiveFetch = exports.setActiveFetch = exports.activeFetch = void 0;
var vue_demi_1 = require("vue-demi");
var env_1 = require("../env");
/**
 * Set or unset active fetch, Used in SSR and internally when calling
 * actions and getters
 * @param fetch Fetch instance
 */
var setActiveFetch = function (fetch) { return (exports.activeFetch = fetch); };
exports.setActiveFetch = setActiveFetch;
/**
 * Get the currently active fetch if there is any.
 */
var getActiveFetch = function () {
    return (((0, vue_demi_1.getCurrentInstance)() && (0, vue_demi_1.inject)(exports.FetchSymbol)) || exports.activeFetch);
};
exports.getActiveFetch = getActiveFetch;
exports.FetchSymbol = env_1.debug ? Symbol.for('__Fetch__') : Symbol();
//# sourceMappingURL=rootFetch.js.map