/**
 * @vue-async/fetch@0.1.0-alpha.0
 */

(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports) :
    typeof define === 'function' && define.amd ? define('fetch', ['exports'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory((global.VueAsync = global.VueAsync || {}, global.VueAsync.Fetch = {})));
})(this, (function (exports) { 'use strict';

    (function() {
        const env = {"NODE_ENV":"development"};
        try {
            if (process) {
                process.env = Object.assign({}, process.env);
                Object.assign(process.env, env);
                return;
            }
        } catch (e) {} // avoid ReferenceError: process is not defined
        globalThis.process = { env:env };
    })();

    function ownKeys$4(object, enumerableOnly) {
      var keys = Object.keys(object);

      if (Object.getOwnPropertySymbols) {
        var symbols = Object.getOwnPropertySymbols(object);
        enumerableOnly && (symbols = symbols.filter(function (sym) {
          return Object.getOwnPropertyDescriptor(object, sym).enumerable;
        })), keys.push.apply(keys, symbols);
      }

      return keys;
    }

    function _objectSpread2(target) {
      for (var i = 1; i < arguments.length; i++) {
        var source = null != arguments[i] ? arguments[i] : {};
        i % 2 ? ownKeys$4(Object(source), !0).forEach(function (key) {
          _defineProperty(target, key, source[key]);
        }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys$4(Object(source)).forEach(function (key) {
          Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
        });
      }

      return target;
    }

    function _typeof(obj) {
      "@babel/helpers - typeof";

      return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) {
        return typeof obj;
      } : function (obj) {
        return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
      }, _typeof(obj);
    }

    function _classCallCheck(instance, Constructor) {
      if (!(instance instanceof Constructor)) {
        throw new TypeError("Cannot call a class as a function");
      }
    }

    function _defineProperties(target, props) {
      for (var i = 0; i < props.length; i++) {
        var descriptor = props[i];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if ("value" in descriptor) descriptor.writable = true;
        Object.defineProperty(target, descriptor.key, descriptor);
      }
    }

    function _createClass(Constructor, protoProps, staticProps) {
      if (protoProps) _defineProperties(Constructor.prototype, protoProps);
      if (staticProps) _defineProperties(Constructor, staticProps);
      Object.defineProperty(Constructor, "prototype", {
        writable: false
      });
      return Constructor;
    }

    function _defineProperty(obj, key, value) {
      if (key in obj) {
        Object.defineProperty(obj, key, {
          value: value,
          enumerable: true,
          configurable: true,
          writable: true
        });
      } else {
        obj[key] = value;
      }

      return obj;
    }

    function _slicedToArray(arr, i) {
      return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest();
    }

    function _toConsumableArray(arr) {
      return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread();
    }

    function _arrayWithoutHoles(arr) {
      if (Array.isArray(arr)) return _arrayLikeToArray(arr);
    }

    function _arrayWithHoles(arr) {
      if (Array.isArray(arr)) return arr;
    }

    function _iterableToArray(iter) {
      if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter);
    }

    function _iterableToArrayLimit(arr, i) {
      var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"];

      if (_i == null) return;
      var _arr = [];
      var _n = true;
      var _d = false;

      var _s, _e;

      try {
        for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) {
          _arr.push(_s.value);

          if (i && _arr.length === i) break;
        }
      } catch (err) {
        _d = true;
        _e = err;
      } finally {
        try {
          if (!_n && _i["return"] != null) _i["return"]();
        } finally {
          if (_d) throw _e;
        }
      }

      return _arr;
    }

    function _unsupportedIterableToArray(o, minLen) {
      if (!o) return;
      if (typeof o === "string") return _arrayLikeToArray(o, minLen);
      var n = Object.prototype.toString.call(o).slice(8, -1);
      if (n === "Object" && o.constructor) n = o.constructor.name;
      if (n === "Map" || n === "Set") return Array.from(o);
      if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
    }

    function _arrayLikeToArray(arr, len) {
      if (len == null || len > arr.length) len = arr.length;

      for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i];

      return arr2;
    }

    function _nonIterableSpread() {
      throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
    }

    function _nonIterableRest() {
      throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
    }

    function _createForOfIteratorHelper(o, allowArrayLike) {
      var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"];

      if (!it) {
        if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") {
          if (it) o = it;
          var i = 0;

          var F = function () {};

          return {
            s: F,
            n: function () {
              if (i >= o.length) return {
                done: true
              };
              return {
                done: false,
                value: o[i++]
              };
            },
            e: function (e) {
              throw e;
            },
            f: F
          };
        }

        throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
      }

      var normalCompletion = true,
          didErr = false,
          err;
      return {
        s: function () {
          it = it.call(o);
        },
        n: function () {
          var step = it.next();
          normalCompletion = step.done;
          return step;
        },
        e: function (e) {
          didErr = true;
          err = e;
        },
        f: function () {
          try {
            if (!normalCompletion && it.return != null) it.return();
          } finally {
            if (didErr) throw err;
          }
        }
      };
    }

    var commonjsGlobal = typeof globalThis !== 'undefined' ? globalThis : typeof window !== 'undefined' ? window : typeof global !== 'undefined' ? global : typeof self !== 'undefined' ? self : {};

    var check = function (it) {
      return it && it.Math == Math && it;
    };

    // https://github.com/zloirock/core-js/issues/86#issuecomment-115759028
    var global$w =
      // eslint-disable-next-line es-x/no-global-this -- safe
      check(typeof globalThis == 'object' && globalThis) ||
      check(typeof window == 'object' && window) ||
      // eslint-disable-next-line no-restricted-globals -- safe
      check(typeof self == 'object' && self) ||
      check(typeof commonjsGlobal == 'object' && commonjsGlobal) ||
      // eslint-disable-next-line no-new-func -- fallback
      (function () { return this; })() || Function('return this')();

    var shared$7 = {exports: {}};

    var global$v = global$w;

    // eslint-disable-next-line es-x/no-object-defineproperty -- safe
    var defineProperty$c = Object.defineProperty;

    var defineGlobalProperty$3 = function (key, value) {
      try {
        defineProperty$c(global$v, key, { value: value, configurable: true, writable: true });
      } catch (error) {
        global$v[key] = value;
      } return value;
    };

    var global$u = global$w;
    var defineGlobalProperty$2 = defineGlobalProperty$3;

    var SHARED = '__core-js_shared__';
    var store$3 = global$u[SHARED] || defineGlobalProperty$2(SHARED, {});

    var sharedStore = store$3;

    var store$2 = sharedStore;

    (shared$7.exports = function (key, value) {
      return store$2[key] || (store$2[key] = value !== undefined ? value : {});
    })('versions', []).push({
      version: '3.23.4',
      mode: 'global',
      copyright: '© 2014-2022 Denis Pushkarev (zloirock.ru)',
      license: 'https://github.com/zloirock/core-js/blob/v3.23.4/LICENSE',
      source: 'https://github.com/zloirock/core-js'
    });

    var fails$F = function (exec) {
      try {
        return !!exec();
      } catch (error) {
        return true;
      }
    };

    var fails$E = fails$F;

    var functionBindNative = !fails$E(function () {
      // eslint-disable-next-line es-x/no-function-prototype-bind -- safe
      var test = (function () { /* empty */ }).bind();
      // eslint-disable-next-line no-prototype-builtins -- safe
      return typeof test != 'function' || test.hasOwnProperty('prototype');
    });

    var NATIVE_BIND$3 = functionBindNative;

    var FunctionPrototype$3 = Function.prototype;
    var bind$8 = FunctionPrototype$3.bind;
    var call$q = FunctionPrototype$3.call;
    var uncurryThis$D = NATIVE_BIND$3 && bind$8.bind(call$q, call$q);

    var functionUncurryThis = NATIVE_BIND$3 ? function (fn) {
      return fn && uncurryThis$D(fn);
    } : function (fn) {
      return fn && function () {
        return call$q.apply(fn, arguments);
      };
    };

    var $TypeError$f = TypeError;

    // `RequireObjectCoercible` abstract operation
    // https://tc39.es/ecma262/#sec-requireobjectcoercible
    var requireObjectCoercible$c = function (it) {
      if (it == undefined) throw $TypeError$f("Can't call method on " + it);
      return it;
    };

    var requireObjectCoercible$b = requireObjectCoercible$c;

    var $Object$4 = Object;

    // `ToObject` abstract operation
    // https://tc39.es/ecma262/#sec-toobject
    var toObject$b = function (argument) {
      return $Object$4(requireObjectCoercible$b(argument));
    };

    var uncurryThis$C = functionUncurryThis;
    var toObject$a = toObject$b;

    var hasOwnProperty$1 = uncurryThis$C({}.hasOwnProperty);

    // `HasOwnProperty` abstract operation
    // https://tc39.es/ecma262/#sec-hasownproperty
    // eslint-disable-next-line es-x/no-object-hasown -- safe
    var hasOwnProperty_1 = Object.hasOwn || function hasOwn(it, key) {
      return hasOwnProperty$1(toObject$a(it), key);
    };

    var uncurryThis$B = functionUncurryThis;

    var id$2 = 0;
    var postfix = Math.random();
    var toString$j = uncurryThis$B(1.0.toString);

    var uid$4 = function (key) {
      return 'Symbol(' + (key === undefined ? '' : key) + ')_' + toString$j(++id$2 + postfix, 36);
    };

    // `IsCallable` abstract operation
    // https://tc39.es/ecma262/#sec-iscallable
    var isCallable$q = function (argument) {
      return typeof argument == 'function';
    };

    var global$t = global$w;
    var isCallable$p = isCallable$q;

    var aFunction = function (argument) {
      return isCallable$p(argument) ? argument : undefined;
    };

    var getBuiltIn$c = function (namespace, method) {
      return arguments.length < 2 ? aFunction(global$t[namespace]) : global$t[namespace] && global$t[namespace][method];
    };

    var getBuiltIn$b = getBuiltIn$c;

    var engineUserAgent = getBuiltIn$b('navigator', 'userAgent') || '';

    var global$s = global$w;
    var userAgent$5 = engineUserAgent;

    var process$4 = global$s.process;
    var Deno$1 = global$s.Deno;
    var versions = process$4 && process$4.versions || Deno$1 && Deno$1.version;
    var v8 = versions && versions.v8;
    var match, version$1;

    if (v8) {
      match = v8.split('.');
      // in old Chrome, versions of V8 isn't V8 = Chrome / 10
      // but their correct versions are not interesting for us
      version$1 = match[0] > 0 && match[0] < 4 ? 1 : +(match[0] + match[1]);
    }

    // BrowserFS NodeJS `process` polyfill incorrectly set `.v8` to `0.0`
    // so check `userAgent` even if `.v8` exists, but 0
    if (!version$1 && userAgent$5) {
      match = userAgent$5.match(/Edge\/(\d+)/);
      if (!match || match[1] >= 74) {
        match = userAgent$5.match(/Chrome\/(\d+)/);
        if (match) version$1 = +match[1];
      }
    }

    var engineV8Version = version$1;

    var V8_VERSION$3 = engineV8Version;
    var fails$D = fails$F;

    // eslint-disable-next-line es-x/no-object-getownpropertysymbols -- required for testing
    var nativeSymbol = !!Object.getOwnPropertySymbols && !fails$D(function () {
      var symbol = Symbol();
      // Chrome 38 Symbol has incorrect toString conversion
      // `get-own-property-symbols` polyfill symbols converted to object are not Symbol instances
      return !String(symbol) || !(Object(symbol) instanceof Symbol) ||
        // Chrome 38-40 symbols are not inherited from DOM collections prototypes to instances
        !Symbol.sham && V8_VERSION$3 && V8_VERSION$3 < 41;
    });

    var NATIVE_SYMBOL$6 = nativeSymbol;

    var useSymbolAsUid = NATIVE_SYMBOL$6
      && !Symbol.sham
      && typeof Symbol.iterator == 'symbol';

    var global$r = global$w;
    var shared$6 = shared$7.exports;
    var hasOwn$l = hasOwnProperty_1;
    var uid$3 = uid$4;
    var NATIVE_SYMBOL$5 = nativeSymbol;
    var USE_SYMBOL_AS_UID$1 = useSymbolAsUid;

    var WellKnownSymbolsStore$1 = shared$6('wks');
    var Symbol$1 = global$r.Symbol;
    var symbolFor = Symbol$1 && Symbol$1['for'];
    var createWellKnownSymbol = USE_SYMBOL_AS_UID$1 ? Symbol$1 : Symbol$1 && Symbol$1.withoutSetter || uid$3;

    var wellKnownSymbol$q = function (name) {
      if (!hasOwn$l(WellKnownSymbolsStore$1, name) || !(NATIVE_SYMBOL$5 || typeof WellKnownSymbolsStore$1[name] == 'string')) {
        var description = 'Symbol.' + name;
        if (NATIVE_SYMBOL$5 && hasOwn$l(Symbol$1, name)) {
          WellKnownSymbolsStore$1[name] = Symbol$1[name];
        } else if (USE_SYMBOL_AS_UID$1 && symbolFor) {
          WellKnownSymbolsStore$1[name] = symbolFor(description);
        } else {
          WellKnownSymbolsStore$1[name] = createWellKnownSymbol(description);
        }
      } return WellKnownSymbolsStore$1[name];
    };

    var wellKnownSymbol$p = wellKnownSymbol$q;

    var TO_STRING_TAG$3 = wellKnownSymbol$p('toStringTag');
    var test$1 = {};

    test$1[TO_STRING_TAG$3] = 'z';

    var toStringTagSupport = String(test$1) === '[object z]';

    var objectDefineProperty = {};

    var fails$C = fails$F;

    // Detect IE8's incomplete defineProperty implementation
    var descriptors = !fails$C(function () {
      // eslint-disable-next-line es-x/no-object-defineproperty -- required for testing
      return Object.defineProperty({}, 1, { get: function () { return 7; } })[1] != 7;
    });

    var isCallable$o = isCallable$q;

    var isObject$n = function (it) {
      return typeof it == 'object' ? it !== null : isCallable$o(it);
    };

    var global$q = global$w;
    var isObject$m = isObject$n;

    var document$3 = global$q.document;
    // typeof document.createElement is 'object' in old IE
    var EXISTS$1 = isObject$m(document$3) && isObject$m(document$3.createElement);

    var documentCreateElement$2 = function (it) {
      return EXISTS$1 ? document$3.createElement(it) : {};
    };

    var DESCRIPTORS$h = descriptors;
    var fails$B = fails$F;
    var createElement$1 = documentCreateElement$2;

    // Thanks to IE8 for its funny defineProperty
    var ie8DomDefine = !DESCRIPTORS$h && !fails$B(function () {
      // eslint-disable-next-line es-x/no-object-defineproperty -- required for testing
      return Object.defineProperty(createElement$1('div'), 'a', {
        get: function () { return 7; }
      }).a != 7;
    });

    var DESCRIPTORS$g = descriptors;
    var fails$A = fails$F;

    // V8 ~ Chrome 36-
    // https://bugs.chromium.org/p/v8/issues/detail?id=3334
    var v8PrototypeDefineBug = DESCRIPTORS$g && fails$A(function () {
      // eslint-disable-next-line es-x/no-object-defineproperty -- required for testing
      return Object.defineProperty(function () { /* empty */ }, 'prototype', {
        value: 42,
        writable: false
      }).prototype != 42;
    });

    var isObject$l = isObject$n;

    var $String$3 = String;
    var $TypeError$e = TypeError;

    // `Assert: Type(argument) is Object`
    var anObject$o = function (argument) {
      if (isObject$l(argument)) return argument;
      throw $TypeError$e($String$3(argument) + ' is not an object');
    };

    var NATIVE_BIND$2 = functionBindNative;

    var call$p = Function.prototype.call;

    var functionCall = NATIVE_BIND$2 ? call$p.bind(call$p) : function () {
      return call$p.apply(call$p, arguments);
    };

    var uncurryThis$A = functionUncurryThis;

    var objectIsPrototypeOf = uncurryThis$A({}.isPrototypeOf);

    var getBuiltIn$a = getBuiltIn$c;
    var isCallable$n = isCallable$q;
    var isPrototypeOf$7 = objectIsPrototypeOf;
    var USE_SYMBOL_AS_UID = useSymbolAsUid;

    var $Object$3 = Object;

    var isSymbol$6 = USE_SYMBOL_AS_UID ? function (it) {
      return typeof it == 'symbol';
    } : function (it) {
      var $Symbol = getBuiltIn$a('Symbol');
      return isCallable$n($Symbol) && isPrototypeOf$7($Symbol.prototype, $Object$3(it));
    };

    var $String$2 = String;

    var tryToString$6 = function (argument) {
      try {
        return $String$2(argument);
      } catch (error) {
        return 'Object';
      }
    };

    var isCallable$m = isCallable$q;
    var tryToString$5 = tryToString$6;

    var $TypeError$d = TypeError;

    // `Assert: IsCallable(argument) is true`
    var aCallable$8 = function (argument) {
      if (isCallable$m(argument)) return argument;
      throw $TypeError$d(tryToString$5(argument) + ' is not a function');
    };

    var aCallable$7 = aCallable$8;

    // `GetMethod` abstract operation
    // https://tc39.es/ecma262/#sec-getmethod
    var getMethod$6 = function (V, P) {
      var func = V[P];
      return func == null ? undefined : aCallable$7(func);
    };

    var call$o = functionCall;
    var isCallable$l = isCallable$q;
    var isObject$k = isObject$n;

    var $TypeError$c = TypeError;

    // `OrdinaryToPrimitive` abstract operation
    // https://tc39.es/ecma262/#sec-ordinarytoprimitive
    var ordinaryToPrimitive$1 = function (input, pref) {
      var fn, val;
      if (pref === 'string' && isCallable$l(fn = input.toString) && !isObject$k(val = call$o(fn, input))) return val;
      if (isCallable$l(fn = input.valueOf) && !isObject$k(val = call$o(fn, input))) return val;
      if (pref !== 'string' && isCallable$l(fn = input.toString) && !isObject$k(val = call$o(fn, input))) return val;
      throw $TypeError$c("Can't convert object to primitive value");
    };

    var call$n = functionCall;
    var isObject$j = isObject$n;
    var isSymbol$5 = isSymbol$6;
    var getMethod$5 = getMethod$6;
    var ordinaryToPrimitive = ordinaryToPrimitive$1;
    var wellKnownSymbol$o = wellKnownSymbol$q;

    var $TypeError$b = TypeError;
    var TO_PRIMITIVE = wellKnownSymbol$o('toPrimitive');

    // `ToPrimitive` abstract operation
    // https://tc39.es/ecma262/#sec-toprimitive
    var toPrimitive$2 = function (input, pref) {
      if (!isObject$j(input) || isSymbol$5(input)) return input;
      var exoticToPrim = getMethod$5(input, TO_PRIMITIVE);
      var result;
      if (exoticToPrim) {
        if (pref === undefined) pref = 'default';
        result = call$n(exoticToPrim, input, pref);
        if (!isObject$j(result) || isSymbol$5(result)) return result;
        throw $TypeError$b("Can't convert object to primitive value");
      }
      if (pref === undefined) pref = 'number';
      return ordinaryToPrimitive(input, pref);
    };

    var toPrimitive$1 = toPrimitive$2;
    var isSymbol$4 = isSymbol$6;

    // `ToPropertyKey` abstract operation
    // https://tc39.es/ecma262/#sec-topropertykey
    var toPropertyKey$5 = function (argument) {
      var key = toPrimitive$1(argument, 'string');
      return isSymbol$4(key) ? key : key + '';
    };

    var DESCRIPTORS$f = descriptors;
    var IE8_DOM_DEFINE$1 = ie8DomDefine;
    var V8_PROTOTYPE_DEFINE_BUG$1 = v8PrototypeDefineBug;
    var anObject$n = anObject$o;
    var toPropertyKey$4 = toPropertyKey$5;

    var $TypeError$a = TypeError;
    // eslint-disable-next-line es-x/no-object-defineproperty -- safe
    var $defineProperty$1 = Object.defineProperty;
    // eslint-disable-next-line es-x/no-object-getownpropertydescriptor -- safe
    var $getOwnPropertyDescriptor$2 = Object.getOwnPropertyDescriptor;
    var ENUMERABLE = 'enumerable';
    var CONFIGURABLE$1 = 'configurable';
    var WRITABLE = 'writable';

    // `Object.defineProperty` method
    // https://tc39.es/ecma262/#sec-object.defineproperty
    objectDefineProperty.f = DESCRIPTORS$f ? V8_PROTOTYPE_DEFINE_BUG$1 ? function defineProperty(O, P, Attributes) {
      anObject$n(O);
      P = toPropertyKey$4(P);
      anObject$n(Attributes);
      if (typeof O === 'function' && P === 'prototype' && 'value' in Attributes && WRITABLE in Attributes && !Attributes[WRITABLE]) {
        var current = $getOwnPropertyDescriptor$2(O, P);
        if (current && current[WRITABLE]) {
          O[P] = Attributes.value;
          Attributes = {
            configurable: CONFIGURABLE$1 in Attributes ? Attributes[CONFIGURABLE$1] : current[CONFIGURABLE$1],
            enumerable: ENUMERABLE in Attributes ? Attributes[ENUMERABLE] : current[ENUMERABLE],
            writable: false
          };
        }
      } return $defineProperty$1(O, P, Attributes);
    } : $defineProperty$1 : function defineProperty(O, P, Attributes) {
      anObject$n(O);
      P = toPropertyKey$4(P);
      anObject$n(Attributes);
      if (IE8_DOM_DEFINE$1) try {
        return $defineProperty$1(O, P, Attributes);
      } catch (error) { /* empty */ }
      if ('get' in Attributes || 'set' in Attributes) throw $TypeError$a('Accessors not supported');
      if ('value' in Attributes) O[P] = Attributes.value;
      return O;
    };

    var makeBuiltIn$2 = {exports: {}};

    var DESCRIPTORS$e = descriptors;
    var hasOwn$k = hasOwnProperty_1;

    var FunctionPrototype$2 = Function.prototype;
    // eslint-disable-next-line es-x/no-object-getownpropertydescriptor -- safe
    var getDescriptor = DESCRIPTORS$e && Object.getOwnPropertyDescriptor;

    var EXISTS = hasOwn$k(FunctionPrototype$2, 'name');
    // additional protection from minified / mangled / dropped function names
    var PROPER = EXISTS && (function something() { /* empty */ }).name === 'something';
    var CONFIGURABLE = EXISTS && (!DESCRIPTORS$e || (DESCRIPTORS$e && getDescriptor(FunctionPrototype$2, 'name').configurable));

    var functionName = {
      EXISTS: EXISTS,
      PROPER: PROPER,
      CONFIGURABLE: CONFIGURABLE
    };

    var uncurryThis$z = functionUncurryThis;
    var isCallable$k = isCallable$q;
    var store$1 = sharedStore;

    var functionToString$1 = uncurryThis$z(Function.toString);

    // this helper broken in `core-js@3.4.1-3.4.4`, so we can't use `shared` helper
    if (!isCallable$k(store$1.inspectSource)) {
      store$1.inspectSource = function (it) {
        return functionToString$1(it);
      };
    }

    var inspectSource$4 = store$1.inspectSource;

    var global$p = global$w;
    var isCallable$j = isCallable$q;
    var inspectSource$3 = inspectSource$4;

    var WeakMap$2 = global$p.WeakMap;

    var nativeWeakMap = isCallable$j(WeakMap$2) && /native code/.test(inspectSource$3(WeakMap$2));

    var createPropertyDescriptor$6 = function (bitmap, value) {
      return {
        enumerable: !(bitmap & 1),
        configurable: !(bitmap & 2),
        writable: !(bitmap & 4),
        value: value
      };
    };

    var DESCRIPTORS$d = descriptors;
    var definePropertyModule$8 = objectDefineProperty;
    var createPropertyDescriptor$5 = createPropertyDescriptor$6;

    var createNonEnumerableProperty$7 = DESCRIPTORS$d ? function (object, key, value) {
      return definePropertyModule$8.f(object, key, createPropertyDescriptor$5(1, value));
    } : function (object, key, value) {
      object[key] = value;
      return object;
    };

    var shared$5 = shared$7.exports;
    var uid$2 = uid$4;

    var keys$2 = shared$5('keys');

    var sharedKey$4 = function (key) {
      return keys$2[key] || (keys$2[key] = uid$2(key));
    };

    var hiddenKeys$6 = {};

    var NATIVE_WEAK_MAP$1 = nativeWeakMap;
    var global$o = global$w;
    var uncurryThis$y = functionUncurryThis;
    var isObject$i = isObject$n;
    var createNonEnumerableProperty$6 = createNonEnumerableProperty$7;
    var hasOwn$j = hasOwnProperty_1;
    var shared$4 = sharedStore;
    var sharedKey$3 = sharedKey$4;
    var hiddenKeys$5 = hiddenKeys$6;

    var OBJECT_ALREADY_INITIALIZED = 'Object already initialized';
    var TypeError$4 = global$o.TypeError;
    var WeakMap$1 = global$o.WeakMap;
    var set$4, get$3, has$2;

    var enforce = function (it) {
      return has$2(it) ? get$3(it) : set$4(it, {});
    };

    var getterFor = function (TYPE) {
      return function (it) {
        var state;
        if (!isObject$i(it) || (state = get$3(it)).type !== TYPE) {
          throw TypeError$4('Incompatible receiver, ' + TYPE + ' required');
        } return state;
      };
    };

    if (NATIVE_WEAK_MAP$1 || shared$4.state) {
      var store = shared$4.state || (shared$4.state = new WeakMap$1());
      var wmget = uncurryThis$y(store.get);
      var wmhas = uncurryThis$y(store.has);
      var wmset = uncurryThis$y(store.set);
      set$4 = function (it, metadata) {
        if (wmhas(store, it)) throw new TypeError$4(OBJECT_ALREADY_INITIALIZED);
        metadata.facade = it;
        wmset(store, it, metadata);
        return metadata;
      };
      get$3 = function (it) {
        return wmget(store, it) || {};
      };
      has$2 = function (it) {
        return wmhas(store, it);
      };
    } else {
      var STATE = sharedKey$3('state');
      hiddenKeys$5[STATE] = true;
      set$4 = function (it, metadata) {
        if (hasOwn$j(it, STATE)) throw new TypeError$4(OBJECT_ALREADY_INITIALIZED);
        metadata.facade = it;
        createNonEnumerableProperty$6(it, STATE, metadata);
        return metadata;
      };
      get$3 = function (it) {
        return hasOwn$j(it, STATE) ? it[STATE] : {};
      };
      has$2 = function (it) {
        return hasOwn$j(it, STATE);
      };
    }

    var internalState = {
      set: set$4,
      get: get$3,
      has: has$2,
      enforce: enforce,
      getterFor: getterFor
    };

    var fails$z = fails$F;
    var isCallable$i = isCallable$q;
    var hasOwn$i = hasOwnProperty_1;
    var DESCRIPTORS$c = descriptors;
    var CONFIGURABLE_FUNCTION_NAME$1 = functionName.CONFIGURABLE;
    var inspectSource$2 = inspectSource$4;
    var InternalStateModule$6 = internalState;

    var enforceInternalState$2 = InternalStateModule$6.enforce;
    var getInternalState$4 = InternalStateModule$6.get;
    // eslint-disable-next-line es-x/no-object-defineproperty -- safe
    var defineProperty$b = Object.defineProperty;

    var CONFIGURABLE_LENGTH = DESCRIPTORS$c && !fails$z(function () {
      return defineProperty$b(function () { /* empty */ }, 'length', { value: 8 }).length !== 8;
    });

    var TEMPLATE = String(String).split('String');

    var makeBuiltIn$1 = makeBuiltIn$2.exports = function (value, name, options) {
      if (String(name).slice(0, 7) === 'Symbol(') {
        name = '[' + String(name).replace(/^Symbol\(([^)]*)\)/, '$1') + ']';
      }
      if (options && options.getter) name = 'get ' + name;
      if (options && options.setter) name = 'set ' + name;
      if (!hasOwn$i(value, 'name') || (CONFIGURABLE_FUNCTION_NAME$1 && value.name !== name)) {
        if (DESCRIPTORS$c) defineProperty$b(value, 'name', { value: name, configurable: true });
        else value.name = name;
      }
      if (CONFIGURABLE_LENGTH && options && hasOwn$i(options, 'arity') && value.length !== options.arity) {
        defineProperty$b(value, 'length', { value: options.arity });
      }
      try {
        if (options && hasOwn$i(options, 'constructor') && options.constructor) {
          if (DESCRIPTORS$c) defineProperty$b(value, 'prototype', { writable: false });
        // in V8 ~ Chrome 53, prototypes of some methods, like `Array.prototype.values`, are non-writable
        } else if (value.prototype) value.prototype = undefined;
      } catch (error) { /* empty */ }
      var state = enforceInternalState$2(value);
      if (!hasOwn$i(state, 'source')) {
        state.source = TEMPLATE.join(typeof name == 'string' ? name : '');
      } return value;
    };

    // add fake Function#toString for correct work wrapped methods / constructors with methods like LoDash isNative
    // eslint-disable-next-line no-extend-native -- required
    Function.prototype.toString = makeBuiltIn$1(function toString() {
      return isCallable$i(this) && getInternalState$4(this).source || inspectSource$2(this);
    }, 'toString');

    var isCallable$h = isCallable$q;
    var definePropertyModule$7 = objectDefineProperty;
    var makeBuiltIn = makeBuiltIn$2.exports;
    var defineGlobalProperty$1 = defineGlobalProperty$3;

    var defineBuiltIn$e = function (O, key, value, options) {
      if (!options) options = {};
      var simple = options.enumerable;
      var name = options.name !== undefined ? options.name : key;
      if (isCallable$h(value)) makeBuiltIn(value, name, options);
      if (options.global) {
        if (simple) O[key] = value;
        else defineGlobalProperty$1(key, value);
      } else {
        try {
          if (!options.unsafe) delete O[key];
          else if (O[key]) simple = true;
        } catch (error) { /* empty */ }
        if (simple) O[key] = value;
        else definePropertyModule$7.f(O, key, {
          value: value,
          enumerable: false,
          configurable: !options.nonConfigurable,
          writable: !options.nonWritable
        });
      } return O;
    };

    var uncurryThis$x = functionUncurryThis;

    var toString$i = uncurryThis$x({}.toString);
    var stringSlice$8 = uncurryThis$x(''.slice);

    var classofRaw$1 = function (it) {
      return stringSlice$8(toString$i(it), 8, -1);
    };

    var TO_STRING_TAG_SUPPORT$2 = toStringTagSupport;
    var isCallable$g = isCallable$q;
    var classofRaw = classofRaw$1;
    var wellKnownSymbol$n = wellKnownSymbol$q;

    var TO_STRING_TAG$2 = wellKnownSymbol$n('toStringTag');
    var $Object$2 = Object;

    // ES3 wrong here
    var CORRECT_ARGUMENTS = classofRaw(function () { return arguments; }()) == 'Arguments';

    // fallback for IE11 Script Access Denied error
    var tryGet = function (it, key) {
      try {
        return it[key];
      } catch (error) { /* empty */ }
    };

    // getting tag from ES6+ `Object.prototype.toString`
    var classof$b = TO_STRING_TAG_SUPPORT$2 ? classofRaw : function (it) {
      var O, tag, result;
      return it === undefined ? 'Undefined' : it === null ? 'Null'
        // @@toStringTag case
        : typeof (tag = tryGet(O = $Object$2(it), TO_STRING_TAG$2)) == 'string' ? tag
        // builtinTag case
        : CORRECT_ARGUMENTS ? classofRaw(O)
        // ES3 arguments fallback
        : (result = classofRaw(O)) == 'Object' && isCallable$g(O.callee) ? 'Arguments' : result;
    };

    var TO_STRING_TAG_SUPPORT$1 = toStringTagSupport;
    var classof$a = classof$b;

    // `Object.prototype.toString` method implementation
    // https://tc39.es/ecma262/#sec-object.prototype.tostring
    var objectToString$1 = TO_STRING_TAG_SUPPORT$1 ? {}.toString : function toString() {
      return '[object ' + classof$a(this) + ']';
    };

    var TO_STRING_TAG_SUPPORT = toStringTagSupport;
    var defineBuiltIn$d = defineBuiltIn$e;
    var toString$h = objectToString$1;

    // `Object.prototype.toString` method
    // https://tc39.es/ecma262/#sec-object.prototype.tostring
    if (!TO_STRING_TAG_SUPPORT) {
      defineBuiltIn$d(Object.prototype, 'toString', toString$h, { unsafe: true });
    }

    // iterable DOM collections
    // flag - `iterable` interface - 'entries', 'keys', 'values', 'forEach' methods
    var domIterables = {
      CSSRuleList: 0,
      CSSStyleDeclaration: 0,
      CSSValueList: 0,
      ClientRectList: 0,
      DOMRectList: 0,
      DOMStringList: 0,
      DOMTokenList: 1,
      DataTransferItemList: 0,
      FileList: 0,
      HTMLAllCollection: 0,
      HTMLCollection: 0,
      HTMLFormElement: 0,
      HTMLSelectElement: 0,
      MediaList: 0,
      MimeTypeArray: 0,
      NamedNodeMap: 0,
      NodeList: 1,
      PaintRequestList: 0,
      Plugin: 0,
      PluginArray: 0,
      SVGLengthList: 0,
      SVGNumberList: 0,
      SVGPathSegList: 0,
      SVGPointList: 0,
      SVGStringList: 0,
      SVGTransformList: 0,
      SourceBufferList: 0,
      StyleSheetList: 0,
      TextTrackCueList: 0,
      TextTrackList: 0,
      TouchList: 0
    };

    // in old WebKit versions, `element.classList` is not an instance of global `DOMTokenList`
    var documentCreateElement$1 = documentCreateElement$2;

    var classList = documentCreateElement$1('span').classList;
    var DOMTokenListPrototype$2 = classList && classList.constructor && classList.constructor.prototype;

    var domTokenListPrototype = DOMTokenListPrototype$2 === Object.prototype ? undefined : DOMTokenListPrototype$2;

    var uncurryThis$w = functionUncurryThis;
    var aCallable$6 = aCallable$8;
    var NATIVE_BIND$1 = functionBindNative;

    var bind$7 = uncurryThis$w(uncurryThis$w.bind);

    // optional / simple context binding
    var functionBindContext = function (fn, that) {
      aCallable$6(fn);
      return that === undefined ? fn : NATIVE_BIND$1 ? bind$7(fn, that) : function (/* ...args */) {
        return fn.apply(that, arguments);
      };
    };

    var uncurryThis$v = functionUncurryThis;
    var fails$y = fails$F;
    var classof$9 = classofRaw$1;

    var $Object$1 = Object;
    var split = uncurryThis$v(''.split);

    // fallback for non-array-like ES3 and non-enumerable old V8 strings
    var indexedObject = fails$y(function () {
      // throws an error in rhino, see https://github.com/mozilla/rhino/issues/346
      // eslint-disable-next-line no-prototype-builtins -- safe
      return !$Object$1('z').propertyIsEnumerable(0);
    }) ? function (it) {
      return classof$9(it) == 'String' ? split(it, '') : $Object$1(it);
    } : $Object$1;

    var ceil = Math.ceil;
    var floor$3 = Math.floor;

    // `Math.trunc` method
    // https://tc39.es/ecma262/#sec-math.trunc
    // eslint-disable-next-line es-x/no-math-trunc -- safe
    var mathTrunc = Math.trunc || function trunc(x) {
      var n = +x;
      return (n > 0 ? floor$3 : ceil)(n);
    };

    var trunc = mathTrunc;

    // `ToIntegerOrInfinity` abstract operation
    // https://tc39.es/ecma262/#sec-tointegerorinfinity
    var toIntegerOrInfinity$6 = function (argument) {
      var number = +argument;
      // eslint-disable-next-line no-self-compare -- NaN check
      return number !== number || number === 0 ? 0 : trunc(number);
    };

    var toIntegerOrInfinity$5 = toIntegerOrInfinity$6;

    var min$6 = Math.min;

    // `ToLength` abstract operation
    // https://tc39.es/ecma262/#sec-tolength
    var toLength$6 = function (argument) {
      return argument > 0 ? min$6(toIntegerOrInfinity$5(argument), 0x1FFFFFFFFFFFFF) : 0; // 2 ** 53 - 1 == 9007199254740991
    };

    var toLength$5 = toLength$6;

    // `LengthOfArrayLike` abstract operation
    // https://tc39.es/ecma262/#sec-lengthofarraylike
    var lengthOfArrayLike$9 = function (obj) {
      return toLength$5(obj.length);
    };

    var classof$8 = classofRaw$1;

    // `IsArray` abstract operation
    // https://tc39.es/ecma262/#sec-isarray
    // eslint-disable-next-line es-x/no-array-isarray -- safe
    var isArray$5 = Array.isArray || function isArray(argument) {
      return classof$8(argument) == 'Array';
    };

    var uncurryThis$u = functionUncurryThis;
    var fails$x = fails$F;
    var isCallable$f = isCallable$q;
    var classof$7 = classof$b;
    var getBuiltIn$9 = getBuiltIn$c;
    var inspectSource$1 = inspectSource$4;

    var noop = function () { /* empty */ };
    var empty = [];
    var construct = getBuiltIn$9('Reflect', 'construct');
    var constructorRegExp = /^\s*(?:class|function)\b/;
    var exec$4 = uncurryThis$u(constructorRegExp.exec);
    var INCORRECT_TO_STRING = !constructorRegExp.exec(noop);

    var isConstructorModern = function isConstructor(argument) {
      if (!isCallable$f(argument)) return false;
      try {
        construct(noop, empty, argument);
        return true;
      } catch (error) {
        return false;
      }
    };

    var isConstructorLegacy = function isConstructor(argument) {
      if (!isCallable$f(argument)) return false;
      switch (classof$7(argument)) {
        case 'AsyncFunction':
        case 'GeneratorFunction':
        case 'AsyncGeneratorFunction': return false;
      }
      try {
        // we can't check .prototype since constructors produced by .bind haven't it
        // `Function#toString` throws on some built-it function in some legacy engines
        // (for example, `DOMQuad` and similar in FF41-)
        return INCORRECT_TO_STRING || !!exec$4(constructorRegExp, inspectSource$1(argument));
      } catch (error) {
        return true;
      }
    };

    isConstructorLegacy.sham = true;

    // `IsConstructor` abstract operation
    // https://tc39.es/ecma262/#sec-isconstructor
    var isConstructor$4 = !construct || fails$x(function () {
      var called;
      return isConstructorModern(isConstructorModern.call)
        || !isConstructorModern(Object)
        || !isConstructorModern(function () { called = true; })
        || called;
    }) ? isConstructorLegacy : isConstructorModern;

    var isArray$4 = isArray$5;
    var isConstructor$3 = isConstructor$4;
    var isObject$h = isObject$n;
    var wellKnownSymbol$m = wellKnownSymbol$q;

    var SPECIES$6 = wellKnownSymbol$m('species');
    var $Array$3 = Array;

    // a part of `ArraySpeciesCreate` abstract operation
    // https://tc39.es/ecma262/#sec-arrayspeciescreate
    var arraySpeciesConstructor$1 = function (originalArray) {
      var C;
      if (isArray$4(originalArray)) {
        C = originalArray.constructor;
        // cross-realm fallback
        if (isConstructor$3(C) && (C === $Array$3 || isArray$4(C.prototype))) C = undefined;
        else if (isObject$h(C)) {
          C = C[SPECIES$6];
          if (C === null) C = undefined;
        }
      } return C === undefined ? $Array$3 : C;
    };

    var arraySpeciesConstructor = arraySpeciesConstructor$1;

    // `ArraySpeciesCreate` abstract operation
    // https://tc39.es/ecma262/#sec-arrayspeciescreate
    var arraySpeciesCreate$3 = function (originalArray, length) {
      return new (arraySpeciesConstructor(originalArray))(length === 0 ? 0 : length);
    };

    var bind$6 = functionBindContext;
    var uncurryThis$t = functionUncurryThis;
    var IndexedObject$3 = indexedObject;
    var toObject$9 = toObject$b;
    var lengthOfArrayLike$8 = lengthOfArrayLike$9;
    var arraySpeciesCreate$2 = arraySpeciesCreate$3;

    var push$5 = uncurryThis$t([].push);

    // `Array.prototype.{ forEach, map, filter, some, every, find, findIndex, filterReject }` methods implementation
    var createMethod$3 = function (TYPE) {
      var IS_MAP = TYPE == 1;
      var IS_FILTER = TYPE == 2;
      var IS_SOME = TYPE == 3;
      var IS_EVERY = TYPE == 4;
      var IS_FIND_INDEX = TYPE == 6;
      var IS_FILTER_REJECT = TYPE == 7;
      var NO_HOLES = TYPE == 5 || IS_FIND_INDEX;
      return function ($this, callbackfn, that, specificCreate) {
        var O = toObject$9($this);
        var self = IndexedObject$3(O);
        var boundFunction = bind$6(callbackfn, that);
        var length = lengthOfArrayLike$8(self);
        var index = 0;
        var create = specificCreate || arraySpeciesCreate$2;
        var target = IS_MAP ? create($this, length) : IS_FILTER || IS_FILTER_REJECT ? create($this, 0) : undefined;
        var value, result;
        for (;length > index; index++) if (NO_HOLES || index in self) {
          value = self[index];
          result = boundFunction(value, index, O);
          if (TYPE) {
            if (IS_MAP) target[index] = result; // map
            else if (result) switch (TYPE) {
              case 3: return true;              // some
              case 5: return value;             // find
              case 6: return index;             // findIndex
              case 2: push$5(target, value);      // filter
            } else switch (TYPE) {
              case 4: return false;             // every
              case 7: push$5(target, value);      // filterReject
            }
          }
        }
        return IS_FIND_INDEX ? -1 : IS_SOME || IS_EVERY ? IS_EVERY : target;
      };
    };

    var arrayIteration = {
      // `Array.prototype.forEach` method
      // https://tc39.es/ecma262/#sec-array.prototype.foreach
      forEach: createMethod$3(0),
      // `Array.prototype.map` method
      // https://tc39.es/ecma262/#sec-array.prototype.map
      map: createMethod$3(1),
      // `Array.prototype.filter` method
      // https://tc39.es/ecma262/#sec-array.prototype.filter
      filter: createMethod$3(2),
      // `Array.prototype.some` method
      // https://tc39.es/ecma262/#sec-array.prototype.some
      some: createMethod$3(3),
      // `Array.prototype.every` method
      // https://tc39.es/ecma262/#sec-array.prototype.every
      every: createMethod$3(4),
      // `Array.prototype.find` method
      // https://tc39.es/ecma262/#sec-array.prototype.find
      find: createMethod$3(5),
      // `Array.prototype.findIndex` method
      // https://tc39.es/ecma262/#sec-array.prototype.findIndex
      findIndex: createMethod$3(6),
      // `Array.prototype.filterReject` method
      // https://github.com/tc39/proposal-array-filtering
      filterReject: createMethod$3(7)
    };

    var fails$w = fails$F;

    var arrayMethodIsStrict$3 = function (METHOD_NAME, argument) {
      var method = [][METHOD_NAME];
      return !!method && fails$w(function () {
        // eslint-disable-next-line no-useless-call -- required for testing
        method.call(null, argument || function () { return 1; }, 1);
      });
    };

    var $forEach$1 = arrayIteration.forEach;
    var arrayMethodIsStrict$2 = arrayMethodIsStrict$3;

    var STRICT_METHOD$2 = arrayMethodIsStrict$2('forEach');

    // `Array.prototype.forEach` method implementation
    // https://tc39.es/ecma262/#sec-array.prototype.foreach
    var arrayForEach = !STRICT_METHOD$2 ? function forEach(callbackfn /* , thisArg */) {
      return $forEach$1(this, callbackfn, arguments.length > 1 ? arguments[1] : undefined);
    // eslint-disable-next-line es-x/no-array-prototype-foreach -- safe
    } : [].forEach;

    var global$n = global$w;
    var DOMIterables$1 = domIterables;
    var DOMTokenListPrototype$1 = domTokenListPrototype;
    var forEach = arrayForEach;
    var createNonEnumerableProperty$5 = createNonEnumerableProperty$7;

    var handlePrototype$1 = function (CollectionPrototype) {
      // some Chrome versions have non-configurable methods on DOMTokenList
      if (CollectionPrototype && CollectionPrototype.forEach !== forEach) try {
        createNonEnumerableProperty$5(CollectionPrototype, 'forEach', forEach);
      } catch (error) {
        CollectionPrototype.forEach = forEach;
      }
    };

    for (var COLLECTION_NAME$1 in DOMIterables$1) {
      if (DOMIterables$1[COLLECTION_NAME$1]) {
        handlePrototype$1(global$n[COLLECTION_NAME$1] && global$n[COLLECTION_NAME$1].prototype);
      }
    }

    handlePrototype$1(DOMTokenListPrototype$1);

    var objectGetOwnPropertyDescriptor = {};

    var objectPropertyIsEnumerable = {};

    var $propertyIsEnumerable$1 = {}.propertyIsEnumerable;
    // eslint-disable-next-line es-x/no-object-getownpropertydescriptor -- safe
    var getOwnPropertyDescriptor$6 = Object.getOwnPropertyDescriptor;

    // Nashorn ~ JDK8 bug
    var NASHORN_BUG = getOwnPropertyDescriptor$6 && !$propertyIsEnumerable$1.call({ 1: 2 }, 1);

    // `Object.prototype.propertyIsEnumerable` method implementation
    // https://tc39.es/ecma262/#sec-object.prototype.propertyisenumerable
    objectPropertyIsEnumerable.f = NASHORN_BUG ? function propertyIsEnumerable(V) {
      var descriptor = getOwnPropertyDescriptor$6(this, V);
      return !!descriptor && descriptor.enumerable;
    } : $propertyIsEnumerable$1;

    // toObject with fallback for non-array-like ES3 strings
    var IndexedObject$2 = indexedObject;
    var requireObjectCoercible$a = requireObjectCoercible$c;

    var toIndexedObject$9 = function (it) {
      return IndexedObject$2(requireObjectCoercible$a(it));
    };

    var DESCRIPTORS$b = descriptors;
    var call$m = functionCall;
    var propertyIsEnumerableModule$2 = objectPropertyIsEnumerable;
    var createPropertyDescriptor$4 = createPropertyDescriptor$6;
    var toIndexedObject$8 = toIndexedObject$9;
    var toPropertyKey$3 = toPropertyKey$5;
    var hasOwn$h = hasOwnProperty_1;
    var IE8_DOM_DEFINE = ie8DomDefine;

    // eslint-disable-next-line es-x/no-object-getownpropertydescriptor -- safe
    var $getOwnPropertyDescriptor$1 = Object.getOwnPropertyDescriptor;

    // `Object.getOwnPropertyDescriptor` method
    // https://tc39.es/ecma262/#sec-object.getownpropertydescriptor
    objectGetOwnPropertyDescriptor.f = DESCRIPTORS$b ? $getOwnPropertyDescriptor$1 : function getOwnPropertyDescriptor(O, P) {
      O = toIndexedObject$8(O);
      P = toPropertyKey$3(P);
      if (IE8_DOM_DEFINE) try {
        return $getOwnPropertyDescriptor$1(O, P);
      } catch (error) { /* empty */ }
      if (hasOwn$h(O, P)) return createPropertyDescriptor$4(!call$m(propertyIsEnumerableModule$2.f, O, P), O[P]);
    };

    var objectGetOwnPropertyNames = {};

    var toIntegerOrInfinity$4 = toIntegerOrInfinity$6;

    var max$4 = Math.max;
    var min$5 = Math.min;

    // Helper for a popular repeating case of the spec:
    // Let integer be ? ToInteger(index).
    // If integer < 0, let result be max((length + integer), 0); else let result be min(integer, length).
    var toAbsoluteIndex$4 = function (index, length) {
      var integer = toIntegerOrInfinity$4(index);
      return integer < 0 ? max$4(integer + length, 0) : min$5(integer, length);
    };

    var toIndexedObject$7 = toIndexedObject$9;
    var toAbsoluteIndex$3 = toAbsoluteIndex$4;
    var lengthOfArrayLike$7 = lengthOfArrayLike$9;

    // `Array.prototype.{ indexOf, includes }` methods implementation
    var createMethod$2 = function (IS_INCLUDES) {
      return function ($this, el, fromIndex) {
        var O = toIndexedObject$7($this);
        var length = lengthOfArrayLike$7(O);
        var index = toAbsoluteIndex$3(fromIndex, length);
        var value;
        // Array#includes uses SameValueZero equality algorithm
        // eslint-disable-next-line no-self-compare -- NaN check
        if (IS_INCLUDES && el != el) while (length > index) {
          value = O[index++];
          // eslint-disable-next-line no-self-compare -- NaN check
          if (value != value) return true;
        // Array#indexOf ignores holes, Array#includes - not
        } else for (;length > index; index++) {
          if ((IS_INCLUDES || index in O) && O[index] === el) return IS_INCLUDES || index || 0;
        } return !IS_INCLUDES && -1;
      };
    };

    var arrayIncludes = {
      // `Array.prototype.includes` method
      // https://tc39.es/ecma262/#sec-array.prototype.includes
      includes: createMethod$2(true),
      // `Array.prototype.indexOf` method
      // https://tc39.es/ecma262/#sec-array.prototype.indexof
      indexOf: createMethod$2(false)
    };

    var uncurryThis$s = functionUncurryThis;
    var hasOwn$g = hasOwnProperty_1;
    var toIndexedObject$6 = toIndexedObject$9;
    var indexOf$1 = arrayIncludes.indexOf;
    var hiddenKeys$4 = hiddenKeys$6;

    var push$4 = uncurryThis$s([].push);

    var objectKeysInternal = function (object, names) {
      var O = toIndexedObject$6(object);
      var i = 0;
      var result = [];
      var key;
      for (key in O) !hasOwn$g(hiddenKeys$4, key) && hasOwn$g(O, key) && push$4(result, key);
      // Don't enum bug & hidden keys
      while (names.length > i) if (hasOwn$g(O, key = names[i++])) {
        ~indexOf$1(result, key) || push$4(result, key);
      }
      return result;
    };

    // IE8- don't enum bug keys
    var enumBugKeys$3 = [
      'constructor',
      'hasOwnProperty',
      'isPrototypeOf',
      'propertyIsEnumerable',
      'toLocaleString',
      'toString',
      'valueOf'
    ];

    var internalObjectKeys$1 = objectKeysInternal;
    var enumBugKeys$2 = enumBugKeys$3;

    var hiddenKeys$3 = enumBugKeys$2.concat('length', 'prototype');

    // `Object.getOwnPropertyNames` method
    // https://tc39.es/ecma262/#sec-object.getownpropertynames
    // eslint-disable-next-line es-x/no-object-getownpropertynames -- safe
    objectGetOwnPropertyNames.f = Object.getOwnPropertyNames || function getOwnPropertyNames(O) {
      return internalObjectKeys$1(O, hiddenKeys$3);
    };

    var objectGetOwnPropertySymbols = {};

    // eslint-disable-next-line es-x/no-object-getownpropertysymbols -- safe
    objectGetOwnPropertySymbols.f = Object.getOwnPropertySymbols;

    var getBuiltIn$8 = getBuiltIn$c;
    var uncurryThis$r = functionUncurryThis;
    var getOwnPropertyNamesModule$2 = objectGetOwnPropertyNames;
    var getOwnPropertySymbolsModule$3 = objectGetOwnPropertySymbols;
    var anObject$m = anObject$o;

    var concat$2 = uncurryThis$r([].concat);

    // all object keys, includes non-enumerable and symbols
    var ownKeys$3 = getBuiltIn$8('Reflect', 'ownKeys') || function ownKeys(it) {
      var keys = getOwnPropertyNamesModule$2.f(anObject$m(it));
      var getOwnPropertySymbols = getOwnPropertySymbolsModule$3.f;
      return getOwnPropertySymbols ? concat$2(keys, getOwnPropertySymbols(it)) : keys;
    };

    var hasOwn$f = hasOwnProperty_1;
    var ownKeys$2 = ownKeys$3;
    var getOwnPropertyDescriptorModule$3 = objectGetOwnPropertyDescriptor;
    var definePropertyModule$6 = objectDefineProperty;

    var copyConstructorProperties$2 = function (target, source, exceptions) {
      var keys = ownKeys$2(source);
      var defineProperty = definePropertyModule$6.f;
      var getOwnPropertyDescriptor = getOwnPropertyDescriptorModule$3.f;
      for (var i = 0; i < keys.length; i++) {
        var key = keys[i];
        if (!hasOwn$f(target, key) && !(exceptions && hasOwn$f(exceptions, key))) {
          defineProperty(target, key, getOwnPropertyDescriptor(source, key));
        }
      }
    };

    var fails$v = fails$F;
    var isCallable$e = isCallable$q;

    var replacement = /#|\.prototype\./;

    var isForced$5 = function (feature, detection) {
      var value = data[normalize(feature)];
      return value == POLYFILL ? true
        : value == NATIVE ? false
        : isCallable$e(detection) ? fails$v(detection)
        : !!detection;
    };

    var normalize = isForced$5.normalize = function (string) {
      return String(string).replace(replacement, '.').toLowerCase();
    };

    var data = isForced$5.data = {};
    var NATIVE = isForced$5.NATIVE = 'N';
    var POLYFILL = isForced$5.POLYFILL = 'P';

    var isForced_1 = isForced$5;

    var global$m = global$w;
    var getOwnPropertyDescriptor$5 = objectGetOwnPropertyDescriptor.f;
    var createNonEnumerableProperty$4 = createNonEnumerableProperty$7;
    var defineBuiltIn$c = defineBuiltIn$e;
    var defineGlobalProperty = defineGlobalProperty$3;
    var copyConstructorProperties$1 = copyConstructorProperties$2;
    var isForced$4 = isForced_1;

    /*
      options.target         - name of the target object
      options.global         - target is the global object
      options.stat           - export as static methods of target
      options.proto          - export as prototype methods of target
      options.real           - real prototype method for the `pure` version
      options.forced         - export even if the native feature is available
      options.bind           - bind methods to the target, required for the `pure` version
      options.wrap           - wrap constructors to preventing global pollution, required for the `pure` version
      options.unsafe         - use the simple assignment of property instead of delete + defineProperty
      options.sham           - add a flag to not completely full polyfills
      options.enumerable     - export as enumerable property
      options.dontCallGetSet - prevent calling a getter on target
      options.name           - the .name of the function if it does not match the key
    */
    var _export = function (options, source) {
      var TARGET = options.target;
      var GLOBAL = options.global;
      var STATIC = options.stat;
      var FORCED, target, key, targetProperty, sourceProperty, descriptor;
      if (GLOBAL) {
        target = global$m;
      } else if (STATIC) {
        target = global$m[TARGET] || defineGlobalProperty(TARGET, {});
      } else {
        target = (global$m[TARGET] || {}).prototype;
      }
      if (target) for (key in source) {
        sourceProperty = source[key];
        if (options.dontCallGetSet) {
          descriptor = getOwnPropertyDescriptor$5(target, key);
          targetProperty = descriptor && descriptor.value;
        } else targetProperty = target[key];
        FORCED = isForced$4(GLOBAL ? key : TARGET + (STATIC ? '.' : '#') + key, options.forced);
        // contained in target
        if (!FORCED && targetProperty !== undefined) {
          if (typeof sourceProperty == typeof targetProperty) continue;
          copyConstructorProperties$1(sourceProperty, targetProperty);
        }
        // add a flag to not completely full polyfills
        if (options.sham || (targetProperty && targetProperty.sham)) {
          createNonEnumerableProperty$4(sourceProperty, 'sham', true);
        }
        defineBuiltIn$c(target, key, sourceProperty, options);
      }
    };

    var $$K = _export;
    var uncurryThis$q = functionUncurryThis;
    var IndexedObject$1 = indexedObject;
    var toIndexedObject$5 = toIndexedObject$9;
    var arrayMethodIsStrict$1 = arrayMethodIsStrict$3;

    var un$Join = uncurryThis$q([].join);

    var ES3_STRINGS = IndexedObject$1 != Object;
    var STRICT_METHOD$1 = arrayMethodIsStrict$1('join', ',');

    // `Array.prototype.join` method
    // https://tc39.es/ecma262/#sec-array.prototype.join
    $$K({ target: 'Array', proto: true, forced: ES3_STRINGS || !STRICT_METHOD$1 }, {
      join: function join(separator) {
        return un$Join(toIndexedObject$5(this), separator === undefined ? ',' : separator);
      }
    });

    var internalObjectKeys = objectKeysInternal;
    var enumBugKeys$1 = enumBugKeys$3;

    // `Object.keys` method
    // https://tc39.es/ecma262/#sec-object.keys
    // eslint-disable-next-line es-x/no-object-keys -- safe
    var objectKeys$3 = Object.keys || function keys(O) {
      return internalObjectKeys(O, enumBugKeys$1);
    };

    var $$J = _export;
    var toObject$8 = toObject$b;
    var nativeKeys = objectKeys$3;
    var fails$u = fails$F;

    var FAILS_ON_PRIMITIVES$3 = fails$u(function () { nativeKeys(1); });

    // `Object.keys` method
    // https://tc39.es/ecma262/#sec-object.keys
    $$J({ target: 'Object', stat: true, forced: FAILS_ON_PRIMITIVES$3 }, {
      keys: function keys(it) {
        return nativeKeys(toObject$8(it));
      }
    });

    var classof$6 = classof$b;

    var $String$1 = String;

    var toString$g = function (argument) {
      if (classof$6(argument) === 'Symbol') throw TypeError('Cannot convert a Symbol value to a string');
      return $String$1(argument);
    };

    var anObject$l = anObject$o;

    // `RegExp.prototype.flags` getter implementation
    // https://tc39.es/ecma262/#sec-get-regexp.prototype.flags
    var regexpFlags$1 = function () {
      var that = anObject$l(this);
      var result = '';
      if (that.hasIndices) result += 'd';
      if (that.global) result += 'g';
      if (that.ignoreCase) result += 'i';
      if (that.multiline) result += 'm';
      if (that.dotAll) result += 's';
      if (that.unicode) result += 'u';
      if (that.unicodeSets) result += 'v';
      if (that.sticky) result += 'y';
      return result;
    };

    var fails$t = fails$F;
    var global$l = global$w;

    // babel-minify and Closure Compiler transpiles RegExp('a', 'y') -> /a/y and it causes SyntaxError
    var $RegExp$2 = global$l.RegExp;

    var UNSUPPORTED_Y$3 = fails$t(function () {
      var re = $RegExp$2('a', 'y');
      re.lastIndex = 2;
      return re.exec('abcd') != null;
    });

    // UC Browser bug
    // https://github.com/zloirock/core-js/issues/1008
    var MISSED_STICKY$1 = UNSUPPORTED_Y$3 || fails$t(function () {
      return !$RegExp$2('a', 'y').sticky;
    });

    var BROKEN_CARET = UNSUPPORTED_Y$3 || fails$t(function () {
      // https://bugzilla.mozilla.org/show_bug.cgi?id=773687
      var re = $RegExp$2('^r', 'gy');
      re.lastIndex = 2;
      return re.exec('str') != null;
    });

    var regexpStickyHelpers = {
      BROKEN_CARET: BROKEN_CARET,
      MISSED_STICKY: MISSED_STICKY$1,
      UNSUPPORTED_Y: UNSUPPORTED_Y$3
    };

    var objectDefineProperties = {};

    var DESCRIPTORS$a = descriptors;
    var V8_PROTOTYPE_DEFINE_BUG = v8PrototypeDefineBug;
    var definePropertyModule$5 = objectDefineProperty;
    var anObject$k = anObject$o;
    var toIndexedObject$4 = toIndexedObject$9;
    var objectKeys$2 = objectKeys$3;

    // `Object.defineProperties` method
    // https://tc39.es/ecma262/#sec-object.defineproperties
    // eslint-disable-next-line es-x/no-object-defineproperties -- safe
    objectDefineProperties.f = DESCRIPTORS$a && !V8_PROTOTYPE_DEFINE_BUG ? Object.defineProperties : function defineProperties(O, Properties) {
      anObject$k(O);
      var props = toIndexedObject$4(Properties);
      var keys = objectKeys$2(Properties);
      var length = keys.length;
      var index = 0;
      var key;
      while (length > index) definePropertyModule$5.f(O, key = keys[index++], props[key]);
      return O;
    };

    var getBuiltIn$7 = getBuiltIn$c;

    var html$2 = getBuiltIn$7('document', 'documentElement');

    var anObject$j = anObject$o;
    var definePropertiesModule$1 = objectDefineProperties;
    var enumBugKeys = enumBugKeys$3;
    var hiddenKeys$2 = hiddenKeys$6;
    var html$1 = html$2;
    var documentCreateElement = documentCreateElement$2;
    var sharedKey$2 = sharedKey$4;

    var GT = '>';
    var LT = '<';
    var PROTOTYPE$1 = 'prototype';
    var SCRIPT = 'script';
    var IE_PROTO$1 = sharedKey$2('IE_PROTO');

    var EmptyConstructor = function () { /* empty */ };

    var scriptTag = function (content) {
      return LT + SCRIPT + GT + content + LT + '/' + SCRIPT + GT;
    };

    // Create object with fake `null` prototype: use ActiveX Object with cleared prototype
    var NullProtoObjectViaActiveX = function (activeXDocument) {
      activeXDocument.write(scriptTag(''));
      activeXDocument.close();
      var temp = activeXDocument.parentWindow.Object;
      activeXDocument = null; // avoid memory leak
      return temp;
    };

    // Create object with fake `null` prototype: use iframe Object with cleared prototype
    var NullProtoObjectViaIFrame = function () {
      // Thrash, waste and sodomy: IE GC bug
      var iframe = documentCreateElement('iframe');
      var JS = 'java' + SCRIPT + ':';
      var iframeDocument;
      iframe.style.display = 'none';
      html$1.appendChild(iframe);
      // https://github.com/zloirock/core-js/issues/475
      iframe.src = String(JS);
      iframeDocument = iframe.contentWindow.document;
      iframeDocument.open();
      iframeDocument.write(scriptTag('document.F=Object'));
      iframeDocument.close();
      return iframeDocument.F;
    };

    // Check for document.domain and active x support
    // No need to use active x approach when document.domain is not set
    // see https://github.com/es-shims/es5-shim/issues/150
    // variation of https://github.com/kitcambridge/es5-shim/commit/4f738ac066346
    // avoid IE GC bug
    var activeXDocument;
    var NullProtoObject = function () {
      try {
        activeXDocument = new ActiveXObject('htmlfile');
      } catch (error) { /* ignore */ }
      NullProtoObject = typeof document != 'undefined'
        ? document.domain && activeXDocument
          ? NullProtoObjectViaActiveX(activeXDocument) // old IE
          : NullProtoObjectViaIFrame()
        : NullProtoObjectViaActiveX(activeXDocument); // WSH
      var length = enumBugKeys.length;
      while (length--) delete NullProtoObject[PROTOTYPE$1][enumBugKeys[length]];
      return NullProtoObject();
    };

    hiddenKeys$2[IE_PROTO$1] = true;

    // `Object.create` method
    // https://tc39.es/ecma262/#sec-object.create
    // eslint-disable-next-line es-x/no-object-create -- safe
    var objectCreate = Object.create || function create(O, Properties) {
      var result;
      if (O !== null) {
        EmptyConstructor[PROTOTYPE$1] = anObject$j(O);
        result = new EmptyConstructor();
        EmptyConstructor[PROTOTYPE$1] = null;
        // add "__proto__" for Object.getPrototypeOf polyfill
        result[IE_PROTO$1] = O;
      } else result = NullProtoObject();
      return Properties === undefined ? result : definePropertiesModule$1.f(result, Properties);
    };

    var fails$s = fails$F;
    var global$k = global$w;

    // babel-minify and Closure Compiler transpiles RegExp('.', 's') -> /./s and it causes SyntaxError
    var $RegExp$1 = global$k.RegExp;

    var regexpUnsupportedDotAll = fails$s(function () {
      var re = $RegExp$1('.', 's');
      return !(re.dotAll && re.exec('\n') && re.flags === 's');
    });

    var fails$r = fails$F;
    var global$j = global$w;

    // babel-minify and Closure Compiler transpiles RegExp('(?<a>b)', 'g') -> /(?<a>b)/g and it causes SyntaxError
    var $RegExp = global$j.RegExp;

    var regexpUnsupportedNcg = fails$r(function () {
      var re = $RegExp('(?<a>b)', 'g');
      return re.exec('b').groups.a !== 'b' ||
        'b'.replace(re, '$<a>c') !== 'bc';
    });

    /* eslint-disable regexp/no-empty-capturing-group, regexp/no-empty-group, regexp/no-lazy-ends -- testing */
    /* eslint-disable regexp/no-useless-quantifier -- testing */
    var call$l = functionCall;
    var uncurryThis$p = functionUncurryThis;
    var toString$f = toString$g;
    var regexpFlags = regexpFlags$1;
    var stickyHelpers$2 = regexpStickyHelpers;
    var shared$3 = shared$7.exports;
    var create$3 = objectCreate;
    var getInternalState$3 = internalState.get;
    var UNSUPPORTED_DOT_ALL$1 = regexpUnsupportedDotAll;
    var UNSUPPORTED_NCG$1 = regexpUnsupportedNcg;

    var nativeReplace = shared$3('native-string-replace', String.prototype.replace);
    var nativeExec = RegExp.prototype.exec;
    var patchedExec = nativeExec;
    var charAt$6 = uncurryThis$p(''.charAt);
    var indexOf = uncurryThis$p(''.indexOf);
    var replace$6 = uncurryThis$p(''.replace);
    var stringSlice$7 = uncurryThis$p(''.slice);

    var UPDATES_LAST_INDEX_WRONG = (function () {
      var re1 = /a/;
      var re2 = /b*/g;
      call$l(nativeExec, re1, 'a');
      call$l(nativeExec, re2, 'a');
      return re1.lastIndex !== 0 || re2.lastIndex !== 0;
    })();

    var UNSUPPORTED_Y$2 = stickyHelpers$2.BROKEN_CARET;

    // nonparticipating capturing group, copied from es5-shim's String#split patch.
    var NPCG_INCLUDED = /()??/.exec('')[1] !== undefined;

    var PATCH = UPDATES_LAST_INDEX_WRONG || NPCG_INCLUDED || UNSUPPORTED_Y$2 || UNSUPPORTED_DOT_ALL$1 || UNSUPPORTED_NCG$1;

    if (PATCH) {
      patchedExec = function exec(string) {
        var re = this;
        var state = getInternalState$3(re);
        var str = toString$f(string);
        var raw = state.raw;
        var result, reCopy, lastIndex, match, i, object, group;

        if (raw) {
          raw.lastIndex = re.lastIndex;
          result = call$l(patchedExec, raw, str);
          re.lastIndex = raw.lastIndex;
          return result;
        }

        var groups = state.groups;
        var sticky = UNSUPPORTED_Y$2 && re.sticky;
        var flags = call$l(regexpFlags, re);
        var source = re.source;
        var charsAdded = 0;
        var strCopy = str;

        if (sticky) {
          flags = replace$6(flags, 'y', '');
          if (indexOf(flags, 'g') === -1) {
            flags += 'g';
          }

          strCopy = stringSlice$7(str, re.lastIndex);
          // Support anchored sticky behavior.
          if (re.lastIndex > 0 && (!re.multiline || re.multiline && charAt$6(str, re.lastIndex - 1) !== '\n')) {
            source = '(?: ' + source + ')';
            strCopy = ' ' + strCopy;
            charsAdded++;
          }
          // ^(? + rx + ) is needed, in combination with some str slicing, to
          // simulate the 'y' flag.
          reCopy = new RegExp('^(?:' + source + ')', flags);
        }

        if (NPCG_INCLUDED) {
          reCopy = new RegExp('^' + source + '$(?!\\s)', flags);
        }
        if (UPDATES_LAST_INDEX_WRONG) lastIndex = re.lastIndex;

        match = call$l(nativeExec, sticky ? reCopy : re, strCopy);

        if (sticky) {
          if (match) {
            match.input = stringSlice$7(match.input, charsAdded);
            match[0] = stringSlice$7(match[0], charsAdded);
            match.index = re.lastIndex;
            re.lastIndex += match[0].length;
          } else re.lastIndex = 0;
        } else if (UPDATES_LAST_INDEX_WRONG && match) {
          re.lastIndex = re.global ? match.index + match[0].length : lastIndex;
        }
        if (NPCG_INCLUDED && match && match.length > 1) {
          // Fix browsers whose `exec` methods don't consistently return `undefined`
          // for NPCG, like IE8. NOTE: This doesn't work for /(.?)?/
          call$l(nativeReplace, match[0], reCopy, function () {
            for (i = 1; i < arguments.length - 2; i++) {
              if (arguments[i] === undefined) match[i] = undefined;
            }
          });
        }

        if (match && groups) {
          match.groups = object = create$3(null);
          for (i = 0; i < groups.length; i++) {
            group = groups[i];
            object[group[0]] = match[group[1]];
          }
        }

        return match;
      };
    }

    var regexpExec$3 = patchedExec;

    var $$I = _export;
    var exec$3 = regexpExec$3;

    // `RegExp.prototype.exec` method
    // https://tc39.es/ecma262/#sec-regexp.prototype.exec
    $$I({ target: 'RegExp', proto: true, forced: /./.exec !== exec$3 }, {
      exec: exec$3
    });

    var NATIVE_BIND = functionBindNative;

    var FunctionPrototype$1 = Function.prototype;
    var apply$4 = FunctionPrototype$1.apply;
    var call$k = FunctionPrototype$1.call;

    // eslint-disable-next-line es-x/no-reflect -- safe
    var functionApply = typeof Reflect == 'object' && Reflect.apply || (NATIVE_BIND ? call$k.bind(apply$4) : function () {
      return call$k.apply(apply$4, arguments);
    });

    // TODO: Remove from `core-js@4` since it's moved to entry points

    var uncurryThis$o = functionUncurryThis;
    var defineBuiltIn$b = defineBuiltIn$e;
    var regexpExec$2 = regexpExec$3;
    var fails$q = fails$F;
    var wellKnownSymbol$l = wellKnownSymbol$q;
    var createNonEnumerableProperty$3 = createNonEnumerableProperty$7;

    var SPECIES$5 = wellKnownSymbol$l('species');
    var RegExpPrototype$3 = RegExp.prototype;

    var fixRegexpWellKnownSymbolLogic = function (KEY, exec, FORCED, SHAM) {
      var SYMBOL = wellKnownSymbol$l(KEY);

      var DELEGATES_TO_SYMBOL = !fails$q(function () {
        // String methods call symbol-named RegEp methods
        var O = {};
        O[SYMBOL] = function () { return 7; };
        return ''[KEY](O) != 7;
      });

      var DELEGATES_TO_EXEC = DELEGATES_TO_SYMBOL && !fails$q(function () {
        // Symbol-named RegExp methods call .exec
        var execCalled = false;
        var re = /a/;

        if (KEY === 'split') {
          // We can't use real regex here since it causes deoptimization
          // and serious performance degradation in V8
          // https://github.com/zloirock/core-js/issues/306
          re = {};
          // RegExp[@@split] doesn't call the regex's exec method, but first creates
          // a new one. We need to return the patched regex when creating the new one.
          re.constructor = {};
          re.constructor[SPECIES$5] = function () { return re; };
          re.flags = '';
          re[SYMBOL] = /./[SYMBOL];
        }

        re.exec = function () { execCalled = true; return null; };

        re[SYMBOL]('');
        return !execCalled;
      });

      if (
        !DELEGATES_TO_SYMBOL ||
        !DELEGATES_TO_EXEC ||
        FORCED
      ) {
        var uncurriedNativeRegExpMethod = uncurryThis$o(/./[SYMBOL]);
        var methods = exec(SYMBOL, ''[KEY], function (nativeMethod, regexp, str, arg2, forceStringMethod) {
          var uncurriedNativeMethod = uncurryThis$o(nativeMethod);
          var $exec = regexp.exec;
          if ($exec === regexpExec$2 || $exec === RegExpPrototype$3.exec) {
            if (DELEGATES_TO_SYMBOL && !forceStringMethod) {
              // The native String method already delegates to @@method (this
              // polyfilled function), leasing to infinite recursion.
              // We avoid it by directly calling the native @@method method.
              return { done: true, value: uncurriedNativeRegExpMethod(regexp, str, arg2) };
            }
            return { done: true, value: uncurriedNativeMethod(str, regexp, arg2) };
          }
          return { done: false };
        });

        defineBuiltIn$b(String.prototype, KEY, methods[0]);
        defineBuiltIn$b(RegExpPrototype$3, SYMBOL, methods[1]);
      }

      if (SHAM) createNonEnumerableProperty$3(RegExpPrototype$3[SYMBOL], 'sham', true);
    };

    var isObject$g = isObject$n;
    var classof$5 = classofRaw$1;
    var wellKnownSymbol$k = wellKnownSymbol$q;

    var MATCH$2 = wellKnownSymbol$k('match');

    // `IsRegExp` abstract operation
    // https://tc39.es/ecma262/#sec-isregexp
    var isRegexp = function (it) {
      var isRegExp;
      return isObject$g(it) && ((isRegExp = it[MATCH$2]) !== undefined ? !!isRegExp : classof$5(it) == 'RegExp');
    };

    var isConstructor$2 = isConstructor$4;
    var tryToString$4 = tryToString$6;

    var $TypeError$9 = TypeError;

    // `Assert: IsConstructor(argument) is true`
    var aConstructor$1 = function (argument) {
      if (isConstructor$2(argument)) return argument;
      throw $TypeError$9(tryToString$4(argument) + ' is not a constructor');
    };

    var anObject$i = anObject$o;
    var aConstructor = aConstructor$1;
    var wellKnownSymbol$j = wellKnownSymbol$q;

    var SPECIES$4 = wellKnownSymbol$j('species');

    // `SpeciesConstructor` abstract operation
    // https://tc39.es/ecma262/#sec-speciesconstructor
    var speciesConstructor$2 = function (O, defaultConstructor) {
      var C = anObject$i(O).constructor;
      var S;
      return C === undefined || (S = anObject$i(C)[SPECIES$4]) == undefined ? defaultConstructor : aConstructor(S);
    };

    var uncurryThis$n = functionUncurryThis;
    var toIntegerOrInfinity$3 = toIntegerOrInfinity$6;
    var toString$e = toString$g;
    var requireObjectCoercible$9 = requireObjectCoercible$c;

    var charAt$5 = uncurryThis$n(''.charAt);
    var charCodeAt$2 = uncurryThis$n(''.charCodeAt);
    var stringSlice$6 = uncurryThis$n(''.slice);

    var createMethod$1 = function (CONVERT_TO_STRING) {
      return function ($this, pos) {
        var S = toString$e(requireObjectCoercible$9($this));
        var position = toIntegerOrInfinity$3(pos);
        var size = S.length;
        var first, second;
        if (position < 0 || position >= size) return CONVERT_TO_STRING ? '' : undefined;
        first = charCodeAt$2(S, position);
        return first < 0xD800 || first > 0xDBFF || position + 1 === size
          || (second = charCodeAt$2(S, position + 1)) < 0xDC00 || second > 0xDFFF
            ? CONVERT_TO_STRING
              ? charAt$5(S, position)
              : first
            : CONVERT_TO_STRING
              ? stringSlice$6(S, position, position + 2)
              : (first - 0xD800 << 10) + (second - 0xDC00) + 0x10000;
      };
    };

    var stringMultibyte = {
      // `String.prototype.codePointAt` method
      // https://tc39.es/ecma262/#sec-string.prototype.codepointat
      codeAt: createMethod$1(false),
      // `String.prototype.at` method
      // https://github.com/mathiasbynens/String.prototype.at
      charAt: createMethod$1(true)
    };

    var charAt$4 = stringMultibyte.charAt;

    // `AdvanceStringIndex` abstract operation
    // https://tc39.es/ecma262/#sec-advancestringindex
    var advanceStringIndex$3 = function (S, index, unicode) {
      return index + (unicode ? charAt$4(S, index).length : 1);
    };

    var toPropertyKey$2 = toPropertyKey$5;
    var definePropertyModule$4 = objectDefineProperty;
    var createPropertyDescriptor$3 = createPropertyDescriptor$6;

    var createProperty$5 = function (object, key, value) {
      var propertyKey = toPropertyKey$2(key);
      if (propertyKey in object) definePropertyModule$4.f(object, propertyKey, createPropertyDescriptor$3(0, value));
      else object[propertyKey] = value;
    };

    var toAbsoluteIndex$2 = toAbsoluteIndex$4;
    var lengthOfArrayLike$6 = lengthOfArrayLike$9;
    var createProperty$4 = createProperty$5;

    var $Array$2 = Array;
    var max$3 = Math.max;

    var arraySliceSimple = function (O, start, end) {
      var length = lengthOfArrayLike$6(O);
      var k = toAbsoluteIndex$2(start, length);
      var fin = toAbsoluteIndex$2(end === undefined ? length : end, length);
      var result = $Array$2(max$3(fin - k, 0));
      for (var n = 0; k < fin; k++, n++) createProperty$4(result, n, O[k]);
      result.length = n;
      return result;
    };

    var call$j = functionCall;
    var anObject$h = anObject$o;
    var isCallable$d = isCallable$q;
    var classof$4 = classofRaw$1;
    var regexpExec$1 = regexpExec$3;

    var $TypeError$8 = TypeError;

    // `RegExpExec` abstract operation
    // https://tc39.es/ecma262/#sec-regexpexec
    var regexpExecAbstract = function (R, S) {
      var exec = R.exec;
      if (isCallable$d(exec)) {
        var result = call$j(exec, R, S);
        if (result !== null) anObject$h(result);
        return result;
      }
      if (classof$4(R) === 'RegExp') return call$j(regexpExec$1, R, S);
      throw $TypeError$8('RegExp#exec called on incompatible receiver');
    };

    var apply$3 = functionApply;
    var call$i = functionCall;
    var uncurryThis$m = functionUncurryThis;
    var fixRegExpWellKnownSymbolLogic$2 = fixRegexpWellKnownSymbolLogic;
    var isRegExp$2 = isRegexp;
    var anObject$g = anObject$o;
    var requireObjectCoercible$8 = requireObjectCoercible$c;
    var speciesConstructor$1 = speciesConstructor$2;
    var advanceStringIndex$2 = advanceStringIndex$3;
    var toLength$4 = toLength$6;
    var toString$d = toString$g;
    var getMethod$4 = getMethod$6;
    var arraySlice$6 = arraySliceSimple;
    var callRegExpExec = regexpExecAbstract;
    var regexpExec = regexpExec$3;
    var stickyHelpers$1 = regexpStickyHelpers;
    var fails$p = fails$F;

    var UNSUPPORTED_Y$1 = stickyHelpers$1.UNSUPPORTED_Y;
    var MAX_UINT32 = 0xFFFFFFFF;
    var min$4 = Math.min;
    var $push = [].push;
    var exec$2 = uncurryThis$m(/./.exec);
    var push$3 = uncurryThis$m($push);
    var stringSlice$5 = uncurryThis$m(''.slice);

    // Chrome 51 has a buggy "split" implementation when RegExp#exec !== nativeExec
    // Weex JS has frozen built-in prototypes, so use try / catch wrapper
    var SPLIT_WORKS_WITH_OVERWRITTEN_EXEC = !fails$p(function () {
      // eslint-disable-next-line regexp/no-empty-group -- required for testing
      var re = /(?:)/;
      var originalExec = re.exec;
      re.exec = function () { return originalExec.apply(this, arguments); };
      var result = 'ab'.split(re);
      return result.length !== 2 || result[0] !== 'a' || result[1] !== 'b';
    });

    // @@split logic
    fixRegExpWellKnownSymbolLogic$2('split', function (SPLIT, nativeSplit, maybeCallNative) {
      var internalSplit;
      if (
        'abbc'.split(/(b)*/)[1] == 'c' ||
        // eslint-disable-next-line regexp/no-empty-group -- required for testing
        'test'.split(/(?:)/, -1).length != 4 ||
        'ab'.split(/(?:ab)*/).length != 2 ||
        '.'.split(/(.?)(.?)/).length != 4 ||
        // eslint-disable-next-line regexp/no-empty-capturing-group, regexp/no-empty-group -- required for testing
        '.'.split(/()()/).length > 1 ||
        ''.split(/.?/).length
      ) {
        // based on es5-shim implementation, need to rework it
        internalSplit = function (separator, limit) {
          var string = toString$d(requireObjectCoercible$8(this));
          var lim = limit === undefined ? MAX_UINT32 : limit >>> 0;
          if (lim === 0) return [];
          if (separator === undefined) return [string];
          // If `separator` is not a regex, use native split
          if (!isRegExp$2(separator)) {
            return call$i(nativeSplit, string, separator, lim);
          }
          var output = [];
          var flags = (separator.ignoreCase ? 'i' : '') +
                      (separator.multiline ? 'm' : '') +
                      (separator.unicode ? 'u' : '') +
                      (separator.sticky ? 'y' : '');
          var lastLastIndex = 0;
          // Make `global` and avoid `lastIndex` issues by working with a copy
          var separatorCopy = new RegExp(separator.source, flags + 'g');
          var match, lastIndex, lastLength;
          while (match = call$i(regexpExec, separatorCopy, string)) {
            lastIndex = separatorCopy.lastIndex;
            if (lastIndex > lastLastIndex) {
              push$3(output, stringSlice$5(string, lastLastIndex, match.index));
              if (match.length > 1 && match.index < string.length) apply$3($push, output, arraySlice$6(match, 1));
              lastLength = match[0].length;
              lastLastIndex = lastIndex;
              if (output.length >= lim) break;
            }
            if (separatorCopy.lastIndex === match.index) separatorCopy.lastIndex++; // Avoid an infinite loop
          }
          if (lastLastIndex === string.length) {
            if (lastLength || !exec$2(separatorCopy, '')) push$3(output, '');
          } else push$3(output, stringSlice$5(string, lastLastIndex));
          return output.length > lim ? arraySlice$6(output, 0, lim) : output;
        };
      // Chakra, V8
      } else if ('0'.split(undefined, 0).length) {
        internalSplit = function (separator, limit) {
          return separator === undefined && limit === 0 ? [] : call$i(nativeSplit, this, separator, limit);
        };
      } else internalSplit = nativeSplit;

      return [
        // `String.prototype.split` method
        // https://tc39.es/ecma262/#sec-string.prototype.split
        function split(separator, limit) {
          var O = requireObjectCoercible$8(this);
          var splitter = separator == undefined ? undefined : getMethod$4(separator, SPLIT);
          return splitter
            ? call$i(splitter, separator, O, limit)
            : call$i(internalSplit, toString$d(O), separator, limit);
        },
        // `RegExp.prototype[@@split]` method
        // https://tc39.es/ecma262/#sec-regexp.prototype-@@split
        //
        // NOTE: This cannot be properly polyfilled in engines that don't support
        // the 'y' flag.
        function (string, limit) {
          var rx = anObject$g(this);
          var S = toString$d(string);
          var res = maybeCallNative(internalSplit, rx, S, limit, internalSplit !== nativeSplit);

          if (res.done) return res.value;

          var C = speciesConstructor$1(rx, RegExp);

          var unicodeMatching = rx.unicode;
          var flags = (rx.ignoreCase ? 'i' : '') +
                      (rx.multiline ? 'm' : '') +
                      (rx.unicode ? 'u' : '') +
                      (UNSUPPORTED_Y$1 ? 'g' : 'y');

          // ^(? + rx + ) is needed, in combination with some S slicing, to
          // simulate the 'y' flag.
          var splitter = new C(UNSUPPORTED_Y$1 ? '^(?:' + rx.source + ')' : rx, flags);
          var lim = limit === undefined ? MAX_UINT32 : limit >>> 0;
          if (lim === 0) return [];
          if (S.length === 0) return callRegExpExec(splitter, S) === null ? [S] : [];
          var p = 0;
          var q = 0;
          var A = [];
          while (q < S.length) {
            splitter.lastIndex = UNSUPPORTED_Y$1 ? 0 : q;
            var z = callRegExpExec(splitter, UNSUPPORTED_Y$1 ? stringSlice$5(S, q) : S);
            var e;
            if (
              z === null ||
              (e = min$4(toLength$4(splitter.lastIndex + (UNSUPPORTED_Y$1 ? q : 0)), S.length)) === p
            ) {
              q = advanceStringIndex$2(S, q, unicodeMatching);
            } else {
              push$3(A, stringSlice$5(S, p, q));
              if (A.length === lim) return A;
              for (var i = 1; i <= z.length - 1; i++) {
                push$3(A, z[i]);
                if (A.length === lim) return A;
              }
              q = p = e;
            }
          }
          push$3(A, stringSlice$5(S, p));
          return A;
        }
      ];
    }, !SPLIT_WORKS_WITH_OVERWRITTEN_EXEC, UNSUPPORTED_Y$1);

    var $TypeError$7 = TypeError;
    var MAX_SAFE_INTEGER = 0x1FFFFFFFFFFFFF; // 2 ** 53 - 1 == 9007199254740991

    var doesNotExceedSafeInteger$2 = function (it) {
      if (it > MAX_SAFE_INTEGER) throw $TypeError$7('Maximum allowed index exceeded');
      return it;
    };

    var fails$o = fails$F;
    var wellKnownSymbol$i = wellKnownSymbol$q;
    var V8_VERSION$2 = engineV8Version;

    var SPECIES$3 = wellKnownSymbol$i('species');

    var arrayMethodHasSpeciesSupport$5 = function (METHOD_NAME) {
      // We can't use this feature detection in V8 since it causes
      // deoptimization and serious performance degradation
      // https://github.com/zloirock/core-js/issues/677
      return V8_VERSION$2 >= 51 || !fails$o(function () {
        var array = [];
        var constructor = array.constructor = {};
        constructor[SPECIES$3] = function () {
          return { foo: 1 };
        };
        return array[METHOD_NAME](Boolean).foo !== 1;
      });
    };

    var $$H = _export;
    var fails$n = fails$F;
    var isArray$3 = isArray$5;
    var isObject$f = isObject$n;
    var toObject$7 = toObject$b;
    var lengthOfArrayLike$5 = lengthOfArrayLike$9;
    var doesNotExceedSafeInteger$1 = doesNotExceedSafeInteger$2;
    var createProperty$3 = createProperty$5;
    var arraySpeciesCreate$1 = arraySpeciesCreate$3;
    var arrayMethodHasSpeciesSupport$4 = arrayMethodHasSpeciesSupport$5;
    var wellKnownSymbol$h = wellKnownSymbol$q;
    var V8_VERSION$1 = engineV8Version;

    var IS_CONCAT_SPREADABLE = wellKnownSymbol$h('isConcatSpreadable');

    // We can't use this feature detection in V8 since it causes
    // deoptimization and serious performance degradation
    // https://github.com/zloirock/core-js/issues/679
    var IS_CONCAT_SPREADABLE_SUPPORT = V8_VERSION$1 >= 51 || !fails$n(function () {
      var array = [];
      array[IS_CONCAT_SPREADABLE] = false;
      return array.concat()[0] !== array;
    });

    var SPECIES_SUPPORT = arrayMethodHasSpeciesSupport$4('concat');

    var isConcatSpreadable = function (O) {
      if (!isObject$f(O)) return false;
      var spreadable = O[IS_CONCAT_SPREADABLE];
      return spreadable !== undefined ? !!spreadable : isArray$3(O);
    };

    var FORCED$2 = !IS_CONCAT_SPREADABLE_SUPPORT || !SPECIES_SUPPORT;

    // `Array.prototype.concat` method
    // https://tc39.es/ecma262/#sec-array.prototype.concat
    // with adding support of @@isConcatSpreadable and @@species
    $$H({ target: 'Array', proto: true, arity: 1, forced: FORCED$2 }, {
      // eslint-disable-next-line no-unused-vars -- required for `.length`
      concat: function concat(arg) {
        var O = toObject$7(this);
        var A = arraySpeciesCreate$1(O, 0);
        var n = 0;
        var i, k, length, len, E;
        for (i = -1, length = arguments.length; i < length; i++) {
          E = i === -1 ? O : arguments[i];
          if (isConcatSpreadable(E)) {
            len = lengthOfArrayLike$5(E);
            doesNotExceedSafeInteger$1(n + len);
            for (k = 0; k < len; k++, n++) if (k in E) createProperty$3(A, n, E[k]);
          } else {
            doesNotExceedSafeInteger$1(n + 1);
            createProperty$3(A, n++, E);
          }
        }
        A.length = n;
        return A;
      }
    });

    var isRegExp$1 = isRegexp;

    var $TypeError$6 = TypeError;

    var notARegexp = function (it) {
      if (isRegExp$1(it)) {
        throw $TypeError$6("The method doesn't accept regular expressions");
      } return it;
    };

    var wellKnownSymbol$g = wellKnownSymbol$q;

    var MATCH$1 = wellKnownSymbol$g('match');

    var correctIsRegexpLogic = function (METHOD_NAME) {
      var regexp = /./;
      try {
        '/./'[METHOD_NAME](regexp);
      } catch (error1) {
        try {
          regexp[MATCH$1] = false;
          return '/./'[METHOD_NAME](regexp);
        } catch (error2) { /* empty */ }
      } return false;
    };

    var $$G = _export;
    var uncurryThis$l = functionUncurryThis;
    var getOwnPropertyDescriptor$4 = objectGetOwnPropertyDescriptor.f;
    var toLength$3 = toLength$6;
    var toString$c = toString$g;
    var notARegExp$2 = notARegexp;
    var requireObjectCoercible$7 = requireObjectCoercible$c;
    var correctIsRegExpLogic$2 = correctIsRegexpLogic;

    // eslint-disable-next-line es-x/no-string-prototype-endswith -- safe
    var un$EndsWith = uncurryThis$l(''.endsWith);
    var slice = uncurryThis$l(''.slice);
    var min$3 = Math.min;

    var CORRECT_IS_REGEXP_LOGIC$1 = correctIsRegExpLogic$2('endsWith');
    // https://github.com/zloirock/core-js/pull/702
    var MDN_POLYFILL_BUG$1 = !CORRECT_IS_REGEXP_LOGIC$1 && !!function () {
      var descriptor = getOwnPropertyDescriptor$4(String.prototype, 'endsWith');
      return descriptor && !descriptor.writable;
    }();

    // `String.prototype.endsWith` method
    // https://tc39.es/ecma262/#sec-string.prototype.endswith
    $$G({ target: 'String', proto: true, forced: !MDN_POLYFILL_BUG$1 && !CORRECT_IS_REGEXP_LOGIC$1 }, {
      endsWith: function endsWith(searchString /* , endPosition = @length */) {
        var that = toString$c(requireObjectCoercible$7(this));
        notARegExp$2(searchString);
        var endPosition = arguments.length > 1 ? arguments[1] : undefined;
        var len = that.length;
        var end = endPosition === undefined ? len : min$3(toLength$3(endPosition), len);
        var search = toString$c(searchString);
        return un$EndsWith
          ? un$EndsWith(that, search, end)
          : slice(that, end - search.length, end) === search;
      }
    });

    var $$F = _export;
    var uncurryThis$k = functionUncurryThis;
    var getOwnPropertyDescriptor$3 = objectGetOwnPropertyDescriptor.f;
    var toLength$2 = toLength$6;
    var toString$b = toString$g;
    var notARegExp$1 = notARegexp;
    var requireObjectCoercible$6 = requireObjectCoercible$c;
    var correctIsRegExpLogic$1 = correctIsRegexpLogic;

    // eslint-disable-next-line es-x/no-string-prototype-startswith -- safe
    var un$StartsWith = uncurryThis$k(''.startsWith);
    var stringSlice$4 = uncurryThis$k(''.slice);
    var min$2 = Math.min;

    var CORRECT_IS_REGEXP_LOGIC = correctIsRegExpLogic$1('startsWith');
    // https://github.com/zloirock/core-js/pull/702
    var MDN_POLYFILL_BUG = !CORRECT_IS_REGEXP_LOGIC && !!function () {
      var descriptor = getOwnPropertyDescriptor$3(String.prototype, 'startsWith');
      return descriptor && !descriptor.writable;
    }();

    // `String.prototype.startsWith` method
    // https://tc39.es/ecma262/#sec-string.prototype.startswith
    $$F({ target: 'String', proto: true, forced: !MDN_POLYFILL_BUG && !CORRECT_IS_REGEXP_LOGIC }, {
      startsWith: function startsWith(searchString /* , position = 0 */) {
        var that = toString$b(requireObjectCoercible$6(this));
        notARegExp$1(searchString);
        var index = toLength$2(min$2(arguments.length > 1 ? arguments[1] : undefined, that.length));
        var search = toString$b(searchString);
        return un$StartsWith
          ? un$StartsWith(that, search, index)
          : stringSlice$4(that, index, index + search.length) === search;
      }
    });

    var wellKnownSymbol$f = wellKnownSymbol$q;
    var create$2 = objectCreate;
    var defineProperty$a = objectDefineProperty.f;

    var UNSCOPABLES = wellKnownSymbol$f('unscopables');
    var ArrayPrototype$1 = Array.prototype;

    // Array.prototype[@@unscopables]
    // https://tc39.es/ecma262/#sec-array.prototype-@@unscopables
    if (ArrayPrototype$1[UNSCOPABLES] == undefined) {
      defineProperty$a(ArrayPrototype$1, UNSCOPABLES, {
        configurable: true,
        value: create$2(null)
      });
    }

    // add a key to Array.prototype[@@unscopables]
    var addToUnscopables$3 = function (key) {
      ArrayPrototype$1[UNSCOPABLES][key] = true;
    };

    var $$E = _export;
    var $includes = arrayIncludes.includes;
    var fails$m = fails$F;
    var addToUnscopables$2 = addToUnscopables$3;

    // FF99+ bug
    var BROKEN_ON_SPARSE = fails$m(function () {
      return !Array(1).includes();
    });

    // `Array.prototype.includes` method
    // https://tc39.es/ecma262/#sec-array.prototype.includes
    $$E({ target: 'Array', proto: true, forced: BROKEN_ON_SPARSE }, {
      includes: function includes(el /* , fromIndex = 0 */) {
        return $includes(this, el, arguments.length > 1 ? arguments[1] : undefined);
      }
    });

    // https://tc39.es/ecma262/#sec-array.prototype-@@unscopables
    addToUnscopables$2('includes');

    var REQUEST_HEADERS = {
      form: {
        'Content-Type': 'application/x-www-form-urlencoded'
      },
      json: {
        'Content-Type': 'application/json;charset=utf-8'
      }
    };
    function defineApi(options) {
      return options;
    }

    function formatRequestPath(params, strings, keys) {
      var result = [strings[0]];
      keys.forEach(function (key, i) {
        var value = typeof key === 'function' ? key(params) : params[key];
        result.push(value, strings[i + 1]);
      });
      return result.join('');
    }

    function typedUrl(configOrStrings) {
      for (var _len = arguments.length, keys = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
        keys[_key - 1] = arguments[_key];
      }

      // withConfig
      if (!Array.isArray(configOrStrings)) {
        return function (strings) {
          for (var _len2 = arguments.length, innerKeys = new Array(_len2 > 1 ? _len2 - 1 : 0), _key2 = 1; _key2 < _len2; _key2++) {
            innerKeys[_key2 - 1] = arguments[_key2];
          }

          return function (params) {
            return [configOrStrings, formatRequestPath(params, strings, innerKeys)];
          };
        };
      } else {
        return function (params) {
          return formatRequestPath(params, configOrStrings, keys);
        };
      }
    }
    function registApi(client, apis, prefix) {
      var result = {};
      Object.keys(apis).forEach(function (methodName) {
        var methodUrl = apis[methodName];
        result[methodName] = transfromToRequest(client, methodUrl, prefix);
      });
      return result;
    }

    function transfromToRequest(request, methodUrl) {
      var prefix = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : '';
      return function () {
        var config = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
        var _config$requestType = config.requestType,
            requestType = _config$requestType === void 0 ? 'json' : _config$requestType;
        var methodInfo = methodUrl;

        if (typeof methodUrl === 'function') {
          methodInfo = methodUrl(config.params);
        }

        var reqConfig = config;

        if (Array.isArray(methodInfo)) {
          var _methodInfo = methodInfo,
              _methodInfo2 = _slicedToArray(_methodInfo, 2),
              cusConfig = _methodInfo2[0],
              methodPath = _methodInfo2[1];

          reqConfig = _objectSpread2(_objectSpread2({}, reqConfig), cusConfig);
          methodInfo = methodPath;
        } // 获取 方法 和 地址


        var arrMethodInfo = methodInfo.split(' ');

        var _ref = arrMethodInfo.length === 1 ? ['get', methodInfo] : arrMethodInfo,
            _ref2 = _slicedToArray(_ref, 2),
            method = _ref2[0],
            urlPath = _ref2[1];

        var url = "".concat(prefix).concat(prefix.endsWith('/') ? '' : '/').concat(urlPath.startsWith('/') ? urlPath.substring(1) : urlPath);
        reqConfig.method = method; // getLike 请求把data 参数当成 params 传递

        var isGetLike = ['get', 'delete', 'head', 'options'].includes(method);
        reqConfig.params = isGetLike ? _objectSpread2(_objectSpread2({}, reqConfig.data), reqConfig.params) : reqConfig.params;
        reqConfig.headers = _objectSpread2(_objectSpread2({}, REQUEST_HEADERS[requestType] || {}), reqConfig.headers || {});
        return request(url, reqConfig);
      };
    }

    var objectGetOwnPropertyNamesExternal = {};

    var classof$3 = classofRaw$1;
    var toIndexedObject$3 = toIndexedObject$9;
    var $getOwnPropertyNames$1 = objectGetOwnPropertyNames.f;
    var arraySlice$5 = arraySliceSimple;

    var windowNames = typeof window == 'object' && window && Object.getOwnPropertyNames
      ? Object.getOwnPropertyNames(window) : [];

    var getWindowNames = function (it) {
      try {
        return $getOwnPropertyNames$1(it);
      } catch (error) {
        return arraySlice$5(windowNames);
      }
    };

    // fallback for IE11 buggy Object.getOwnPropertyNames with iframe and window
    objectGetOwnPropertyNamesExternal.f = function getOwnPropertyNames(it) {
      return windowNames && classof$3(it) == 'Window'
        ? getWindowNames(it)
        : $getOwnPropertyNames$1(toIndexedObject$3(it));
    };

    var wellKnownSymbolWrapped = {};

    var wellKnownSymbol$e = wellKnownSymbol$q;

    wellKnownSymbolWrapped.f = wellKnownSymbol$e;

    var global$i = global$w;

    var path$1 = global$i;

    var path = path$1;
    var hasOwn$e = hasOwnProperty_1;
    var wrappedWellKnownSymbolModule$1 = wellKnownSymbolWrapped;
    var defineProperty$9 = objectDefineProperty.f;

    var defineWellKnownSymbol$4 = function (NAME) {
      var Symbol = path.Symbol || (path.Symbol = {});
      if (!hasOwn$e(Symbol, NAME)) defineProperty$9(Symbol, NAME, {
        value: wrappedWellKnownSymbolModule$1.f(NAME)
      });
    };

    var call$h = functionCall;
    var getBuiltIn$6 = getBuiltIn$c;
    var wellKnownSymbol$d = wellKnownSymbol$q;
    var defineBuiltIn$a = defineBuiltIn$e;

    var symbolDefineToPrimitive = function () {
      var Symbol = getBuiltIn$6('Symbol');
      var SymbolPrototype = Symbol && Symbol.prototype;
      var valueOf = SymbolPrototype && SymbolPrototype.valueOf;
      var TO_PRIMITIVE = wellKnownSymbol$d('toPrimitive');

      if (SymbolPrototype && !SymbolPrototype[TO_PRIMITIVE]) {
        // `Symbol.prototype[@@toPrimitive]` method
        // https://tc39.es/ecma262/#sec-symbol.prototype-@@toprimitive
        // eslint-disable-next-line no-unused-vars -- required for .length
        defineBuiltIn$a(SymbolPrototype, TO_PRIMITIVE, function (hint) {
          return call$h(valueOf, this);
        }, { arity: 1 });
      }
    };

    var defineProperty$8 = objectDefineProperty.f;
    var hasOwn$d = hasOwnProperty_1;
    var wellKnownSymbol$c = wellKnownSymbol$q;

    var TO_STRING_TAG$1 = wellKnownSymbol$c('toStringTag');

    var setToStringTag$8 = function (target, TAG, STATIC) {
      if (target && !STATIC) target = target.prototype;
      if (target && !hasOwn$d(target, TO_STRING_TAG$1)) {
        defineProperty$8(target, TO_STRING_TAG$1, { configurable: true, value: TAG });
      }
    };

    var $$D = _export;
    var global$h = global$w;
    var call$g = functionCall;
    var uncurryThis$j = functionUncurryThis;
    var DESCRIPTORS$9 = descriptors;
    var NATIVE_SYMBOL$4 = nativeSymbol;
    var fails$l = fails$F;
    var hasOwn$c = hasOwnProperty_1;
    var isPrototypeOf$6 = objectIsPrototypeOf;
    var anObject$f = anObject$o;
    var toIndexedObject$2 = toIndexedObject$9;
    var toPropertyKey$1 = toPropertyKey$5;
    var $toString$1 = toString$g;
    var createPropertyDescriptor$2 = createPropertyDescriptor$6;
    var nativeObjectCreate = objectCreate;
    var objectKeys$1 = objectKeys$3;
    var getOwnPropertyNamesModule$1 = objectGetOwnPropertyNames;
    var getOwnPropertyNamesExternal = objectGetOwnPropertyNamesExternal;
    var getOwnPropertySymbolsModule$2 = objectGetOwnPropertySymbols;
    var getOwnPropertyDescriptorModule$2 = objectGetOwnPropertyDescriptor;
    var definePropertyModule$3 = objectDefineProperty;
    var definePropertiesModule = objectDefineProperties;
    var propertyIsEnumerableModule$1 = objectPropertyIsEnumerable;
    var defineBuiltIn$9 = defineBuiltIn$e;
    var shared$2 = shared$7.exports;
    var sharedKey$1 = sharedKey$4;
    var hiddenKeys$1 = hiddenKeys$6;
    var uid$1 = uid$4;
    var wellKnownSymbol$b = wellKnownSymbol$q;
    var wrappedWellKnownSymbolModule = wellKnownSymbolWrapped;
    var defineWellKnownSymbol$3 = defineWellKnownSymbol$4;
    var defineSymbolToPrimitive = symbolDefineToPrimitive;
    var setToStringTag$7 = setToStringTag$8;
    var InternalStateModule$5 = internalState;
    var $forEach = arrayIteration.forEach;

    var HIDDEN = sharedKey$1('hidden');
    var SYMBOL = 'Symbol';
    var PROTOTYPE = 'prototype';

    var setInternalState$5 = InternalStateModule$5.set;
    var getInternalState$2 = InternalStateModule$5.getterFor(SYMBOL);

    var ObjectPrototype$1 = Object[PROTOTYPE];
    var $Symbol = global$h.Symbol;
    var SymbolPrototype$1 = $Symbol && $Symbol[PROTOTYPE];
    var TypeError$3 = global$h.TypeError;
    var QObject = global$h.QObject;
    var nativeGetOwnPropertyDescriptor = getOwnPropertyDescriptorModule$2.f;
    var nativeDefineProperty = definePropertyModule$3.f;
    var nativeGetOwnPropertyNames = getOwnPropertyNamesExternal.f;
    var nativePropertyIsEnumerable = propertyIsEnumerableModule$1.f;
    var push$2 = uncurryThis$j([].push);

    var AllSymbols = shared$2('symbols');
    var ObjectPrototypeSymbols = shared$2('op-symbols');
    var WellKnownSymbolsStore = shared$2('wks');

    // Don't use setters in Qt Script, https://github.com/zloirock/core-js/issues/173
    var USE_SETTER = !QObject || !QObject[PROTOTYPE] || !QObject[PROTOTYPE].findChild;

    // fallback for old Android, https://code.google.com/p/v8/issues/detail?id=687
    var setSymbolDescriptor = DESCRIPTORS$9 && fails$l(function () {
      return nativeObjectCreate(nativeDefineProperty({}, 'a', {
        get: function () { return nativeDefineProperty(this, 'a', { value: 7 }).a; }
      })).a != 7;
    }) ? function (O, P, Attributes) {
      var ObjectPrototypeDescriptor = nativeGetOwnPropertyDescriptor(ObjectPrototype$1, P);
      if (ObjectPrototypeDescriptor) delete ObjectPrototype$1[P];
      nativeDefineProperty(O, P, Attributes);
      if (ObjectPrototypeDescriptor && O !== ObjectPrototype$1) {
        nativeDefineProperty(ObjectPrototype$1, P, ObjectPrototypeDescriptor);
      }
    } : nativeDefineProperty;

    var wrap = function (tag, description) {
      var symbol = AllSymbols[tag] = nativeObjectCreate(SymbolPrototype$1);
      setInternalState$5(symbol, {
        type: SYMBOL,
        tag: tag,
        description: description
      });
      if (!DESCRIPTORS$9) symbol.description = description;
      return symbol;
    };

    var $defineProperty = function defineProperty(O, P, Attributes) {
      if (O === ObjectPrototype$1) $defineProperty(ObjectPrototypeSymbols, P, Attributes);
      anObject$f(O);
      var key = toPropertyKey$1(P);
      anObject$f(Attributes);
      if (hasOwn$c(AllSymbols, key)) {
        if (!Attributes.enumerable) {
          if (!hasOwn$c(O, HIDDEN)) nativeDefineProperty(O, HIDDEN, createPropertyDescriptor$2(1, {}));
          O[HIDDEN][key] = true;
        } else {
          if (hasOwn$c(O, HIDDEN) && O[HIDDEN][key]) O[HIDDEN][key] = false;
          Attributes = nativeObjectCreate(Attributes, { enumerable: createPropertyDescriptor$2(0, false) });
        } return setSymbolDescriptor(O, key, Attributes);
      } return nativeDefineProperty(O, key, Attributes);
    };

    var $defineProperties = function defineProperties(O, Properties) {
      anObject$f(O);
      var properties = toIndexedObject$2(Properties);
      var keys = objectKeys$1(properties).concat($getOwnPropertySymbols(properties));
      $forEach(keys, function (key) {
        if (!DESCRIPTORS$9 || call$g($propertyIsEnumerable, properties, key)) $defineProperty(O, key, properties[key]);
      });
      return O;
    };

    var $create = function create(O, Properties) {
      return Properties === undefined ? nativeObjectCreate(O) : $defineProperties(nativeObjectCreate(O), Properties);
    };

    var $propertyIsEnumerable = function propertyIsEnumerable(V) {
      var P = toPropertyKey$1(V);
      var enumerable = call$g(nativePropertyIsEnumerable, this, P);
      if (this === ObjectPrototype$1 && hasOwn$c(AllSymbols, P) && !hasOwn$c(ObjectPrototypeSymbols, P)) return false;
      return enumerable || !hasOwn$c(this, P) || !hasOwn$c(AllSymbols, P) || hasOwn$c(this, HIDDEN) && this[HIDDEN][P]
        ? enumerable : true;
    };

    var $getOwnPropertyDescriptor = function getOwnPropertyDescriptor(O, P) {
      var it = toIndexedObject$2(O);
      var key = toPropertyKey$1(P);
      if (it === ObjectPrototype$1 && hasOwn$c(AllSymbols, key) && !hasOwn$c(ObjectPrototypeSymbols, key)) return;
      var descriptor = nativeGetOwnPropertyDescriptor(it, key);
      if (descriptor && hasOwn$c(AllSymbols, key) && !(hasOwn$c(it, HIDDEN) && it[HIDDEN][key])) {
        descriptor.enumerable = true;
      }
      return descriptor;
    };

    var $getOwnPropertyNames = function getOwnPropertyNames(O) {
      var names = nativeGetOwnPropertyNames(toIndexedObject$2(O));
      var result = [];
      $forEach(names, function (key) {
        if (!hasOwn$c(AllSymbols, key) && !hasOwn$c(hiddenKeys$1, key)) push$2(result, key);
      });
      return result;
    };

    var $getOwnPropertySymbols = function (O) {
      var IS_OBJECT_PROTOTYPE = O === ObjectPrototype$1;
      var names = nativeGetOwnPropertyNames(IS_OBJECT_PROTOTYPE ? ObjectPrototypeSymbols : toIndexedObject$2(O));
      var result = [];
      $forEach(names, function (key) {
        if (hasOwn$c(AllSymbols, key) && (!IS_OBJECT_PROTOTYPE || hasOwn$c(ObjectPrototype$1, key))) {
          push$2(result, AllSymbols[key]);
        }
      });
      return result;
    };

    // `Symbol` constructor
    // https://tc39.es/ecma262/#sec-symbol-constructor
    if (!NATIVE_SYMBOL$4) {
      $Symbol = function Symbol() {
        if (isPrototypeOf$6(SymbolPrototype$1, this)) throw TypeError$3('Symbol is not a constructor');
        var description = !arguments.length || arguments[0] === undefined ? undefined : $toString$1(arguments[0]);
        var tag = uid$1(description);
        var setter = function (value) {
          if (this === ObjectPrototype$1) call$g(setter, ObjectPrototypeSymbols, value);
          if (hasOwn$c(this, HIDDEN) && hasOwn$c(this[HIDDEN], tag)) this[HIDDEN][tag] = false;
          setSymbolDescriptor(this, tag, createPropertyDescriptor$2(1, value));
        };
        if (DESCRIPTORS$9 && USE_SETTER) setSymbolDescriptor(ObjectPrototype$1, tag, { configurable: true, set: setter });
        return wrap(tag, description);
      };

      SymbolPrototype$1 = $Symbol[PROTOTYPE];

      defineBuiltIn$9(SymbolPrototype$1, 'toString', function toString() {
        return getInternalState$2(this).tag;
      });

      defineBuiltIn$9($Symbol, 'withoutSetter', function (description) {
        return wrap(uid$1(description), description);
      });

      propertyIsEnumerableModule$1.f = $propertyIsEnumerable;
      definePropertyModule$3.f = $defineProperty;
      definePropertiesModule.f = $defineProperties;
      getOwnPropertyDescriptorModule$2.f = $getOwnPropertyDescriptor;
      getOwnPropertyNamesModule$1.f = getOwnPropertyNamesExternal.f = $getOwnPropertyNames;
      getOwnPropertySymbolsModule$2.f = $getOwnPropertySymbols;

      wrappedWellKnownSymbolModule.f = function (name) {
        return wrap(wellKnownSymbol$b(name), name);
      };

      if (DESCRIPTORS$9) {
        // https://github.com/tc39/proposal-Symbol-description
        nativeDefineProperty(SymbolPrototype$1, 'description', {
          configurable: true,
          get: function description() {
            return getInternalState$2(this).description;
          }
        });
        {
          defineBuiltIn$9(ObjectPrototype$1, 'propertyIsEnumerable', $propertyIsEnumerable, { unsafe: true });
        }
      }
    }

    $$D({ global: true, constructor: true, wrap: true, forced: !NATIVE_SYMBOL$4, sham: !NATIVE_SYMBOL$4 }, {
      Symbol: $Symbol
    });

    $forEach(objectKeys$1(WellKnownSymbolsStore), function (name) {
      defineWellKnownSymbol$3(name);
    });

    $$D({ target: SYMBOL, stat: true, forced: !NATIVE_SYMBOL$4 }, {
      useSetter: function () { USE_SETTER = true; },
      useSimple: function () { USE_SETTER = false; }
    });

    $$D({ target: 'Object', stat: true, forced: !NATIVE_SYMBOL$4, sham: !DESCRIPTORS$9 }, {
      // `Object.create` method
      // https://tc39.es/ecma262/#sec-object.create
      create: $create,
      // `Object.defineProperty` method
      // https://tc39.es/ecma262/#sec-object.defineproperty
      defineProperty: $defineProperty,
      // `Object.defineProperties` method
      // https://tc39.es/ecma262/#sec-object.defineproperties
      defineProperties: $defineProperties,
      // `Object.getOwnPropertyDescriptor` method
      // https://tc39.es/ecma262/#sec-object.getownpropertydescriptors
      getOwnPropertyDescriptor: $getOwnPropertyDescriptor
    });

    $$D({ target: 'Object', stat: true, forced: !NATIVE_SYMBOL$4 }, {
      // `Object.getOwnPropertyNames` method
      // https://tc39.es/ecma262/#sec-object.getownpropertynames
      getOwnPropertyNames: $getOwnPropertyNames
    });

    // `Symbol.prototype[@@toPrimitive]` method
    // https://tc39.es/ecma262/#sec-symbol.prototype-@@toprimitive
    defineSymbolToPrimitive();

    // `Symbol.prototype[@@toStringTag]` property
    // https://tc39.es/ecma262/#sec-symbol.prototype-@@tostringtag
    setToStringTag$7($Symbol, SYMBOL);

    hiddenKeys$1[HIDDEN] = true;

    var NATIVE_SYMBOL$3 = nativeSymbol;

    /* eslint-disable es-x/no-symbol -- safe */
    var nativeSymbolRegistry = NATIVE_SYMBOL$3 && !!Symbol['for'] && !!Symbol.keyFor;

    var $$C = _export;
    var getBuiltIn$5 = getBuiltIn$c;
    var hasOwn$b = hasOwnProperty_1;
    var toString$a = toString$g;
    var shared$1 = shared$7.exports;
    var NATIVE_SYMBOL_REGISTRY$1 = nativeSymbolRegistry;

    var StringToSymbolRegistry = shared$1('string-to-symbol-registry');
    var SymbolToStringRegistry$1 = shared$1('symbol-to-string-registry');

    // `Symbol.for` method
    // https://tc39.es/ecma262/#sec-symbol.for
    $$C({ target: 'Symbol', stat: true, forced: !NATIVE_SYMBOL_REGISTRY$1 }, {
      'for': function (key) {
        var string = toString$a(key);
        if (hasOwn$b(StringToSymbolRegistry, string)) return StringToSymbolRegistry[string];
        var symbol = getBuiltIn$5('Symbol')(string);
        StringToSymbolRegistry[string] = symbol;
        SymbolToStringRegistry$1[symbol] = string;
        return symbol;
      }
    });

    var $$B = _export;
    var hasOwn$a = hasOwnProperty_1;
    var isSymbol$3 = isSymbol$6;
    var tryToString$3 = tryToString$6;
    var shared = shared$7.exports;
    var NATIVE_SYMBOL_REGISTRY = nativeSymbolRegistry;

    var SymbolToStringRegistry = shared('symbol-to-string-registry');

    // `Symbol.keyFor` method
    // https://tc39.es/ecma262/#sec-symbol.keyfor
    $$B({ target: 'Symbol', stat: true, forced: !NATIVE_SYMBOL_REGISTRY }, {
      keyFor: function keyFor(sym) {
        if (!isSymbol$3(sym)) throw TypeError(tryToString$3(sym) + ' is not a symbol');
        if (hasOwn$a(SymbolToStringRegistry, sym)) return SymbolToStringRegistry[sym];
      }
    });

    var uncurryThis$i = functionUncurryThis;

    var arraySlice$4 = uncurryThis$i([].slice);

    var $$A = _export;
    var getBuiltIn$4 = getBuiltIn$c;
    var apply$2 = functionApply;
    var call$f = functionCall;
    var uncurryThis$h = functionUncurryThis;
    var fails$k = fails$F;
    var isArray$2 = isArray$5;
    var isCallable$c = isCallable$q;
    var isObject$e = isObject$n;
    var isSymbol$2 = isSymbol$6;
    var arraySlice$3 = arraySlice$4;
    var NATIVE_SYMBOL$2 = nativeSymbol;

    var $stringify = getBuiltIn$4('JSON', 'stringify');
    var exec$1 = uncurryThis$h(/./.exec);
    var charAt$3 = uncurryThis$h(''.charAt);
    var charCodeAt$1 = uncurryThis$h(''.charCodeAt);
    var replace$5 = uncurryThis$h(''.replace);
    var numberToString = uncurryThis$h(1.0.toString);

    var tester = /[\uD800-\uDFFF]/g;
    var low = /^[\uD800-\uDBFF]$/;
    var hi = /^[\uDC00-\uDFFF]$/;

    var WRONG_SYMBOLS_CONVERSION = !NATIVE_SYMBOL$2 || fails$k(function () {
      var symbol = getBuiltIn$4('Symbol')();
      // MS Edge converts symbol values to JSON as {}
      return $stringify([symbol]) != '[null]'
        // WebKit converts symbol values to JSON as null
        || $stringify({ a: symbol }) != '{}'
        // V8 throws on boxed symbols
        || $stringify(Object(symbol)) != '{}';
    });

    // https://github.com/tc39/proposal-well-formed-stringify
    var ILL_FORMED_UNICODE = fails$k(function () {
      return $stringify('\uDF06\uD834') !== '"\\udf06\\ud834"'
        || $stringify('\uDEAD') !== '"\\udead"';
    });

    var stringifyWithSymbolsFix = function (it, replacer) {
      var args = arraySlice$3(arguments);
      var $replacer = replacer;
      if (!isObject$e(replacer) && it === undefined || isSymbol$2(it)) return; // IE8 returns string on undefined
      if (!isArray$2(replacer)) replacer = function (key, value) {
        if (isCallable$c($replacer)) value = call$f($replacer, this, key, value);
        if (!isSymbol$2(value)) return value;
      };
      args[1] = replacer;
      return apply$2($stringify, null, args);
    };

    var fixIllFormed = function (match, offset, string) {
      var prev = charAt$3(string, offset - 1);
      var next = charAt$3(string, offset + 1);
      if ((exec$1(low, match) && !exec$1(hi, next)) || (exec$1(hi, match) && !exec$1(low, prev))) {
        return '\\u' + numberToString(charCodeAt$1(match, 0), 16);
      } return match;
    };

    if ($stringify) {
      // `JSON.stringify` method
      // https://tc39.es/ecma262/#sec-json.stringify
      $$A({ target: 'JSON', stat: true, arity: 3, forced: WRONG_SYMBOLS_CONVERSION || ILL_FORMED_UNICODE }, {
        // eslint-disable-next-line no-unused-vars -- required for `.length`
        stringify: function stringify(it, replacer, space) {
          var args = arraySlice$3(arguments);
          var result = apply$2(WRONG_SYMBOLS_CONVERSION ? stringifyWithSymbolsFix : $stringify, null, args);
          return ILL_FORMED_UNICODE && typeof result == 'string' ? replace$5(result, tester, fixIllFormed) : result;
        }
      });
    }

    var $$z = _export;
    var NATIVE_SYMBOL$1 = nativeSymbol;
    var fails$j = fails$F;
    var getOwnPropertySymbolsModule$1 = objectGetOwnPropertySymbols;
    var toObject$6 = toObject$b;

    // V8 ~ Chrome 38 and 39 `Object.getOwnPropertySymbols` fails on primitives
    // https://bugs.chromium.org/p/v8/issues/detail?id=3443
    var FORCED$1 = !NATIVE_SYMBOL$1 || fails$j(function () { getOwnPropertySymbolsModule$1.f(1); });

    // `Object.getOwnPropertySymbols` method
    // https://tc39.es/ecma262/#sec-object.getownpropertysymbols
    $$z({ target: 'Object', stat: true, forced: FORCED$1 }, {
      getOwnPropertySymbols: function getOwnPropertySymbols(it) {
        var $getOwnPropertySymbols = getOwnPropertySymbolsModule$1.f;
        return $getOwnPropertySymbols ? $getOwnPropertySymbols(toObject$6(it)) : [];
      }
    });

    var $$y = _export;
    var DESCRIPTORS$8 = descriptors;
    var global$g = global$w;
    var uncurryThis$g = functionUncurryThis;
    var hasOwn$9 = hasOwnProperty_1;
    var isCallable$b = isCallable$q;
    var isPrototypeOf$5 = objectIsPrototypeOf;
    var toString$9 = toString$g;
    var defineProperty$7 = objectDefineProperty.f;
    var copyConstructorProperties = copyConstructorProperties$2;

    var NativeSymbol = global$g.Symbol;
    var SymbolPrototype = NativeSymbol && NativeSymbol.prototype;

    if (DESCRIPTORS$8 && isCallable$b(NativeSymbol) && (!('description' in SymbolPrototype) ||
      // Safari 12 bug
      NativeSymbol().description !== undefined
    )) {
      var EmptyStringDescriptionStore = {};
      // wrap Symbol constructor for correct work with undefined description
      var SymbolWrapper = function Symbol() {
        var description = arguments.length < 1 || arguments[0] === undefined ? undefined : toString$9(arguments[0]);
        var result = isPrototypeOf$5(SymbolPrototype, this)
          ? new NativeSymbol(description)
          // in Edge 13, String(Symbol(undefined)) === 'Symbol(undefined)'
          : description === undefined ? NativeSymbol() : NativeSymbol(description);
        if (description === '') EmptyStringDescriptionStore[result] = true;
        return result;
      };

      copyConstructorProperties(SymbolWrapper, NativeSymbol);
      SymbolWrapper.prototype = SymbolPrototype;
      SymbolPrototype.constructor = SymbolWrapper;

      var NATIVE_SYMBOL = String(NativeSymbol('test')) == 'Symbol(test)';
      var symbolToString = uncurryThis$g(SymbolPrototype.toString);
      var symbolValueOf = uncurryThis$g(SymbolPrototype.valueOf);
      var regexp = /^Symbol\((.*)\)[^)]+$/;
      var replace$4 = uncurryThis$g(''.replace);
      var stringSlice$3 = uncurryThis$g(''.slice);

      defineProperty$7(SymbolPrototype, 'description', {
        configurable: true,
        get: function description() {
          var symbol = symbolValueOf(this);
          var string = symbolToString(symbol);
          if (hasOwn$9(EmptyStringDescriptionStore, symbol)) return '';
          var desc = NATIVE_SYMBOL ? stringSlice$3(string, 7, -1) : replace$4(string, regexp, '$1');
          return desc === '' ? undefined : desc;
        }
      });

      $$y({ global: true, constructor: true, forced: true }, {
        Symbol: SymbolWrapper
      });
    }

    var tryToString$2 = tryToString$6;

    var $TypeError$5 = TypeError;

    var deletePropertyOrThrow$2 = function (O, P) {
      if (!delete O[P]) throw $TypeError$5('Cannot delete property ' + tryToString$2(P) + ' of ' + tryToString$2(O));
    };

    var $$x = _export;
    var toObject$5 = toObject$b;
    var toAbsoluteIndex$1 = toAbsoluteIndex$4;
    var toIntegerOrInfinity$2 = toIntegerOrInfinity$6;
    var lengthOfArrayLike$4 = lengthOfArrayLike$9;
    var doesNotExceedSafeInteger = doesNotExceedSafeInteger$2;
    var arraySpeciesCreate = arraySpeciesCreate$3;
    var createProperty$2 = createProperty$5;
    var deletePropertyOrThrow$1 = deletePropertyOrThrow$2;
    var arrayMethodHasSpeciesSupport$3 = arrayMethodHasSpeciesSupport$5;

    var HAS_SPECIES_SUPPORT$3 = arrayMethodHasSpeciesSupport$3('splice');

    var max$2 = Math.max;
    var min$1 = Math.min;

    // `Array.prototype.splice` method
    // https://tc39.es/ecma262/#sec-array.prototype.splice
    // with adding support of @@species
    $$x({ target: 'Array', proto: true, forced: !HAS_SPECIES_SUPPORT$3 }, {
      splice: function splice(start, deleteCount /* , ...items */) {
        var O = toObject$5(this);
        var len = lengthOfArrayLike$4(O);
        var actualStart = toAbsoluteIndex$1(start, len);
        var argumentsLength = arguments.length;
        var insertCount, actualDeleteCount, A, k, from, to;
        if (argumentsLength === 0) {
          insertCount = actualDeleteCount = 0;
        } else if (argumentsLength === 1) {
          insertCount = 0;
          actualDeleteCount = len - actualStart;
        } else {
          insertCount = argumentsLength - 2;
          actualDeleteCount = min$1(max$2(toIntegerOrInfinity$2(deleteCount), 0), len - actualStart);
        }
        doesNotExceedSafeInteger(len + insertCount - actualDeleteCount);
        A = arraySpeciesCreate(O, actualDeleteCount);
        for (k = 0; k < actualDeleteCount; k++) {
          from = actualStart + k;
          if (from in O) createProperty$2(A, k, O[from]);
        }
        A.length = actualDeleteCount;
        if (insertCount < actualDeleteCount) {
          for (k = actualStart; k < len - actualDeleteCount; k++) {
            from = k + actualDeleteCount;
            to = k + insertCount;
            if (from in O) O[to] = O[from];
            else deletePropertyOrThrow$1(O, to);
          }
          for (k = len; k > len - actualDeleteCount + insertCount; k--) deletePropertyOrThrow$1(O, k - 1);
        } else if (insertCount > actualDeleteCount) {
          for (k = len - actualDeleteCount; k > actualStart; k--) {
            from = k + actualDeleteCount - 1;
            to = k + insertCount - 1;
            if (from in O) O[to] = O[from];
            else deletePropertyOrThrow$1(O, to);
          }
        }
        for (k = 0; k < insertCount; k++) {
          O[k + actualStart] = arguments[k + 2];
        }
        O.length = len - actualDeleteCount + insertCount;
        return A;
      }
    });

    var uncurryThis$f = functionUncurryThis;
    var toObject$4 = toObject$b;

    var floor$2 = Math.floor;
    var charAt$2 = uncurryThis$f(''.charAt);
    var replace$3 = uncurryThis$f(''.replace);
    var stringSlice$2 = uncurryThis$f(''.slice);
    var SUBSTITUTION_SYMBOLS = /\$([$&'`]|\d{1,2}|<[^>]*>)/g;
    var SUBSTITUTION_SYMBOLS_NO_NAMED = /\$([$&'`]|\d{1,2})/g;

    // `GetSubstitution` abstract operation
    // https://tc39.es/ecma262/#sec-getsubstitution
    var getSubstitution$1 = function (matched, str, position, captures, namedCaptures, replacement) {
      var tailPos = position + matched.length;
      var m = captures.length;
      var symbols = SUBSTITUTION_SYMBOLS_NO_NAMED;
      if (namedCaptures !== undefined) {
        namedCaptures = toObject$4(namedCaptures);
        symbols = SUBSTITUTION_SYMBOLS;
      }
      return replace$3(replacement, symbols, function (match, ch) {
        var capture;
        switch (charAt$2(ch, 0)) {
          case '$': return '$';
          case '&': return matched;
          case '`': return stringSlice$2(str, 0, position);
          case "'": return stringSlice$2(str, tailPos);
          case '<':
            capture = namedCaptures[stringSlice$2(ch, 1, -1)];
            break;
          default: // \d\d?
            var n = +ch;
            if (n === 0) return match;
            if (n > m) {
              var f = floor$2(n / 10);
              if (f === 0) return match;
              if (f <= m) return captures[f - 1] === undefined ? charAt$2(ch, 1) : captures[f - 1] + charAt$2(ch, 1);
              return match;
            }
            capture = captures[n - 1];
        }
        return capture === undefined ? '' : capture;
      });
    };

    var apply$1 = functionApply;
    var call$e = functionCall;
    var uncurryThis$e = functionUncurryThis;
    var fixRegExpWellKnownSymbolLogic$1 = fixRegexpWellKnownSymbolLogic;
    var fails$i = fails$F;
    var anObject$e = anObject$o;
    var isCallable$a = isCallable$q;
    var toIntegerOrInfinity$1 = toIntegerOrInfinity$6;
    var toLength$1 = toLength$6;
    var toString$8 = toString$g;
    var requireObjectCoercible$5 = requireObjectCoercible$c;
    var advanceStringIndex$1 = advanceStringIndex$3;
    var getMethod$3 = getMethod$6;
    var getSubstitution = getSubstitution$1;
    var regExpExec$2 = regexpExecAbstract;
    var wellKnownSymbol$a = wellKnownSymbol$q;

    var REPLACE = wellKnownSymbol$a('replace');
    var max$1 = Math.max;
    var min = Math.min;
    var concat$1 = uncurryThis$e([].concat);
    var push$1 = uncurryThis$e([].push);
    var stringIndexOf$2 = uncurryThis$e(''.indexOf);
    var stringSlice$1 = uncurryThis$e(''.slice);

    var maybeToString = function (it) {
      return it === undefined ? it : String(it);
    };

    // IE <= 11 replaces $0 with the whole match, as if it was $&
    // https://stackoverflow.com/questions/6024666/getting-ie-to-replace-a-regex-with-the-literal-string-0
    var REPLACE_KEEPS_$0 = (function () {
      // eslint-disable-next-line regexp/prefer-escape-replacement-dollar-char -- required for testing
      return 'a'.replace(/./, '$0') === '$0';
    })();

    // Safari <= 13.0.3(?) substitutes nth capture where n>m with an empty string
    var REGEXP_REPLACE_SUBSTITUTES_UNDEFINED_CAPTURE = (function () {
      if (/./[REPLACE]) {
        return /./[REPLACE]('a', '$0') === '';
      }
      return false;
    })();

    var REPLACE_SUPPORTS_NAMED_GROUPS = !fails$i(function () {
      var re = /./;
      re.exec = function () {
        var result = [];
        result.groups = { a: '7' };
        return result;
      };
      // eslint-disable-next-line regexp/no-useless-dollar-replacements -- false positive
      return ''.replace(re, '$<a>') !== '7';
    });

    // @@replace logic
    fixRegExpWellKnownSymbolLogic$1('replace', function (_, nativeReplace, maybeCallNative) {
      var UNSAFE_SUBSTITUTE = REGEXP_REPLACE_SUBSTITUTES_UNDEFINED_CAPTURE ? '$' : '$0';

      return [
        // `String.prototype.replace` method
        // https://tc39.es/ecma262/#sec-string.prototype.replace
        function replace(searchValue, replaceValue) {
          var O = requireObjectCoercible$5(this);
          var replacer = searchValue == undefined ? undefined : getMethod$3(searchValue, REPLACE);
          return replacer
            ? call$e(replacer, searchValue, O, replaceValue)
            : call$e(nativeReplace, toString$8(O), searchValue, replaceValue);
        },
        // `RegExp.prototype[@@replace]` method
        // https://tc39.es/ecma262/#sec-regexp.prototype-@@replace
        function (string, replaceValue) {
          var rx = anObject$e(this);
          var S = toString$8(string);

          if (
            typeof replaceValue == 'string' &&
            stringIndexOf$2(replaceValue, UNSAFE_SUBSTITUTE) === -1 &&
            stringIndexOf$2(replaceValue, '$<') === -1
          ) {
            var res = maybeCallNative(nativeReplace, rx, S, replaceValue);
            if (res.done) return res.value;
          }

          var functionalReplace = isCallable$a(replaceValue);
          if (!functionalReplace) replaceValue = toString$8(replaceValue);

          var global = rx.global;
          if (global) {
            var fullUnicode = rx.unicode;
            rx.lastIndex = 0;
          }
          var results = [];
          while (true) {
            var result = regExpExec$2(rx, S);
            if (result === null) break;

            push$1(results, result);
            if (!global) break;

            var matchStr = toString$8(result[0]);
            if (matchStr === '') rx.lastIndex = advanceStringIndex$1(S, toLength$1(rx.lastIndex), fullUnicode);
          }

          var accumulatedResult = '';
          var nextSourcePosition = 0;
          for (var i = 0; i < results.length; i++) {
            result = results[i];

            var matched = toString$8(result[0]);
            var position = max$1(min(toIntegerOrInfinity$1(result.index), S.length), 0);
            var captures = [];
            // NOTE: This is equivalent to
            //   captures = result.slice(1).map(maybeToString)
            // but for some reason `nativeSlice.call(result, 1, result.length)` (called in
            // the slice polyfill when slicing native arrays) "doesn't work" in safari 9 and
            // causes a crash (https://pastebin.com/N21QzeQA) when trying to debug it.
            for (var j = 1; j < result.length; j++) push$1(captures, maybeToString(result[j]));
            var namedCaptures = result.groups;
            if (functionalReplace) {
              var replacerArgs = concat$1([matched], captures, position, S);
              if (namedCaptures !== undefined) push$1(replacerArgs, namedCaptures);
              var replacement = toString$8(apply$1(replaceValue, undefined, replacerArgs));
            } else {
              replacement = getSubstitution(matched, S, position, captures, namedCaptures, replaceValue);
            }
            if (position >= nextSourcePosition) {
              accumulatedResult += stringSlice$1(S, nextSourcePosition, position) + replacement;
              nextSourcePosition = position + matched.length;
            }
          }
          return accumulatedResult + stringSlice$1(S, nextSourcePosition);
        }
      ];
    }, !REPLACE_SUPPORTS_NAMED_GROUPS || !REPLACE_KEEPS_$0 || REGEXP_REPLACE_SUBSTITUTES_UNDEFINED_CAPTURE);

    var $$w = _export;
    var isArray$1 = isArray$5;
    var isConstructor$1 = isConstructor$4;
    var isObject$d = isObject$n;
    var toAbsoluteIndex = toAbsoluteIndex$4;
    var lengthOfArrayLike$3 = lengthOfArrayLike$9;
    var toIndexedObject$1 = toIndexedObject$9;
    var createProperty$1 = createProperty$5;
    var wellKnownSymbol$9 = wellKnownSymbol$q;
    var arrayMethodHasSpeciesSupport$2 = arrayMethodHasSpeciesSupport$5;
    var un$Slice = arraySlice$4;

    var HAS_SPECIES_SUPPORT$2 = arrayMethodHasSpeciesSupport$2('slice');

    var SPECIES$2 = wellKnownSymbol$9('species');
    var $Array$1 = Array;
    var max = Math.max;

    // `Array.prototype.slice` method
    // https://tc39.es/ecma262/#sec-array.prototype.slice
    // fallback for not array-like ES3 strings and DOM objects
    $$w({ target: 'Array', proto: true, forced: !HAS_SPECIES_SUPPORT$2 }, {
      slice: function slice(start, end) {
        var O = toIndexedObject$1(this);
        var length = lengthOfArrayLike$3(O);
        var k = toAbsoluteIndex(start, length);
        var fin = toAbsoluteIndex(end === undefined ? length : end, length);
        // inline `ArraySpeciesCreate` for usage native `Array#slice` where it's possible
        var Constructor, result, n;
        if (isArray$1(O)) {
          Constructor = O.constructor;
          // cross-realm fallback
          if (isConstructor$1(Constructor) && (Constructor === $Array$1 || isArray$1(Constructor.prototype))) {
            Constructor = undefined;
          } else if (isObject$d(Constructor)) {
            Constructor = Constructor[SPECIES$2];
            if (Constructor === null) Constructor = undefined;
          }
          if (Constructor === $Array$1 || Constructor === undefined) {
            return un$Slice(O, k, fin);
          }
        }
        result = new (Constructor === undefined ? $Array$1 : Constructor)(max(fin - k, 0));
        for (n = 0; k < fin; k++, n++) if (k in O) createProperty$1(result, n, O[k]);
        result.length = n;
        return result;
      }
    });

    var $$v = _export;
    var uncurryThis$d = functionUncurryThis;
    var notARegExp = notARegexp;
    var requireObjectCoercible$4 = requireObjectCoercible$c;
    var toString$7 = toString$g;
    var correctIsRegExpLogic = correctIsRegexpLogic;

    var stringIndexOf$1 = uncurryThis$d(''.indexOf);

    // `String.prototype.includes` method
    // https://tc39.es/ecma262/#sec-string.prototype.includes
    $$v({ target: 'String', proto: true, forced: !correctIsRegExpLogic('includes') }, {
      includes: function includes(searchString /* , position = 0 */) {
        return !!~stringIndexOf$1(
          toString$7(requireObjectCoercible$4(this)),
          toString$7(notARegExp(searchString)),
          arguments.length > 1 ? arguments[1] : undefined
        );
      }
    });

    var call$d = functionCall;
    var fixRegExpWellKnownSymbolLogic = fixRegexpWellKnownSymbolLogic;
    var anObject$d = anObject$o;
    var toLength = toLength$6;
    var toString$6 = toString$g;
    var requireObjectCoercible$3 = requireObjectCoercible$c;
    var getMethod$2 = getMethod$6;
    var advanceStringIndex = advanceStringIndex$3;
    var regExpExec$1 = regexpExecAbstract;

    // @@match logic
    fixRegExpWellKnownSymbolLogic('match', function (MATCH, nativeMatch, maybeCallNative) {
      return [
        // `String.prototype.match` method
        // https://tc39.es/ecma262/#sec-string.prototype.match
        function match(regexp) {
          var O = requireObjectCoercible$3(this);
          var matcher = regexp == undefined ? undefined : getMethod$2(regexp, MATCH);
          return matcher ? call$d(matcher, regexp, O) : new RegExp(regexp)[MATCH](toString$6(O));
        },
        // `RegExp.prototype[@@match]` method
        // https://tc39.es/ecma262/#sec-regexp.prototype-@@match
        function (string) {
          var rx = anObject$d(this);
          var S = toString$6(string);
          var res = maybeCallNative(nativeMatch, rx, S);

          if (res.done) return res.value;

          if (!rx.global) return regExpExec$1(rx, S);

          var fullUnicode = rx.unicode;
          rx.lastIndex = 0;
          var A = [];
          var n = 0;
          var result;
          while ((result = regExpExec$1(rx, S)) !== null) {
            var matchStr = toString$6(result[0]);
            A[n] = matchStr;
            if (matchStr === '') rx.lastIndex = advanceStringIndex(S, toLength(rx.lastIndex), fullUnicode);
            n++;
          }
          return n === 0 ? null : A;
        }
      ];
    });

    var isCallable$9 = isCallable$q;

    var $String = String;
    var $TypeError$4 = TypeError;

    var aPossiblePrototype$1 = function (argument) {
      if (typeof argument == 'object' || isCallable$9(argument)) return argument;
      throw $TypeError$4("Can't set " + $String(argument) + ' as a prototype');
    };

    var uncurryThis$c = functionUncurryThis;
    var anObject$c = anObject$o;
    var aPossiblePrototype = aPossiblePrototype$1;

    // `Object.setPrototypeOf` method
    // https://tc39.es/ecma262/#sec-object.setprototypeof
    // Works with __proto__ only. Old v8 can't work with null proto objects.
    // eslint-disable-next-line es-x/no-object-setprototypeof -- safe
    var objectSetPrototypeOf = Object.setPrototypeOf || ('__proto__' in {} ? function () {
      var CORRECT_SETTER = false;
      var test = {};
      var setter;
      try {
        // eslint-disable-next-line es-x/no-object-getownpropertydescriptor -- safe
        setter = uncurryThis$c(Object.getOwnPropertyDescriptor(Object.prototype, '__proto__').set);
        setter(test, []);
        CORRECT_SETTER = test instanceof Array;
      } catch (error) { /* empty */ }
      return function setPrototypeOf(O, proto) {
        anObject$c(O);
        aPossiblePrototype(proto);
        if (CORRECT_SETTER) setter(O, proto);
        else O.__proto__ = proto;
        return O;
      };
    }() : undefined);

    var isCallable$8 = isCallable$q;
    var isObject$c = isObject$n;
    var setPrototypeOf$2 = objectSetPrototypeOf;

    // makes subclassing work correct for wrapped built-ins
    var inheritIfRequired$3 = function ($this, dummy, Wrapper) {
      var NewTarget, NewTargetPrototype;
      if (
        // it can work only with native `setPrototypeOf`
        setPrototypeOf$2 &&
        // we haven't completely correct pre-ES6 way for getting `new.target`, so use this
        isCallable$8(NewTarget = dummy.constructor) &&
        NewTarget !== Wrapper &&
        isObject$c(NewTargetPrototype = NewTarget.prototype) &&
        NewTargetPrototype !== Wrapper.prototype
      ) setPrototypeOf$2($this, NewTargetPrototype);
      return $this;
    };

    var uncurryThis$b = functionUncurryThis;

    // `thisNumberValue` abstract operation
    // https://tc39.es/ecma262/#sec-thisnumbervalue
    var thisNumberValue$1 = uncurryThis$b(1.0.valueOf);

    // a string of all valid unicode whitespaces
    var whitespaces$2 = '\u0009\u000A\u000B\u000C\u000D\u0020\u00A0\u1680\u2000\u2001\u2002' +
      '\u2003\u2004\u2005\u2006\u2007\u2008\u2009\u200A\u202F\u205F\u3000\u2028\u2029\uFEFF';

    var uncurryThis$a = functionUncurryThis;
    var requireObjectCoercible$2 = requireObjectCoercible$c;
    var toString$5 = toString$g;
    var whitespaces$1 = whitespaces$2;

    var replace$2 = uncurryThis$a(''.replace);
    var whitespace = '[' + whitespaces$1 + ']';
    var ltrim = RegExp('^' + whitespace + whitespace + '*');
    var rtrim = RegExp(whitespace + whitespace + '*$');

    // `String.prototype.{ trim, trimStart, trimEnd, trimLeft, trimRight }` methods implementation
    var createMethod = function (TYPE) {
      return function ($this) {
        var string = toString$5(requireObjectCoercible$2($this));
        if (TYPE & 1) string = replace$2(string, ltrim, '');
        if (TYPE & 2) string = replace$2(string, rtrim, '');
        return string;
      };
    };

    var stringTrim = {
      // `String.prototype.{ trimLeft, trimStart }` methods
      // https://tc39.es/ecma262/#sec-string.prototype.trimstart
      start: createMethod(1),
      // `String.prototype.{ trimRight, trimEnd }` methods
      // https://tc39.es/ecma262/#sec-string.prototype.trimend
      end: createMethod(2),
      // `String.prototype.trim` method
      // https://tc39.es/ecma262/#sec-string.prototype.trim
      trim: createMethod(3)
    };

    var DESCRIPTORS$7 = descriptors;
    var global$f = global$w;
    var uncurryThis$9 = functionUncurryThis;
    var isForced$3 = isForced_1;
    var defineBuiltIn$8 = defineBuiltIn$e;
    var hasOwn$8 = hasOwnProperty_1;
    var inheritIfRequired$2 = inheritIfRequired$3;
    var isPrototypeOf$4 = objectIsPrototypeOf;
    var isSymbol$1 = isSymbol$6;
    var toPrimitive = toPrimitive$2;
    var fails$h = fails$F;
    var getOwnPropertyNames$2 = objectGetOwnPropertyNames.f;
    var getOwnPropertyDescriptor$2 = objectGetOwnPropertyDescriptor.f;
    var defineProperty$6 = objectDefineProperty.f;
    var thisNumberValue = thisNumberValue$1;
    var trim = stringTrim.trim;

    var NUMBER = 'Number';
    var NativeNumber = global$f[NUMBER];
    var NumberPrototype = NativeNumber.prototype;
    var TypeError$2 = global$f.TypeError;
    var arraySlice$2 = uncurryThis$9(''.slice);
    var charCodeAt = uncurryThis$9(''.charCodeAt);

    // `ToNumeric` abstract operation
    // https://tc39.es/ecma262/#sec-tonumeric
    var toNumeric = function (value) {
      var primValue = toPrimitive(value, 'number');
      return typeof primValue == 'bigint' ? primValue : toNumber(primValue);
    };

    // `ToNumber` abstract operation
    // https://tc39.es/ecma262/#sec-tonumber
    var toNumber = function (argument) {
      var it = toPrimitive(argument, 'number');
      var first, third, radix, maxCode, digits, length, index, code;
      if (isSymbol$1(it)) throw TypeError$2('Cannot convert a Symbol value to a number');
      if (typeof it == 'string' && it.length > 2) {
        it = trim(it);
        first = charCodeAt(it, 0);
        if (first === 43 || first === 45) {
          third = charCodeAt(it, 2);
          if (third === 88 || third === 120) return NaN; // Number('+0x1') should be NaN, old V8 fix
        } else if (first === 48) {
          switch (charCodeAt(it, 1)) {
            case 66: case 98: radix = 2; maxCode = 49; break; // fast equal of /^0b[01]+$/i
            case 79: case 111: radix = 8; maxCode = 55; break; // fast equal of /^0o[0-7]+$/i
            default: return +it;
          }
          digits = arraySlice$2(it, 2);
          length = digits.length;
          for (index = 0; index < length; index++) {
            code = charCodeAt(digits, index);
            // parseInt parses a string to a first unavailable symbol
            // but ToNumber should return NaN if a string contains unavailable symbols
            if (code < 48 || code > maxCode) return NaN;
          } return parseInt(digits, radix);
        }
      } return +it;
    };

    // `Number` constructor
    // https://tc39.es/ecma262/#sec-number-constructor
    if (isForced$3(NUMBER, !NativeNumber(' 0o1') || !NativeNumber('0b1') || NativeNumber('+0x1'))) {
      var NumberWrapper = function Number(value) {
        var n = arguments.length < 1 ? 0 : NativeNumber(toNumeric(value));
        var dummy = this;
        // check on 1..constructor(foo) case
        return isPrototypeOf$4(NumberPrototype, dummy) && fails$h(function () { thisNumberValue(dummy); })
          ? inheritIfRequired$2(Object(n), dummy, NumberWrapper) : n;
      };
      for (var keys$1 = DESCRIPTORS$7 ? getOwnPropertyNames$2(NativeNumber) : (
        // ES3:
        'MAX_VALUE,MIN_VALUE,NaN,NEGATIVE_INFINITY,POSITIVE_INFINITY,' +
        // ES2015 (in case, if modules with ES2015 Number statics required before):
        'EPSILON,MAX_SAFE_INTEGER,MIN_SAFE_INTEGER,isFinite,isInteger,isNaN,isSafeInteger,parseFloat,parseInt,' +
        // ESNext
        'fromString,range'
      ).split(','), j = 0, key; keys$1.length > j; j++) {
        if (hasOwn$8(NativeNumber, key = keys$1[j]) && !hasOwn$8(NumberWrapper, key)) {
          defineProperty$6(NumberWrapper, key, getOwnPropertyDescriptor$2(NativeNumber, key));
        }
      }
      NumberWrapper.prototype = NumberPrototype;
      NumberPrototype.constructor = NumberWrapper;
      defineBuiltIn$8(global$f, NUMBER, NumberWrapper, { constructor: true });
    }

    var classof$2 = classofRaw$1;
    var global$e = global$w;

    var engineIsNode = classof$2(global$e.process) == 'process';

    var getBuiltIn$3 = getBuiltIn$c;
    var definePropertyModule$2 = objectDefineProperty;
    var wellKnownSymbol$8 = wellKnownSymbol$q;
    var DESCRIPTORS$6 = descriptors;

    var SPECIES$1 = wellKnownSymbol$8('species');

    var setSpecies$3 = function (CONSTRUCTOR_NAME) {
      var Constructor = getBuiltIn$3(CONSTRUCTOR_NAME);
      var defineProperty = definePropertyModule$2.f;

      if (DESCRIPTORS$6 && Constructor && !Constructor[SPECIES$1]) {
        defineProperty(Constructor, SPECIES$1, {
          configurable: true,
          get: function () { return this; }
        });
      }
    };

    var isPrototypeOf$3 = objectIsPrototypeOf;

    var $TypeError$3 = TypeError;

    var anInstance$4 = function (it, Prototype) {
      if (isPrototypeOf$3(Prototype, it)) return it;
      throw $TypeError$3('Incorrect invocation');
    };

    var $TypeError$2 = TypeError;

    var validateArgumentsLength$1 = function (passed, required) {
      if (passed < required) throw $TypeError$2('Not enough arguments');
      return passed;
    };

    var userAgent$4 = engineUserAgent;

    var engineIsIos = /(?:ipad|iphone|ipod).*applewebkit/i.test(userAgent$4);

    var global$d = global$w;
    var apply = functionApply;
    var bind$5 = functionBindContext;
    var isCallable$7 = isCallable$q;
    var hasOwn$7 = hasOwnProperty_1;
    var fails$g = fails$F;
    var html = html$2;
    var arraySlice$1 = arraySlice$4;
    var createElement = documentCreateElement$2;
    var validateArgumentsLength = validateArgumentsLength$1;
    var IS_IOS$1 = engineIsIos;
    var IS_NODE$2 = engineIsNode;

    var set$3 = global$d.setImmediate;
    var clear$1 = global$d.clearImmediate;
    var process$3 = global$d.process;
    var Dispatch = global$d.Dispatch;
    var Function$1 = global$d.Function;
    var MessageChannel = global$d.MessageChannel;
    var String$1 = global$d.String;
    var counter = 0;
    var queue$2 = {};
    var ONREADYSTATECHANGE = 'onreadystatechange';
    var location, defer, channel, port;

    try {
      // Deno throws a ReferenceError on `location` access without `--location` flag
      location = global$d.location;
    } catch (error) { /* empty */ }

    var run = function (id) {
      if (hasOwn$7(queue$2, id)) {
        var fn = queue$2[id];
        delete queue$2[id];
        fn();
      }
    };

    var runner = function (id) {
      return function () {
        run(id);
      };
    };

    var listener = function (event) {
      run(event.data);
    };

    var post = function (id) {
      // old engines have not location.origin
      global$d.postMessage(String$1(id), location.protocol + '//' + location.host);
    };

    // Node.js 0.9+ & IE10+ has setImmediate, otherwise:
    if (!set$3 || !clear$1) {
      set$3 = function setImmediate(handler) {
        validateArgumentsLength(arguments.length, 1);
        var fn = isCallable$7(handler) ? handler : Function$1(handler);
        var args = arraySlice$1(arguments, 1);
        queue$2[++counter] = function () {
          apply(fn, undefined, args);
        };
        defer(counter);
        return counter;
      };
      clear$1 = function clearImmediate(id) {
        delete queue$2[id];
      };
      // Node.js 0.8-
      if (IS_NODE$2) {
        defer = function (id) {
          process$3.nextTick(runner(id));
        };
      // Sphere (JS game engine) Dispatch API
      } else if (Dispatch && Dispatch.now) {
        defer = function (id) {
          Dispatch.now(runner(id));
        };
      // Browsers with MessageChannel, includes WebWorkers
      // except iOS - https://github.com/zloirock/core-js/issues/624
      } else if (MessageChannel && !IS_IOS$1) {
        channel = new MessageChannel();
        port = channel.port2;
        channel.port1.onmessage = listener;
        defer = bind$5(port.postMessage, port);
      // Browsers with postMessage, skip WebWorkers
      // IE8 has postMessage, but it's sync & typeof its postMessage is 'object'
      } else if (
        global$d.addEventListener &&
        isCallable$7(global$d.postMessage) &&
        !global$d.importScripts &&
        location && location.protocol !== 'file:' &&
        !fails$g(post)
      ) {
        defer = post;
        global$d.addEventListener('message', listener, false);
      // IE8-
      } else if (ONREADYSTATECHANGE in createElement('script')) {
        defer = function (id) {
          html.appendChild(createElement('script'))[ONREADYSTATECHANGE] = function () {
            html.removeChild(this);
            run(id);
          };
        };
      // Rest old browsers
      } else {
        defer = function (id) {
          setTimeout(runner(id), 0);
        };
      }
    }

    var task$1 = {
      set: set$3,
      clear: clear$1
    };

    var userAgent$3 = engineUserAgent;
    var global$c = global$w;

    var engineIsIosPebble = /ipad|iphone|ipod/i.test(userAgent$3) && global$c.Pebble !== undefined;

    var userAgent$2 = engineUserAgent;

    var engineIsWebosWebkit = /web0s(?!.*chrome)/i.test(userAgent$2);

    var global$b = global$w;
    var bind$4 = functionBindContext;
    var getOwnPropertyDescriptor$1 = objectGetOwnPropertyDescriptor.f;
    var macrotask = task$1.set;
    var IS_IOS = engineIsIos;
    var IS_IOS_PEBBLE = engineIsIosPebble;
    var IS_WEBOS_WEBKIT = engineIsWebosWebkit;
    var IS_NODE$1 = engineIsNode;

    var MutationObserver = global$b.MutationObserver || global$b.WebKitMutationObserver;
    var document$2 = global$b.document;
    var process$2 = global$b.process;
    var Promise$1 = global$b.Promise;
    // Node.js 11 shows ExperimentalWarning on getting `queueMicrotask`
    var queueMicrotaskDescriptor = getOwnPropertyDescriptor$1(global$b, 'queueMicrotask');
    var queueMicrotask = queueMicrotaskDescriptor && queueMicrotaskDescriptor.value;

    var flush, head, last, notify$1, toggle, node, promise, then;

    // modern engines have queueMicrotask method
    if (!queueMicrotask) {
      flush = function () {
        var parent, fn;
        if (IS_NODE$1 && (parent = process$2.domain)) parent.exit();
        while (head) {
          fn = head.fn;
          head = head.next;
          try {
            fn();
          } catch (error) {
            if (head) notify$1();
            else last = undefined;
            throw error;
          }
        } last = undefined;
        if (parent) parent.enter();
      };

      // browsers with MutationObserver, except iOS - https://github.com/zloirock/core-js/issues/339
      // also except WebOS Webkit https://github.com/zloirock/core-js/issues/898
      if (!IS_IOS && !IS_NODE$1 && !IS_WEBOS_WEBKIT && MutationObserver && document$2) {
        toggle = true;
        node = document$2.createTextNode('');
        new MutationObserver(flush).observe(node, { characterData: true });
        notify$1 = function () {
          node.data = toggle = !toggle;
        };
      // environments with maybe non-completely correct, but existent Promise
      } else if (!IS_IOS_PEBBLE && Promise$1 && Promise$1.resolve) {
        // Promise.resolve without an argument throws an error in LG WebOS 2
        promise = Promise$1.resolve(undefined);
        // workaround of WebKit ~ iOS Safari 10.1 bug
        promise.constructor = Promise$1;
        then = bind$4(promise.then, promise);
        notify$1 = function () {
          then(flush);
        };
      // Node.js without promises
      } else if (IS_NODE$1) {
        notify$1 = function () {
          process$2.nextTick(flush);
        };
      // for other environments - macrotask based on:
      // - setImmediate
      // - MessageChannel
      // - window.postMessage
      // - onreadystatechange
      // - setTimeout
      } else {
        // strange IE + webpack dev server bug - use .bind(global)
        macrotask = bind$4(macrotask, global$b);
        notify$1 = function () {
          macrotask(flush);
        };
      }
    }

    var microtask$1 = queueMicrotask || function (fn) {
      var task = { fn: fn, next: undefined };
      if (last) last.next = task;
      if (!head) {
        head = task;
        notify$1();
      } last = task;
    };

    var global$a = global$w;

    var hostReportErrors$1 = function (a, b) {
      var console = global$a.console;
      if (console && console.error) {
        arguments.length == 1 ? console.error(a) : console.error(a, b);
      }
    };

    var perform$3 = function (exec) {
      try {
        return { error: false, value: exec() };
      } catch (error) {
        return { error: true, value: error };
      }
    };

    var Queue$1 = function () {
      this.head = null;
      this.tail = null;
    };

    Queue$1.prototype = {
      add: function (item) {
        var entry = { item: item, next: null };
        if (this.head) this.tail.next = entry;
        else this.head = entry;
        this.tail = entry;
      },
      get: function () {
        var entry = this.head;
        if (entry) {
          this.head = entry.next;
          if (this.tail === entry) this.tail = null;
          return entry.item;
        }
      }
    };

    var queue$1 = Queue$1;

    var global$9 = global$w;

    var promiseNativeConstructor = global$9.Promise;

    var engineIsBrowser = typeof window == 'object' && typeof Deno != 'object';

    var global$8 = global$w;
    var NativePromiseConstructor$3 = promiseNativeConstructor;
    var isCallable$6 = isCallable$q;
    var isForced$2 = isForced_1;
    var inspectSource = inspectSource$4;
    var wellKnownSymbol$7 = wellKnownSymbol$q;
    var IS_BROWSER = engineIsBrowser;
    var V8_VERSION = engineV8Version;

    NativePromiseConstructor$3 && NativePromiseConstructor$3.prototype;
    var SPECIES = wellKnownSymbol$7('species');
    var SUBCLASSING = false;
    var NATIVE_PROMISE_REJECTION_EVENT$1 = isCallable$6(global$8.PromiseRejectionEvent);

    var FORCED_PROMISE_CONSTRUCTOR$5 = isForced$2('Promise', function () {
      var PROMISE_CONSTRUCTOR_SOURCE = inspectSource(NativePromiseConstructor$3);
      var GLOBAL_CORE_JS_PROMISE = PROMISE_CONSTRUCTOR_SOURCE !== String(NativePromiseConstructor$3);
      // V8 6.6 (Node 10 and Chrome 66) have a bug with resolving custom thenables
      // https://bugs.chromium.org/p/chromium/issues/detail?id=830565
      // We can't detect it synchronously, so just check versions
      if (!GLOBAL_CORE_JS_PROMISE && V8_VERSION === 66) return true;
      // We can't use @@species feature detection in V8 since it causes
      // deoptimization and performance degradation
      // https://github.com/zloirock/core-js/issues/679
      if (V8_VERSION >= 51 && /native code/.test(PROMISE_CONSTRUCTOR_SOURCE)) return false;
      // Detect correctness of subclassing with @@species support
      var promise = new NativePromiseConstructor$3(function (resolve) { resolve(1); });
      var FakePromise = function (exec) {
        exec(function () { /* empty */ }, function () { /* empty */ });
      };
      var constructor = promise.constructor = {};
      constructor[SPECIES] = FakePromise;
      SUBCLASSING = promise.then(function () { /* empty */ }) instanceof FakePromise;
      if (!SUBCLASSING) return true;
      // Unhandled rejections tracking support, NodeJS Promise without it fails @@species test
      return !GLOBAL_CORE_JS_PROMISE && IS_BROWSER && !NATIVE_PROMISE_REJECTION_EVENT$1;
    });

    var promiseConstructorDetection = {
      CONSTRUCTOR: FORCED_PROMISE_CONSTRUCTOR$5,
      REJECTION_EVENT: NATIVE_PROMISE_REJECTION_EVENT$1,
      SUBCLASSING: SUBCLASSING
    };

    var newPromiseCapability$2 = {};

    var aCallable$5 = aCallable$8;

    var PromiseCapability = function (C) {
      var resolve, reject;
      this.promise = new C(function ($$resolve, $$reject) {
        if (resolve !== undefined || reject !== undefined) throw TypeError('Bad Promise constructor');
        resolve = $$resolve;
        reject = $$reject;
      });
      this.resolve = aCallable$5(resolve);
      this.reject = aCallable$5(reject);
    };

    // `NewPromiseCapability` abstract operation
    // https://tc39.es/ecma262/#sec-newpromisecapability
    newPromiseCapability$2.f = function (C) {
      return new PromiseCapability(C);
    };

    var $$u = _export;
    var IS_NODE = engineIsNode;
    var global$7 = global$w;
    var call$c = functionCall;
    var defineBuiltIn$7 = defineBuiltIn$e;
    var setPrototypeOf$1 = objectSetPrototypeOf;
    var setToStringTag$6 = setToStringTag$8;
    var setSpecies$2 = setSpecies$3;
    var aCallable$4 = aCallable$8;
    var isCallable$5 = isCallable$q;
    var isObject$b = isObject$n;
    var anInstance$3 = anInstance$4;
    var speciesConstructor = speciesConstructor$2;
    var task = task$1.set;
    var microtask = microtask$1;
    var hostReportErrors = hostReportErrors$1;
    var perform$2 = perform$3;
    var Queue = queue$1;
    var InternalStateModule$4 = internalState;
    var NativePromiseConstructor$2 = promiseNativeConstructor;
    var PromiseConstructorDetection = promiseConstructorDetection;
    var newPromiseCapabilityModule$3 = newPromiseCapability$2;

    var PROMISE = 'Promise';
    var FORCED_PROMISE_CONSTRUCTOR$4 = PromiseConstructorDetection.CONSTRUCTOR;
    var NATIVE_PROMISE_REJECTION_EVENT = PromiseConstructorDetection.REJECTION_EVENT;
    var NATIVE_PROMISE_SUBCLASSING = PromiseConstructorDetection.SUBCLASSING;
    var getInternalPromiseState = InternalStateModule$4.getterFor(PROMISE);
    var setInternalState$4 = InternalStateModule$4.set;
    var NativePromisePrototype$1 = NativePromiseConstructor$2 && NativePromiseConstructor$2.prototype;
    var PromiseConstructor = NativePromiseConstructor$2;
    var PromisePrototype = NativePromisePrototype$1;
    var TypeError$1 = global$7.TypeError;
    var document$1 = global$7.document;
    var process$1 = global$7.process;
    var newPromiseCapability$1 = newPromiseCapabilityModule$3.f;
    var newGenericPromiseCapability = newPromiseCapability$1;

    var DISPATCH_EVENT = !!(document$1 && document$1.createEvent && global$7.dispatchEvent);
    var UNHANDLED_REJECTION = 'unhandledrejection';
    var REJECTION_HANDLED = 'rejectionhandled';
    var PENDING = 0;
    var FULFILLED = 1;
    var REJECTED = 2;
    var HANDLED = 1;
    var UNHANDLED = 2;

    var Internal, OwnPromiseCapability, PromiseWrapper, nativeThen;

    // helpers
    var isThenable = function (it) {
      var then;
      return isObject$b(it) && isCallable$5(then = it.then) ? then : false;
    };

    var callReaction = function (reaction, state) {
      var value = state.value;
      var ok = state.state == FULFILLED;
      var handler = ok ? reaction.ok : reaction.fail;
      var resolve = reaction.resolve;
      var reject = reaction.reject;
      var domain = reaction.domain;
      var result, then, exited;
      try {
        if (handler) {
          if (!ok) {
            if (state.rejection === UNHANDLED) onHandleUnhandled(state);
            state.rejection = HANDLED;
          }
          if (handler === true) result = value;
          else {
            if (domain) domain.enter();
            result = handler(value); // can throw
            if (domain) {
              domain.exit();
              exited = true;
            }
          }
          if (result === reaction.promise) {
            reject(TypeError$1('Promise-chain cycle'));
          } else if (then = isThenable(result)) {
            call$c(then, result, resolve, reject);
          } else resolve(result);
        } else reject(value);
      } catch (error) {
        if (domain && !exited) domain.exit();
        reject(error);
      }
    };

    var notify = function (state, isReject) {
      if (state.notified) return;
      state.notified = true;
      microtask(function () {
        var reactions = state.reactions;
        var reaction;
        while (reaction = reactions.get()) {
          callReaction(reaction, state);
        }
        state.notified = false;
        if (isReject && !state.rejection) onUnhandled(state);
      });
    };

    var dispatchEvent = function (name, promise, reason) {
      var event, handler;
      if (DISPATCH_EVENT) {
        event = document$1.createEvent('Event');
        event.promise = promise;
        event.reason = reason;
        event.initEvent(name, false, true);
        global$7.dispatchEvent(event);
      } else event = { promise: promise, reason: reason };
      if (!NATIVE_PROMISE_REJECTION_EVENT && (handler = global$7['on' + name])) handler(event);
      else if (name === UNHANDLED_REJECTION) hostReportErrors('Unhandled promise rejection', reason);
    };

    var onUnhandled = function (state) {
      call$c(task, global$7, function () {
        var promise = state.facade;
        var value = state.value;
        var IS_UNHANDLED = isUnhandled(state);
        var result;
        if (IS_UNHANDLED) {
          result = perform$2(function () {
            if (IS_NODE) {
              process$1.emit('unhandledRejection', value, promise);
            } else dispatchEvent(UNHANDLED_REJECTION, promise, value);
          });
          // Browsers should not trigger `rejectionHandled` event if it was handled here, NodeJS - should
          state.rejection = IS_NODE || isUnhandled(state) ? UNHANDLED : HANDLED;
          if (result.error) throw result.value;
        }
      });
    };

    var isUnhandled = function (state) {
      return state.rejection !== HANDLED && !state.parent;
    };

    var onHandleUnhandled = function (state) {
      call$c(task, global$7, function () {
        var promise = state.facade;
        if (IS_NODE) {
          process$1.emit('rejectionHandled', promise);
        } else dispatchEvent(REJECTION_HANDLED, promise, state.value);
      });
    };

    var bind$3 = function (fn, state, unwrap) {
      return function (value) {
        fn(state, value, unwrap);
      };
    };

    var internalReject = function (state, value, unwrap) {
      if (state.done) return;
      state.done = true;
      if (unwrap) state = unwrap;
      state.value = value;
      state.state = REJECTED;
      notify(state, true);
    };

    var internalResolve = function (state, value, unwrap) {
      if (state.done) return;
      state.done = true;
      if (unwrap) state = unwrap;
      try {
        if (state.facade === value) throw TypeError$1("Promise can't be resolved itself");
        var then = isThenable(value);
        if (then) {
          microtask(function () {
            var wrapper = { done: false };
            try {
              call$c(then, value,
                bind$3(internalResolve, wrapper, state),
                bind$3(internalReject, wrapper, state)
              );
            } catch (error) {
              internalReject(wrapper, error, state);
            }
          });
        } else {
          state.value = value;
          state.state = FULFILLED;
          notify(state, false);
        }
      } catch (error) {
        internalReject({ done: false }, error, state);
      }
    };

    // constructor polyfill
    if (FORCED_PROMISE_CONSTRUCTOR$4) {
      // 25.4.3.1 Promise(executor)
      PromiseConstructor = function Promise(executor) {
        anInstance$3(this, PromisePrototype);
        aCallable$4(executor);
        call$c(Internal, this);
        var state = getInternalPromiseState(this);
        try {
          executor(bind$3(internalResolve, state), bind$3(internalReject, state));
        } catch (error) {
          internalReject(state, error);
        }
      };

      PromisePrototype = PromiseConstructor.prototype;

      // eslint-disable-next-line no-unused-vars -- required for `.length`
      Internal = function Promise(executor) {
        setInternalState$4(this, {
          type: PROMISE,
          done: false,
          notified: false,
          parent: false,
          reactions: new Queue(),
          rejection: false,
          state: PENDING,
          value: undefined
        });
      };

      // `Promise.prototype.then` method
      // https://tc39.es/ecma262/#sec-promise.prototype.then
      Internal.prototype = defineBuiltIn$7(PromisePrototype, 'then', function then(onFulfilled, onRejected) {
        var state = getInternalPromiseState(this);
        var reaction = newPromiseCapability$1(speciesConstructor(this, PromiseConstructor));
        state.parent = true;
        reaction.ok = isCallable$5(onFulfilled) ? onFulfilled : true;
        reaction.fail = isCallable$5(onRejected) && onRejected;
        reaction.domain = IS_NODE ? process$1.domain : undefined;
        if (state.state == PENDING) state.reactions.add(reaction);
        else microtask(function () {
          callReaction(reaction, state);
        });
        return reaction.promise;
      });

      OwnPromiseCapability = function () {
        var promise = new Internal();
        var state = getInternalPromiseState(promise);
        this.promise = promise;
        this.resolve = bind$3(internalResolve, state);
        this.reject = bind$3(internalReject, state);
      };

      newPromiseCapabilityModule$3.f = newPromiseCapability$1 = function (C) {
        return C === PromiseConstructor || C === PromiseWrapper
          ? new OwnPromiseCapability(C)
          : newGenericPromiseCapability(C);
      };

      if (isCallable$5(NativePromiseConstructor$2) && NativePromisePrototype$1 !== Object.prototype) {
        nativeThen = NativePromisePrototype$1.then;

        if (!NATIVE_PROMISE_SUBCLASSING) {
          // make `Promise#then` return a polyfilled `Promise` for native promise-based APIs
          defineBuiltIn$7(NativePromisePrototype$1, 'then', function then(onFulfilled, onRejected) {
            var that = this;
            return new PromiseConstructor(function (resolve, reject) {
              call$c(nativeThen, that, resolve, reject);
            }).then(onFulfilled, onRejected);
          // https://github.com/zloirock/core-js/issues/640
          }, { unsafe: true });
        }

        // make `.constructor === Promise` work for native promise-based APIs
        try {
          delete NativePromisePrototype$1.constructor;
        } catch (error) { /* empty */ }

        // make `instanceof Promise` work for native promise-based APIs
        if (setPrototypeOf$1) {
          setPrototypeOf$1(NativePromisePrototype$1, PromisePrototype);
        }
      }
    }

    $$u({ global: true, constructor: true, wrap: true, forced: FORCED_PROMISE_CONSTRUCTOR$4 }, {
      Promise: PromiseConstructor
    });

    setToStringTag$6(PromiseConstructor, PROMISE, false);
    setSpecies$2(PROMISE);

    var iterators = {};

    var wellKnownSymbol$6 = wellKnownSymbol$q;
    var Iterators$4 = iterators;

    var ITERATOR$5 = wellKnownSymbol$6('iterator');
    var ArrayPrototype = Array.prototype;

    // check on default Array iterator
    var isArrayIteratorMethod$2 = function (it) {
      return it !== undefined && (Iterators$4.Array === it || ArrayPrototype[ITERATOR$5] === it);
    };

    var classof$1 = classof$b;
    var getMethod$1 = getMethod$6;
    var Iterators$3 = iterators;
    var wellKnownSymbol$5 = wellKnownSymbol$q;

    var ITERATOR$4 = wellKnownSymbol$5('iterator');

    var getIteratorMethod$3 = function (it) {
      if (it != undefined) return getMethod$1(it, ITERATOR$4)
        || getMethod$1(it, '@@iterator')
        || Iterators$3[classof$1(it)];
    };

    var call$b = functionCall;
    var aCallable$3 = aCallable$8;
    var anObject$b = anObject$o;
    var tryToString$1 = tryToString$6;
    var getIteratorMethod$2 = getIteratorMethod$3;

    var $TypeError$1 = TypeError;

    var getIterator$2 = function (argument, usingIterator) {
      var iteratorMethod = arguments.length < 2 ? getIteratorMethod$2(argument) : usingIterator;
      if (aCallable$3(iteratorMethod)) return anObject$b(call$b(iteratorMethod, argument));
      throw $TypeError$1(tryToString$1(argument) + ' is not iterable');
    };

    var call$a = functionCall;
    var anObject$a = anObject$o;
    var getMethod = getMethod$6;

    var iteratorClose$2 = function (iterator, kind, value) {
      var innerResult, innerError;
      anObject$a(iterator);
      try {
        innerResult = getMethod(iterator, 'return');
        if (!innerResult) {
          if (kind === 'throw') throw value;
          return value;
        }
        innerResult = call$a(innerResult, iterator);
      } catch (error) {
        innerError = true;
        innerResult = error;
      }
      if (kind === 'throw') throw value;
      if (innerError) throw innerResult;
      anObject$a(innerResult);
      return value;
    };

    var bind$2 = functionBindContext;
    var call$9 = functionCall;
    var anObject$9 = anObject$o;
    var tryToString = tryToString$6;
    var isArrayIteratorMethod$1 = isArrayIteratorMethod$2;
    var lengthOfArrayLike$2 = lengthOfArrayLike$9;
    var isPrototypeOf$2 = objectIsPrototypeOf;
    var getIterator$1 = getIterator$2;
    var getIteratorMethod$1 = getIteratorMethod$3;
    var iteratorClose$1 = iteratorClose$2;

    var $TypeError = TypeError;

    var Result = function (stopped, result) {
      this.stopped = stopped;
      this.result = result;
    };

    var ResultPrototype = Result.prototype;

    var iterate$5 = function (iterable, unboundFunction, options) {
      var that = options && options.that;
      var AS_ENTRIES = !!(options && options.AS_ENTRIES);
      var IS_RECORD = !!(options && options.IS_RECORD);
      var IS_ITERATOR = !!(options && options.IS_ITERATOR);
      var INTERRUPTED = !!(options && options.INTERRUPTED);
      var fn = bind$2(unboundFunction, that);
      var iterator, iterFn, index, length, result, next, step;

      var stop = function (condition) {
        if (iterator) iteratorClose$1(iterator, 'normal', condition);
        return new Result(true, condition);
      };

      var callFn = function (value) {
        if (AS_ENTRIES) {
          anObject$9(value);
          return INTERRUPTED ? fn(value[0], value[1], stop) : fn(value[0], value[1]);
        } return INTERRUPTED ? fn(value, stop) : fn(value);
      };

      if (IS_RECORD) {
        iterator = iterable.iterator;
      } else if (IS_ITERATOR) {
        iterator = iterable;
      } else {
        iterFn = getIteratorMethod$1(iterable);
        if (!iterFn) throw $TypeError(tryToString(iterable) + ' is not iterable');
        // optimisation for array iterators
        if (isArrayIteratorMethod$1(iterFn)) {
          for (index = 0, length = lengthOfArrayLike$2(iterable); length > index; index++) {
            result = callFn(iterable[index]);
            if (result && isPrototypeOf$2(ResultPrototype, result)) return result;
          } return new Result(false);
        }
        iterator = getIterator$1(iterable, iterFn);
      }

      next = IS_RECORD ? iterable.next : iterator.next;
      while (!(step = call$9(next, iterator)).done) {
        try {
          result = callFn(step.value);
        } catch (error) {
          iteratorClose$1(iterator, 'throw', error);
        }
        if (typeof result == 'object' && result && isPrototypeOf$2(ResultPrototype, result)) return result;
      } return new Result(false);
    };

    var wellKnownSymbol$4 = wellKnownSymbol$q;

    var ITERATOR$3 = wellKnownSymbol$4('iterator');
    var SAFE_CLOSING = false;

    try {
      var called = 0;
      var iteratorWithReturn = {
        next: function () {
          return { done: !!called++ };
        },
        'return': function () {
          SAFE_CLOSING = true;
        }
      };
      iteratorWithReturn[ITERATOR$3] = function () {
        return this;
      };
      // eslint-disable-next-line es-x/no-array-from, no-throw-literal -- required for testing
      Array.from(iteratorWithReturn, function () { throw 2; });
    } catch (error) { /* empty */ }

    var checkCorrectnessOfIteration$3 = function (exec, SKIP_CLOSING) {
      if (!SKIP_CLOSING && !SAFE_CLOSING) return false;
      var ITERATION_SUPPORT = false;
      try {
        var object = {};
        object[ITERATOR$3] = function () {
          return {
            next: function () {
              return { done: ITERATION_SUPPORT = true };
            }
          };
        };
        exec(object);
      } catch (error) { /* empty */ }
      return ITERATION_SUPPORT;
    };

    var NativePromiseConstructor$1 = promiseNativeConstructor;
    var checkCorrectnessOfIteration$2 = checkCorrectnessOfIteration$3;
    var FORCED_PROMISE_CONSTRUCTOR$3 = promiseConstructorDetection.CONSTRUCTOR;

    var promiseStaticsIncorrectIteration = FORCED_PROMISE_CONSTRUCTOR$3 || !checkCorrectnessOfIteration$2(function (iterable) {
      NativePromiseConstructor$1.all(iterable).then(undefined, function () { /* empty */ });
    });

    var $$t = _export;
    var call$8 = functionCall;
    var aCallable$2 = aCallable$8;
    var newPromiseCapabilityModule$2 = newPromiseCapability$2;
    var perform$1 = perform$3;
    var iterate$4 = iterate$5;
    var PROMISE_STATICS_INCORRECT_ITERATION$1 = promiseStaticsIncorrectIteration;

    // `Promise.all` method
    // https://tc39.es/ecma262/#sec-promise.all
    $$t({ target: 'Promise', stat: true, forced: PROMISE_STATICS_INCORRECT_ITERATION$1 }, {
      all: function all(iterable) {
        var C = this;
        var capability = newPromiseCapabilityModule$2.f(C);
        var resolve = capability.resolve;
        var reject = capability.reject;
        var result = perform$1(function () {
          var $promiseResolve = aCallable$2(C.resolve);
          var values = [];
          var counter = 0;
          var remaining = 1;
          iterate$4(iterable, function (promise) {
            var index = counter++;
            var alreadyCalled = false;
            remaining++;
            call$8($promiseResolve, C, promise).then(function (value) {
              if (alreadyCalled) return;
              alreadyCalled = true;
              values[index] = value;
              --remaining || resolve(values);
            }, reject);
          });
          --remaining || resolve(values);
        });
        if (result.error) reject(result.value);
        return capability.promise;
      }
    });

    var $$s = _export;
    var FORCED_PROMISE_CONSTRUCTOR$2 = promiseConstructorDetection.CONSTRUCTOR;
    var NativePromiseConstructor = promiseNativeConstructor;
    var getBuiltIn$2 = getBuiltIn$c;
    var isCallable$4 = isCallable$q;
    var defineBuiltIn$6 = defineBuiltIn$e;

    var NativePromisePrototype = NativePromiseConstructor && NativePromiseConstructor.prototype;

    // `Promise.prototype.catch` method
    // https://tc39.es/ecma262/#sec-promise.prototype.catch
    $$s({ target: 'Promise', proto: true, forced: FORCED_PROMISE_CONSTRUCTOR$2, real: true }, {
      'catch': function (onRejected) {
        return this.then(undefined, onRejected);
      }
    });

    // makes sure that native promise-based APIs `Promise#catch` properly works with patched `Promise#then`
    if (isCallable$4(NativePromiseConstructor)) {
      var method = getBuiltIn$2('Promise').prototype['catch'];
      if (NativePromisePrototype['catch'] !== method) {
        defineBuiltIn$6(NativePromisePrototype, 'catch', method, { unsafe: true });
      }
    }

    var $$r = _export;
    var call$7 = functionCall;
    var aCallable$1 = aCallable$8;
    var newPromiseCapabilityModule$1 = newPromiseCapability$2;
    var perform = perform$3;
    var iterate$3 = iterate$5;
    var PROMISE_STATICS_INCORRECT_ITERATION = promiseStaticsIncorrectIteration;

    // `Promise.race` method
    // https://tc39.es/ecma262/#sec-promise.race
    $$r({ target: 'Promise', stat: true, forced: PROMISE_STATICS_INCORRECT_ITERATION }, {
      race: function race(iterable) {
        var C = this;
        var capability = newPromiseCapabilityModule$1.f(C);
        var reject = capability.reject;
        var result = perform(function () {
          var $promiseResolve = aCallable$1(C.resolve);
          iterate$3(iterable, function (promise) {
            call$7($promiseResolve, C, promise).then(capability.resolve, reject);
          });
        });
        if (result.error) reject(result.value);
        return capability.promise;
      }
    });

    var $$q = _export;
    var call$6 = functionCall;
    var newPromiseCapabilityModule = newPromiseCapability$2;
    var FORCED_PROMISE_CONSTRUCTOR$1 = promiseConstructorDetection.CONSTRUCTOR;

    // `Promise.reject` method
    // https://tc39.es/ecma262/#sec-promise.reject
    $$q({ target: 'Promise', stat: true, forced: FORCED_PROMISE_CONSTRUCTOR$1 }, {
      reject: function reject(r) {
        var capability = newPromiseCapabilityModule.f(this);
        call$6(capability.reject, undefined, r);
        return capability.promise;
      }
    });

    var anObject$8 = anObject$o;
    var isObject$a = isObject$n;
    var newPromiseCapability = newPromiseCapability$2;

    var promiseResolve$1 = function (C, x) {
      anObject$8(C);
      if (isObject$a(x) && x.constructor === C) return x;
      var promiseCapability = newPromiseCapability.f(C);
      var resolve = promiseCapability.resolve;
      resolve(x);
      return promiseCapability.promise;
    };

    var $$p = _export;
    var getBuiltIn$1 = getBuiltIn$c;
    var FORCED_PROMISE_CONSTRUCTOR = promiseConstructorDetection.CONSTRUCTOR;
    var promiseResolve = promiseResolve$1;

    getBuiltIn$1('Promise');

    // `Promise.resolve` method
    // https://tc39.es/ecma262/#sec-promise.resolve
    $$p({ target: 'Promise', stat: true, forced: FORCED_PROMISE_CONSTRUCTOR }, {
      resolve: function resolve(x) {
        return promiseResolve(this, x);
      }
    });

    var $$o = _export;
    var $map = arrayIteration.map;
    var arrayMethodHasSpeciesSupport$1 = arrayMethodHasSpeciesSupport$5;

    var HAS_SPECIES_SUPPORT$1 = arrayMethodHasSpeciesSupport$1('map');

    // `Array.prototype.map` method
    // https://tc39.es/ecma262/#sec-array.prototype.map
    // with adding support of @@species
    $$o({ target: 'Array', proto: true, forced: !HAS_SPECIES_SUPPORT$1 }, {
      map: function map(callbackfn /* , thisArg */) {
        return $map(this, callbackfn, arguments.length > 1 ? arguments[1] : undefined);
      }
    });

    var DESCRIPTORS$5 = descriptors;
    var FUNCTION_NAME_EXISTS = functionName.EXISTS;
    var uncurryThis$8 = functionUncurryThis;
    var defineProperty$5 = objectDefineProperty.f;

    var FunctionPrototype = Function.prototype;
    var functionToString = uncurryThis$8(FunctionPrototype.toString);
    var nameRE = /function\b(?:\s|\/\*[\S\s]*?\*\/|\/\/[^\n\r]*[\n\r]+)*([^\s(/]*)/;
    var regExpExec = uncurryThis$8(nameRE.exec);
    var NAME = 'name';

    // Function instances `.name` property
    // https://tc39.es/ecma262/#sec-function-instances-name
    if (DESCRIPTORS$5 && !FUNCTION_NAME_EXISTS) {
      defineProperty$5(FunctionPrototype, NAME, {
        configurable: true,
        get: function () {
          try {
            return regExpExec(nameRE, functionToString(this))[1];
          } catch (error) {
            return '';
          }
        }
      });
    }

    var uncurryThis$7 = functionUncurryThis;
    var requireObjectCoercible$1 = requireObjectCoercible$c;
    var toString$4 = toString$g;

    var quot = /"/g;
    var replace$1 = uncurryThis$7(''.replace);

    // `CreateHTML` abstract operation
    // https://tc39.es/ecma262/#sec-createhtml
    var createHtml = function (string, tag, attribute, value) {
      var S = toString$4(requireObjectCoercible$1(string));
      var p1 = '<' + tag;
      if (attribute !== '') p1 += ' ' + attribute + '="' + replace$1(toString$4(value), quot, '&quot;') + '"';
      return p1 + '>' + S + '</' + tag + '>';
    };

    var fails$f = fails$F;

    // check the existence of a method, lowercase
    // of a tag and escaping quotes in arguments
    var stringHtmlForced = function (METHOD_NAME) {
      return fails$f(function () {
        var test = ''[METHOD_NAME]('"');
        return test !== test.toLowerCase() || test.split('"').length > 3;
      });
    };

    var $$n = _export;
    var createHTML = createHtml;
    var forcedStringHTMLMethod = stringHtmlForced;

    // `String.prototype.anchor` method
    // https://tc39.es/ecma262/#sec-string.prototype.anchor
    $$n({ target: 'String', proto: true, forced: forcedStringHTMLMethod('anchor') }, {
      anchor: function anchor(name) {
        return createHTML(this, 'a', 'name', name);
      }
    });

    var fails$e = fails$F;

    var correctPrototypeGetter = !fails$e(function () {
      function F() { /* empty */ }
      F.prototype.constructor = null;
      // eslint-disable-next-line es-x/no-object-getprototypeof -- required for testing
      return Object.getPrototypeOf(new F()) !== F.prototype;
    });

    var hasOwn$6 = hasOwnProperty_1;
    var isCallable$3 = isCallable$q;
    var toObject$3 = toObject$b;
    var sharedKey = sharedKey$4;
    var CORRECT_PROTOTYPE_GETTER$1 = correctPrototypeGetter;

    var IE_PROTO = sharedKey('IE_PROTO');
    var $Object = Object;
    var ObjectPrototype = $Object.prototype;

    // `Object.getPrototypeOf` method
    // https://tc39.es/ecma262/#sec-object.getprototypeof
    // eslint-disable-next-line es-x/no-object-getprototypeof -- safe
    var objectGetPrototypeOf$1 = CORRECT_PROTOTYPE_GETTER$1 ? $Object.getPrototypeOf : function (O) {
      var object = toObject$3(O);
      if (hasOwn$6(object, IE_PROTO)) return object[IE_PROTO];
      var constructor = object.constructor;
      if (isCallable$3(constructor) && object instanceof constructor) {
        return constructor.prototype;
      } return object instanceof $Object ? ObjectPrototype : null;
    };

    var fails$d = fails$F;
    var isCallable$2 = isCallable$q;
    var getPrototypeOf$3 = objectGetPrototypeOf$1;
    var defineBuiltIn$5 = defineBuiltIn$e;
    var wellKnownSymbol$3 = wellKnownSymbol$q;

    var ITERATOR$2 = wellKnownSymbol$3('iterator');
    var BUGGY_SAFARI_ITERATORS$1 = false;

    // `%IteratorPrototype%` object
    // https://tc39.es/ecma262/#sec-%iteratorprototype%-object
    var IteratorPrototype$2, PrototypeOfArrayIteratorPrototype, arrayIterator;

    /* eslint-disable es-x/no-array-prototype-keys -- safe */
    if ([].keys) {
      arrayIterator = [].keys();
      // Safari 8 has buggy iterators w/o `next`
      if (!('next' in arrayIterator)) BUGGY_SAFARI_ITERATORS$1 = true;
      else {
        PrototypeOfArrayIteratorPrototype = getPrototypeOf$3(getPrototypeOf$3(arrayIterator));
        if (PrototypeOfArrayIteratorPrototype !== Object.prototype) IteratorPrototype$2 = PrototypeOfArrayIteratorPrototype;
      }
    }

    var NEW_ITERATOR_PROTOTYPE = IteratorPrototype$2 == undefined || fails$d(function () {
      var test = {};
      // FF44- legacy iterators case
      return IteratorPrototype$2[ITERATOR$2].call(test) !== test;
    });

    if (NEW_ITERATOR_PROTOTYPE) IteratorPrototype$2 = {};

    // `%IteratorPrototype%[@@iterator]()` method
    // https://tc39.es/ecma262/#sec-%iteratorprototype%-@@iterator
    if (!isCallable$2(IteratorPrototype$2[ITERATOR$2])) {
      defineBuiltIn$5(IteratorPrototype$2, ITERATOR$2, function () {
        return this;
      });
    }

    var iteratorsCore = {
      IteratorPrototype: IteratorPrototype$2,
      BUGGY_SAFARI_ITERATORS: BUGGY_SAFARI_ITERATORS$1
    };

    var IteratorPrototype$1 = iteratorsCore.IteratorPrototype;
    var create$1 = objectCreate;
    var createPropertyDescriptor$1 = createPropertyDescriptor$6;
    var setToStringTag$5 = setToStringTag$8;
    var Iterators$2 = iterators;

    var returnThis$1 = function () { return this; };

    var createIteratorConstructor$1 = function (IteratorConstructor, NAME, next, ENUMERABLE_NEXT) {
      var TO_STRING_TAG = NAME + ' Iterator';
      IteratorConstructor.prototype = create$1(IteratorPrototype$1, { next: createPropertyDescriptor$1(+!ENUMERABLE_NEXT, next) });
      setToStringTag$5(IteratorConstructor, TO_STRING_TAG, false);
      Iterators$2[TO_STRING_TAG] = returnThis$1;
      return IteratorConstructor;
    };

    var $$m = _export;
    var call$5 = functionCall;
    var FunctionName = functionName;
    var isCallable$1 = isCallable$q;
    var createIteratorConstructor = createIteratorConstructor$1;
    var getPrototypeOf$2 = objectGetPrototypeOf$1;
    var setPrototypeOf = objectSetPrototypeOf;
    var setToStringTag$4 = setToStringTag$8;
    var createNonEnumerableProperty$2 = createNonEnumerableProperty$7;
    var defineBuiltIn$4 = defineBuiltIn$e;
    var wellKnownSymbol$2 = wellKnownSymbol$q;
    var Iterators$1 = iterators;
    var IteratorsCore = iteratorsCore;

    var PROPER_FUNCTION_NAME$2 = FunctionName.PROPER;
    var CONFIGURABLE_FUNCTION_NAME = FunctionName.CONFIGURABLE;
    var IteratorPrototype = IteratorsCore.IteratorPrototype;
    var BUGGY_SAFARI_ITERATORS = IteratorsCore.BUGGY_SAFARI_ITERATORS;
    var ITERATOR$1 = wellKnownSymbol$2('iterator');
    var KEYS = 'keys';
    var VALUES = 'values';
    var ENTRIES = 'entries';

    var returnThis = function () { return this; };

    var defineIterator$3 = function (Iterable, NAME, IteratorConstructor, next, DEFAULT, IS_SET, FORCED) {
      createIteratorConstructor(IteratorConstructor, NAME, next);

      var getIterationMethod = function (KIND) {
        if (KIND === DEFAULT && defaultIterator) return defaultIterator;
        if (!BUGGY_SAFARI_ITERATORS && KIND in IterablePrototype) return IterablePrototype[KIND];
        switch (KIND) {
          case KEYS: return function keys() { return new IteratorConstructor(this, KIND); };
          case VALUES: return function values() { return new IteratorConstructor(this, KIND); };
          case ENTRIES: return function entries() { return new IteratorConstructor(this, KIND); };
        } return function () { return new IteratorConstructor(this); };
      };

      var TO_STRING_TAG = NAME + ' Iterator';
      var INCORRECT_VALUES_NAME = false;
      var IterablePrototype = Iterable.prototype;
      var nativeIterator = IterablePrototype[ITERATOR$1]
        || IterablePrototype['@@iterator']
        || DEFAULT && IterablePrototype[DEFAULT];
      var defaultIterator = !BUGGY_SAFARI_ITERATORS && nativeIterator || getIterationMethod(DEFAULT);
      var anyNativeIterator = NAME == 'Array' ? IterablePrototype.entries || nativeIterator : nativeIterator;
      var CurrentIteratorPrototype, methods, KEY;

      // fix native
      if (anyNativeIterator) {
        CurrentIteratorPrototype = getPrototypeOf$2(anyNativeIterator.call(new Iterable()));
        if (CurrentIteratorPrototype !== Object.prototype && CurrentIteratorPrototype.next) {
          if (getPrototypeOf$2(CurrentIteratorPrototype) !== IteratorPrototype) {
            if (setPrototypeOf) {
              setPrototypeOf(CurrentIteratorPrototype, IteratorPrototype);
            } else if (!isCallable$1(CurrentIteratorPrototype[ITERATOR$1])) {
              defineBuiltIn$4(CurrentIteratorPrototype, ITERATOR$1, returnThis);
            }
          }
          // Set @@toStringTag to native iterators
          setToStringTag$4(CurrentIteratorPrototype, TO_STRING_TAG, true);
        }
      }

      // fix Array.prototype.{ values, @@iterator }.name in V8 / FF
      if (PROPER_FUNCTION_NAME$2 && DEFAULT == VALUES && nativeIterator && nativeIterator.name !== VALUES) {
        if (CONFIGURABLE_FUNCTION_NAME) {
          createNonEnumerableProperty$2(IterablePrototype, 'name', VALUES);
        } else {
          INCORRECT_VALUES_NAME = true;
          defaultIterator = function values() { return call$5(nativeIterator, this); };
        }
      }

      // export additional methods
      if (DEFAULT) {
        methods = {
          values: getIterationMethod(VALUES),
          keys: IS_SET ? defaultIterator : getIterationMethod(KEYS),
          entries: getIterationMethod(ENTRIES)
        };
        if (FORCED) for (KEY in methods) {
          if (BUGGY_SAFARI_ITERATORS || INCORRECT_VALUES_NAME || !(KEY in IterablePrototype)) {
            defineBuiltIn$4(IterablePrototype, KEY, methods[KEY]);
          }
        } else $$m({ target: NAME, proto: true, forced: BUGGY_SAFARI_ITERATORS || INCORRECT_VALUES_NAME }, methods);
      }

      // define iterator
      if (IterablePrototype[ITERATOR$1] !== defaultIterator) {
        defineBuiltIn$4(IterablePrototype, ITERATOR$1, defaultIterator, { name: DEFAULT });
      }
      Iterators$1[NAME] = defaultIterator;

      return methods;
    };

    var toIndexedObject = toIndexedObject$9;
    var addToUnscopables$1 = addToUnscopables$3;
    var Iterators = iterators;
    var InternalStateModule$3 = internalState;
    var defineProperty$4 = objectDefineProperty.f;
    var defineIterator$2 = defineIterator$3;
    var DESCRIPTORS$4 = descriptors;

    var ARRAY_ITERATOR = 'Array Iterator';
    var setInternalState$3 = InternalStateModule$3.set;
    var getInternalState$1 = InternalStateModule$3.getterFor(ARRAY_ITERATOR);

    // `Array.prototype.entries` method
    // https://tc39.es/ecma262/#sec-array.prototype.entries
    // `Array.prototype.keys` method
    // https://tc39.es/ecma262/#sec-array.prototype.keys
    // `Array.prototype.values` method
    // https://tc39.es/ecma262/#sec-array.prototype.values
    // `Array.prototype[@@iterator]` method
    // https://tc39.es/ecma262/#sec-array.prototype-@@iterator
    // `CreateArrayIterator` internal method
    // https://tc39.es/ecma262/#sec-createarrayiterator
    var es_array_iterator = defineIterator$2(Array, 'Array', function (iterated, kind) {
      setInternalState$3(this, {
        type: ARRAY_ITERATOR,
        target: toIndexedObject(iterated), // target
        index: 0,                          // next index
        kind: kind                         // kind
      });
    // `%ArrayIteratorPrototype%.next` method
    // https://tc39.es/ecma262/#sec-%arrayiteratorprototype%.next
    }, function () {
      var state = getInternalState$1(this);
      var target = state.target;
      var kind = state.kind;
      var index = state.index++;
      if (!target || index >= target.length) {
        state.target = undefined;
        return { value: undefined, done: true };
      }
      if (kind == 'keys') return { value: index, done: false };
      if (kind == 'values') return { value: target[index], done: false };
      return { value: [index, target[index]], done: false };
    }, 'values');

    // argumentsList[@@iterator] is %ArrayProto_values%
    // https://tc39.es/ecma262/#sec-createunmappedargumentsobject
    // https://tc39.es/ecma262/#sec-createmappedargumentsobject
    var values = Iterators.Arguments = Iterators.Array;

    // https://tc39.es/ecma262/#sec-array.prototype-@@unscopables
    addToUnscopables$1('keys');
    addToUnscopables$1('values');
    addToUnscopables$1('entries');

    // V8 ~ Chrome 45- bug
    if (DESCRIPTORS$4 && values.name !== 'values') try {
      defineProperty$4(values, 'name', { value: 'values' });
    } catch (error) { /* empty */ }

    var internalMetadata = {exports: {}};

    // FF26- bug: ArrayBuffers are non-extensible, but Object.isExtensible does not report it
    var fails$c = fails$F;

    var arrayBufferNonExtensible = fails$c(function () {
      if (typeof ArrayBuffer == 'function') {
        var buffer = new ArrayBuffer(8);
        // eslint-disable-next-line es-x/no-object-isextensible, es-x/no-object-defineproperty -- safe
        if (Object.isExtensible(buffer)) Object.defineProperty(buffer, 'a', { value: 8 });
      }
    });

    var fails$b = fails$F;
    var isObject$9 = isObject$n;
    var classof = classofRaw$1;
    var ARRAY_BUFFER_NON_EXTENSIBLE = arrayBufferNonExtensible;

    // eslint-disable-next-line es-x/no-object-isextensible -- safe
    var $isExtensible$1 = Object.isExtensible;
    var FAILS_ON_PRIMITIVES$2 = fails$b(function () { $isExtensible$1(1); });

    // `Object.isExtensible` method
    // https://tc39.es/ecma262/#sec-object.isextensible
    var objectIsExtensible = (FAILS_ON_PRIMITIVES$2 || ARRAY_BUFFER_NON_EXTENSIBLE) ? function isExtensible(it) {
      if (!isObject$9(it)) return false;
      if (ARRAY_BUFFER_NON_EXTENSIBLE && classof(it) == 'ArrayBuffer') return false;
      return $isExtensible$1 ? $isExtensible$1(it) : true;
    } : $isExtensible$1;

    var fails$a = fails$F;

    var freezing = !fails$a(function () {
      // eslint-disable-next-line es-x/no-object-isextensible, es-x/no-object-preventextensions -- required for testing
      return Object.isExtensible(Object.preventExtensions({}));
    });

    var $$l = _export;
    var uncurryThis$6 = functionUncurryThis;
    var hiddenKeys = hiddenKeys$6;
    var isObject$8 = isObject$n;
    var hasOwn$5 = hasOwnProperty_1;
    var defineProperty$3 = objectDefineProperty.f;
    var getOwnPropertyNamesModule = objectGetOwnPropertyNames;
    var getOwnPropertyNamesExternalModule = objectGetOwnPropertyNamesExternal;
    var isExtensible$1 = objectIsExtensible;
    var uid = uid$4;
    var FREEZING$1 = freezing;

    var REQUIRED = false;
    var METADATA = uid('meta');
    var id$1 = 0;

    var setMetadata = function (it) {
      defineProperty$3(it, METADATA, { value: {
        objectID: 'O' + id$1++, // object ID
        weakData: {}          // weak collections IDs
      } });
    };

    var fastKey$1 = function (it, create) {
      // return a primitive with prefix
      if (!isObject$8(it)) return typeof it == 'symbol' ? it : (typeof it == 'string' ? 'S' : 'P') + it;
      if (!hasOwn$5(it, METADATA)) {
        // can't set metadata to uncaught frozen object
        if (!isExtensible$1(it)) return 'F';
        // not necessary to add metadata
        if (!create) return 'E';
        // add missing metadata
        setMetadata(it);
      // return object ID
      } return it[METADATA].objectID;
    };

    var getWeakData$1 = function (it, create) {
      if (!hasOwn$5(it, METADATA)) {
        // can't set metadata to uncaught frozen object
        if (!isExtensible$1(it)) return true;
        // not necessary to add metadata
        if (!create) return false;
        // add missing metadata
        setMetadata(it);
      // return the store of weak collections IDs
      } return it[METADATA].weakData;
    };

    // add metadata on freeze-family methods calling
    var onFreeze$1 = function (it) {
      if (FREEZING$1 && REQUIRED && isExtensible$1(it) && !hasOwn$5(it, METADATA)) setMetadata(it);
      return it;
    };

    var enable = function () {
      meta.enable = function () { /* empty */ };
      REQUIRED = true;
      var getOwnPropertyNames = getOwnPropertyNamesModule.f;
      var splice = uncurryThis$6([].splice);
      var test = {};
      test[METADATA] = 1;

      // prevent exposing of metadata key
      if (getOwnPropertyNames(test).length) {
        getOwnPropertyNamesModule.f = function (it) {
          var result = getOwnPropertyNames(it);
          for (var i = 0, length = result.length; i < length; i++) {
            if (result[i] === METADATA) {
              splice(result, i, 1);
              break;
            }
          } return result;
        };

        $$l({ target: 'Object', stat: true, forced: true }, {
          getOwnPropertyNames: getOwnPropertyNamesExternalModule.f
        });
      }
    };

    var meta = internalMetadata.exports = {
      enable: enable,
      fastKey: fastKey$1,
      getWeakData: getWeakData$1,
      onFreeze: onFreeze$1
    };

    hiddenKeys[METADATA] = true;

    var $$k = _export;
    var global$6 = global$w;
    var uncurryThis$5 = functionUncurryThis;
    var isForced$1 = isForced_1;
    var defineBuiltIn$3 = defineBuiltIn$e;
    var InternalMetadataModule$1 = internalMetadata.exports;
    var iterate$2 = iterate$5;
    var anInstance$2 = anInstance$4;
    var isCallable = isCallable$q;
    var isObject$7 = isObject$n;
    var fails$9 = fails$F;
    var checkCorrectnessOfIteration$1 = checkCorrectnessOfIteration$3;
    var setToStringTag$3 = setToStringTag$8;
    var inheritIfRequired$1 = inheritIfRequired$3;

    var collection$3 = function (CONSTRUCTOR_NAME, wrapper, common) {
      var IS_MAP = CONSTRUCTOR_NAME.indexOf('Map') !== -1;
      var IS_WEAK = CONSTRUCTOR_NAME.indexOf('Weak') !== -1;
      var ADDER = IS_MAP ? 'set' : 'add';
      var NativeConstructor = global$6[CONSTRUCTOR_NAME];
      var NativePrototype = NativeConstructor && NativeConstructor.prototype;
      var Constructor = NativeConstructor;
      var exported = {};

      var fixMethod = function (KEY) {
        var uncurriedNativeMethod = uncurryThis$5(NativePrototype[KEY]);
        defineBuiltIn$3(NativePrototype, KEY,
          KEY == 'add' ? function add(value) {
            uncurriedNativeMethod(this, value === 0 ? 0 : value);
            return this;
          } : KEY == 'delete' ? function (key) {
            return IS_WEAK && !isObject$7(key) ? false : uncurriedNativeMethod(this, key === 0 ? 0 : key);
          } : KEY == 'get' ? function get(key) {
            return IS_WEAK && !isObject$7(key) ? undefined : uncurriedNativeMethod(this, key === 0 ? 0 : key);
          } : KEY == 'has' ? function has(key) {
            return IS_WEAK && !isObject$7(key) ? false : uncurriedNativeMethod(this, key === 0 ? 0 : key);
          } : function set(key, value) {
            uncurriedNativeMethod(this, key === 0 ? 0 : key, value);
            return this;
          }
        );
      };

      var REPLACE = isForced$1(
        CONSTRUCTOR_NAME,
        !isCallable(NativeConstructor) || !(IS_WEAK || NativePrototype.forEach && !fails$9(function () {
          new NativeConstructor().entries().next();
        }))
      );

      if (REPLACE) {
        // create collection constructor
        Constructor = common.getConstructor(wrapper, CONSTRUCTOR_NAME, IS_MAP, ADDER);
        InternalMetadataModule$1.enable();
      } else if (isForced$1(CONSTRUCTOR_NAME, true)) {
        var instance = new Constructor();
        // early implementations not supports chaining
        var HASNT_CHAINING = instance[ADDER](IS_WEAK ? {} : -0, 1) != instance;
        // V8 ~ Chromium 40- weak-collections throws on primitives, but should return false
        var THROWS_ON_PRIMITIVES = fails$9(function () { instance.has(1); });
        // most early implementations doesn't supports iterables, most modern - not close it correctly
        // eslint-disable-next-line no-new -- required for testing
        var ACCEPT_ITERABLES = checkCorrectnessOfIteration$1(function (iterable) { new NativeConstructor(iterable); });
        // for early implementations -0 and +0 not the same
        var BUGGY_ZERO = !IS_WEAK && fails$9(function () {
          // V8 ~ Chromium 42- fails only with 5+ elements
          var $instance = new NativeConstructor();
          var index = 5;
          while (index--) $instance[ADDER](index, index);
          return !$instance.has(-0);
        });

        if (!ACCEPT_ITERABLES) {
          Constructor = wrapper(function (dummy, iterable) {
            anInstance$2(dummy, NativePrototype);
            var that = inheritIfRequired$1(new NativeConstructor(), dummy, Constructor);
            if (iterable != undefined) iterate$2(iterable, that[ADDER], { that: that, AS_ENTRIES: IS_MAP });
            return that;
          });
          Constructor.prototype = NativePrototype;
          NativePrototype.constructor = Constructor;
        }

        if (THROWS_ON_PRIMITIVES || BUGGY_ZERO) {
          fixMethod('delete');
          fixMethod('has');
          IS_MAP && fixMethod('get');
        }

        if (BUGGY_ZERO || HASNT_CHAINING) fixMethod(ADDER);

        // weak collections should not contains .clear method
        if (IS_WEAK && NativePrototype.clear) delete NativePrototype.clear;
      }

      exported[CONSTRUCTOR_NAME] = Constructor;
      $$k({ global: true, constructor: true, forced: Constructor != NativeConstructor }, exported);

      setToStringTag$3(Constructor, CONSTRUCTOR_NAME);

      if (!IS_WEAK) common.setStrong(Constructor, CONSTRUCTOR_NAME, IS_MAP);

      return Constructor;
    };

    var defineBuiltIn$2 = defineBuiltIn$e;

    var defineBuiltIns$3 = function (target, src, options) {
      for (var key in src) defineBuiltIn$2(target, key, src[key], options);
      return target;
    };

    var defineProperty$2 = objectDefineProperty.f;
    var create = objectCreate;
    var defineBuiltIns$2 = defineBuiltIns$3;
    var bind$1 = functionBindContext;
    var anInstance$1 = anInstance$4;
    var iterate$1 = iterate$5;
    var defineIterator$1 = defineIterator$3;
    var setSpecies$1 = setSpecies$3;
    var DESCRIPTORS$3 = descriptors;
    var fastKey = internalMetadata.exports.fastKey;
    var InternalStateModule$2 = internalState;

    var setInternalState$2 = InternalStateModule$2.set;
    var internalStateGetterFor$1 = InternalStateModule$2.getterFor;

    var collectionStrong$2 = {
      getConstructor: function (wrapper, CONSTRUCTOR_NAME, IS_MAP, ADDER) {
        var Constructor = wrapper(function (that, iterable) {
          anInstance$1(that, Prototype);
          setInternalState$2(that, {
            type: CONSTRUCTOR_NAME,
            index: create(null),
            first: undefined,
            last: undefined,
            size: 0
          });
          if (!DESCRIPTORS$3) that.size = 0;
          if (iterable != undefined) iterate$1(iterable, that[ADDER], { that: that, AS_ENTRIES: IS_MAP });
        });

        var Prototype = Constructor.prototype;

        var getInternalState = internalStateGetterFor$1(CONSTRUCTOR_NAME);

        var define = function (that, key, value) {
          var state = getInternalState(that);
          var entry = getEntry(that, key);
          var previous, index;
          // change existing entry
          if (entry) {
            entry.value = value;
          // create new entry
          } else {
            state.last = entry = {
              index: index = fastKey(key, true),
              key: key,
              value: value,
              previous: previous = state.last,
              next: undefined,
              removed: false
            };
            if (!state.first) state.first = entry;
            if (previous) previous.next = entry;
            if (DESCRIPTORS$3) state.size++;
            else that.size++;
            // add to index
            if (index !== 'F') state.index[index] = entry;
          } return that;
        };

        var getEntry = function (that, key) {
          var state = getInternalState(that);
          // fast case
          var index = fastKey(key);
          var entry;
          if (index !== 'F') return state.index[index];
          // frozen object case
          for (entry = state.first; entry; entry = entry.next) {
            if (entry.key == key) return entry;
          }
        };

        defineBuiltIns$2(Prototype, {
          // `{ Map, Set }.prototype.clear()` methods
          // https://tc39.es/ecma262/#sec-map.prototype.clear
          // https://tc39.es/ecma262/#sec-set.prototype.clear
          clear: function clear() {
            var that = this;
            var state = getInternalState(that);
            var data = state.index;
            var entry = state.first;
            while (entry) {
              entry.removed = true;
              if (entry.previous) entry.previous = entry.previous.next = undefined;
              delete data[entry.index];
              entry = entry.next;
            }
            state.first = state.last = undefined;
            if (DESCRIPTORS$3) state.size = 0;
            else that.size = 0;
          },
          // `{ Map, Set }.prototype.delete(key)` methods
          // https://tc39.es/ecma262/#sec-map.prototype.delete
          // https://tc39.es/ecma262/#sec-set.prototype.delete
          'delete': function (key) {
            var that = this;
            var state = getInternalState(that);
            var entry = getEntry(that, key);
            if (entry) {
              var next = entry.next;
              var prev = entry.previous;
              delete state.index[entry.index];
              entry.removed = true;
              if (prev) prev.next = next;
              if (next) next.previous = prev;
              if (state.first == entry) state.first = next;
              if (state.last == entry) state.last = prev;
              if (DESCRIPTORS$3) state.size--;
              else that.size--;
            } return !!entry;
          },
          // `{ Map, Set }.prototype.forEach(callbackfn, thisArg = undefined)` methods
          // https://tc39.es/ecma262/#sec-map.prototype.foreach
          // https://tc39.es/ecma262/#sec-set.prototype.foreach
          forEach: function forEach(callbackfn /* , that = undefined */) {
            var state = getInternalState(this);
            var boundFunction = bind$1(callbackfn, arguments.length > 1 ? arguments[1] : undefined);
            var entry;
            while (entry = entry ? entry.next : state.first) {
              boundFunction(entry.value, entry.key, this);
              // revert to the last existing entry
              while (entry && entry.removed) entry = entry.previous;
            }
          },
          // `{ Map, Set}.prototype.has(key)` methods
          // https://tc39.es/ecma262/#sec-map.prototype.has
          // https://tc39.es/ecma262/#sec-set.prototype.has
          has: function has(key) {
            return !!getEntry(this, key);
          }
        });

        defineBuiltIns$2(Prototype, IS_MAP ? {
          // `Map.prototype.get(key)` method
          // https://tc39.es/ecma262/#sec-map.prototype.get
          get: function get(key) {
            var entry = getEntry(this, key);
            return entry && entry.value;
          },
          // `Map.prototype.set(key, value)` method
          // https://tc39.es/ecma262/#sec-map.prototype.set
          set: function set(key, value) {
            return define(this, key === 0 ? 0 : key, value);
          }
        } : {
          // `Set.prototype.add(value)` method
          // https://tc39.es/ecma262/#sec-set.prototype.add
          add: function add(value) {
            return define(this, value = value === 0 ? 0 : value, value);
          }
        });
        if (DESCRIPTORS$3) defineProperty$2(Prototype, 'size', {
          get: function () {
            return getInternalState(this).size;
          }
        });
        return Constructor;
      },
      setStrong: function (Constructor, CONSTRUCTOR_NAME, IS_MAP) {
        var ITERATOR_NAME = CONSTRUCTOR_NAME + ' Iterator';
        var getInternalCollectionState = internalStateGetterFor$1(CONSTRUCTOR_NAME);
        var getInternalIteratorState = internalStateGetterFor$1(ITERATOR_NAME);
        // `{ Map, Set }.prototype.{ keys, values, entries, @@iterator }()` methods
        // https://tc39.es/ecma262/#sec-map.prototype.entries
        // https://tc39.es/ecma262/#sec-map.prototype.keys
        // https://tc39.es/ecma262/#sec-map.prototype.values
        // https://tc39.es/ecma262/#sec-map.prototype-@@iterator
        // https://tc39.es/ecma262/#sec-set.prototype.entries
        // https://tc39.es/ecma262/#sec-set.prototype.keys
        // https://tc39.es/ecma262/#sec-set.prototype.values
        // https://tc39.es/ecma262/#sec-set.prototype-@@iterator
        defineIterator$1(Constructor, CONSTRUCTOR_NAME, function (iterated, kind) {
          setInternalState$2(this, {
            type: ITERATOR_NAME,
            target: iterated,
            state: getInternalCollectionState(iterated),
            kind: kind,
            last: undefined
          });
        }, function () {
          var state = getInternalIteratorState(this);
          var kind = state.kind;
          var entry = state.last;
          // revert to the last existing entry
          while (entry && entry.removed) entry = entry.previous;
          // get next entry
          if (!state.target || !(state.last = entry = entry ? entry.next : state.state.first)) {
            // or finish the iteration
            state.target = undefined;
            return { value: undefined, done: true };
          }
          // return step by kind
          if (kind == 'keys') return { value: entry.key, done: false };
          if (kind == 'values') return { value: entry.value, done: false };
          return { value: [entry.key, entry.value], done: false };
        }, IS_MAP ? 'entries' : 'values', !IS_MAP, true);

        // `{ Map, Set }.prototype[@@species]` accessors
        // https://tc39.es/ecma262/#sec-get-map-@@species
        // https://tc39.es/ecma262/#sec-get-set-@@species
        setSpecies$1(CONSTRUCTOR_NAME);
      }
    };

    var collection$2 = collection$3;
    var collectionStrong$1 = collectionStrong$2;

    // `Set` constructor
    // https://tc39.es/ecma262/#sec-set-objects
    collection$2('Set', function (init) {
      return function Set() { return init(this, arguments.length ? arguments[0] : undefined); };
    }, collectionStrong$1);

    var charAt$1 = stringMultibyte.charAt;
    var toString$3 = toString$g;
    var InternalStateModule$1 = internalState;
    var defineIterator = defineIterator$3;

    var STRING_ITERATOR = 'String Iterator';
    var setInternalState$1 = InternalStateModule$1.set;
    var getInternalState = InternalStateModule$1.getterFor(STRING_ITERATOR);

    // `String.prototype[@@iterator]` method
    // https://tc39.es/ecma262/#sec-string.prototype-@@iterator
    defineIterator(String, 'String', function (iterated) {
      setInternalState$1(this, {
        type: STRING_ITERATOR,
        string: toString$3(iterated),
        index: 0
      });
    // `%StringIteratorPrototype%.next` method
    // https://tc39.es/ecma262/#sec-%stringiteratorprototype%.next
    }, function next() {
      var state = getInternalState(this);
      var string = state.string;
      var index = state.index;
      var point;
      if (index >= string.length) return { value: undefined, done: true };
      point = charAt$1(string, index);
      state.index += point.length;
      return { value: point, done: false };
    });

    var global$5 = global$w;
    var DOMIterables = domIterables;
    var DOMTokenListPrototype = domTokenListPrototype;
    var ArrayIteratorMethods = es_array_iterator;
    var createNonEnumerableProperty$1 = createNonEnumerableProperty$7;
    var wellKnownSymbol$1 = wellKnownSymbol$q;

    var ITERATOR = wellKnownSymbol$1('iterator');
    var TO_STRING_TAG = wellKnownSymbol$1('toStringTag');
    var ArrayValues = ArrayIteratorMethods.values;

    var handlePrototype = function (CollectionPrototype, COLLECTION_NAME) {
      if (CollectionPrototype) {
        // some Chrome versions have non-configurable methods on DOMTokenList
        if (CollectionPrototype[ITERATOR] !== ArrayValues) try {
          createNonEnumerableProperty$1(CollectionPrototype, ITERATOR, ArrayValues);
        } catch (error) {
          CollectionPrototype[ITERATOR] = ArrayValues;
        }
        if (!CollectionPrototype[TO_STRING_TAG]) {
          createNonEnumerableProperty$1(CollectionPrototype, TO_STRING_TAG, COLLECTION_NAME);
        }
        if (DOMIterables[COLLECTION_NAME]) for (var METHOD_NAME in ArrayIteratorMethods) {
          // some Chrome versions have non-configurable methods on DOMTokenList
          if (CollectionPrototype[METHOD_NAME] !== ArrayIteratorMethods[METHOD_NAME]) try {
            createNonEnumerableProperty$1(CollectionPrototype, METHOD_NAME, ArrayIteratorMethods[METHOD_NAME]);
          } catch (error) {
            CollectionPrototype[METHOD_NAME] = ArrayIteratorMethods[METHOD_NAME];
          }
        }
      }
    };

    for (var COLLECTION_NAME in DOMIterables) {
      handlePrototype(global$5[COLLECTION_NAME] && global$5[COLLECTION_NAME].prototype, COLLECTION_NAME);
    }

    handlePrototype(DOMTokenListPrototype, 'DOMTokenList');

    var uncurryThis$4 = functionUncurryThis;
    var defineBuiltIns$1 = defineBuiltIns$3;
    var getWeakData = internalMetadata.exports.getWeakData;
    var anObject$7 = anObject$o;
    var isObject$6 = isObject$n;
    var anInstance = anInstance$4;
    var iterate = iterate$5;
    var ArrayIterationModule = arrayIteration;
    var hasOwn$4 = hasOwnProperty_1;
    var InternalStateModule = internalState;

    var setInternalState = InternalStateModule.set;
    var internalStateGetterFor = InternalStateModule.getterFor;
    var find = ArrayIterationModule.find;
    var findIndex = ArrayIterationModule.findIndex;
    var splice = uncurryThis$4([].splice);
    var id = 0;

    // fallback for uncaught frozen keys
    var uncaughtFrozenStore = function (store) {
      return store.frozen || (store.frozen = new UncaughtFrozenStore());
    };

    var UncaughtFrozenStore = function () {
      this.entries = [];
    };

    var findUncaughtFrozen = function (store, key) {
      return find(store.entries, function (it) {
        return it[0] === key;
      });
    };

    UncaughtFrozenStore.prototype = {
      get: function (key) {
        var entry = findUncaughtFrozen(this, key);
        if (entry) return entry[1];
      },
      has: function (key) {
        return !!findUncaughtFrozen(this, key);
      },
      set: function (key, value) {
        var entry = findUncaughtFrozen(this, key);
        if (entry) entry[1] = value;
        else this.entries.push([key, value]);
      },
      'delete': function (key) {
        var index = findIndex(this.entries, function (it) {
          return it[0] === key;
        });
        if (~index) splice(this.entries, index, 1);
        return !!~index;
      }
    };

    var collectionWeak$1 = {
      getConstructor: function (wrapper, CONSTRUCTOR_NAME, IS_MAP, ADDER) {
        var Constructor = wrapper(function (that, iterable) {
          anInstance(that, Prototype);
          setInternalState(that, {
            type: CONSTRUCTOR_NAME,
            id: id++,
            frozen: undefined
          });
          if (iterable != undefined) iterate(iterable, that[ADDER], { that: that, AS_ENTRIES: IS_MAP });
        });

        var Prototype = Constructor.prototype;

        var getInternalState = internalStateGetterFor(CONSTRUCTOR_NAME);

        var define = function (that, key, value) {
          var state = getInternalState(that);
          var data = getWeakData(anObject$7(key), true);
          if (data === true) uncaughtFrozenStore(state).set(key, value);
          else data[state.id] = value;
          return that;
        };

        defineBuiltIns$1(Prototype, {
          // `{ WeakMap, WeakSet }.prototype.delete(key)` methods
          // https://tc39.es/ecma262/#sec-weakmap.prototype.delete
          // https://tc39.es/ecma262/#sec-weakset.prototype.delete
          'delete': function (key) {
            var state = getInternalState(this);
            if (!isObject$6(key)) return false;
            var data = getWeakData(key);
            if (data === true) return uncaughtFrozenStore(state)['delete'](key);
            return data && hasOwn$4(data, state.id) && delete data[state.id];
          },
          // `{ WeakMap, WeakSet }.prototype.has(key)` methods
          // https://tc39.es/ecma262/#sec-weakmap.prototype.has
          // https://tc39.es/ecma262/#sec-weakset.prototype.has
          has: function has(key) {
            var state = getInternalState(this);
            if (!isObject$6(key)) return false;
            var data = getWeakData(key);
            if (data === true) return uncaughtFrozenStore(state).has(key);
            return data && hasOwn$4(data, state.id);
          }
        });

        defineBuiltIns$1(Prototype, IS_MAP ? {
          // `WeakMap.prototype.get(key)` method
          // https://tc39.es/ecma262/#sec-weakmap.prototype.get
          get: function get(key) {
            var state = getInternalState(this);
            if (isObject$6(key)) {
              var data = getWeakData(key);
              if (data === true) return uncaughtFrozenStore(state).get(key);
              return data ? data[state.id] : undefined;
            }
          },
          // `WeakMap.prototype.set(key, value)` method
          // https://tc39.es/ecma262/#sec-weakmap.prototype.set
          set: function set(key, value) {
            return define(this, key, value);
          }
        } : {
          // `WeakSet.prototype.add(value)` method
          // https://tc39.es/ecma262/#sec-weakset.prototype.add
          add: function add(value) {
            return define(this, value, true);
          }
        });

        return Constructor;
      }
    };

    var global$4 = global$w;
    var uncurryThis$3 = functionUncurryThis;
    var defineBuiltIns = defineBuiltIns$3;
    var InternalMetadataModule = internalMetadata.exports;
    var collection$1 = collection$3;
    var collectionWeak = collectionWeak$1;
    var isObject$5 = isObject$n;
    var isExtensible = objectIsExtensible;
    var enforceInternalState$1 = internalState.enforce;
    var NATIVE_WEAK_MAP = nativeWeakMap;

    var IS_IE11 = !global$4.ActiveXObject && 'ActiveXObject' in global$4;
    var InternalWeakMap;

    var wrapper = function (init) {
      return function WeakMap() {
        return init(this, arguments.length ? arguments[0] : undefined);
      };
    };

    // `WeakMap` constructor
    // https://tc39.es/ecma262/#sec-weakmap-constructor
    var $WeakMap = collection$1('WeakMap', wrapper, collectionWeak);

    // IE11 WeakMap frozen keys fix
    // We can't use feature detection because it crash some old IE builds
    // https://github.com/zloirock/core-js/issues/485
    if (NATIVE_WEAK_MAP && IS_IE11) {
      InternalWeakMap = collectionWeak.getConstructor(wrapper, 'WeakMap', true);
      InternalMetadataModule.enable();
      var WeakMapPrototype = $WeakMap.prototype;
      var nativeDelete = uncurryThis$3(WeakMapPrototype['delete']);
      var nativeHas = uncurryThis$3(WeakMapPrototype.has);
      var nativeGet = uncurryThis$3(WeakMapPrototype.get);
      var nativeSet = uncurryThis$3(WeakMapPrototype.set);
      defineBuiltIns(WeakMapPrototype, {
        'delete': function (key) {
          if (isObject$5(key) && !isExtensible(key)) {
            var state = enforceInternalState$1(this);
            if (!state.frozen) state.frozen = new InternalWeakMap();
            return nativeDelete(this, key) || state.frozen['delete'](key);
          } return nativeDelete(this, key);
        },
        has: function has(key) {
          if (isObject$5(key) && !isExtensible(key)) {
            var state = enforceInternalState$1(this);
            if (!state.frozen) state.frozen = new InternalWeakMap();
            return nativeHas(this, key) || state.frozen.has(key);
          } return nativeHas(this, key);
        },
        get: function get(key) {
          if (isObject$5(key) && !isExtensible(key)) {
            var state = enforceInternalState$1(this);
            if (!state.frozen) state.frozen = new InternalWeakMap();
            return nativeHas(this, key) ? nativeGet(this, key) : state.frozen.get(key);
          } return nativeGet(this, key);
        },
        set: function set(key, value) {
          if (isObject$5(key) && !isExtensible(key)) {
            var state = enforceInternalState$1(this);
            if (!state.frozen) state.frozen = new InternalWeakMap();
            nativeHas(this, key) ? nativeSet(this, key, value) : state.frozen.set(key, value);
          } else nativeSet(this, key, value);
          return this;
        }
      });
    }

    var $$j = _export;
    var $filter = arrayIteration.filter;
    var arrayMethodHasSpeciesSupport = arrayMethodHasSpeciesSupport$5;

    var HAS_SPECIES_SUPPORT = arrayMethodHasSpeciesSupport('filter');

    // `Array.prototype.filter` method
    // https://tc39.es/ecma262/#sec-array.prototype.filter
    // with adding support of @@species
    $$j({ target: 'Array', proto: true, forced: !HAS_SPECIES_SUPPORT }, {
      filter: function filter(callbackfn /* , thisArg */) {
        return $filter(this, callbackfn, arguments.length > 1 ? arguments[1] : undefined);
      }
    });

    var PROPER_FUNCTION_NAME$1 = functionName.PROPER;
    var fails$8 = fails$F;
    var whitespaces = whitespaces$2;

    var non = '\u200B\u0085\u180E';

    // check that a method works with the correct list
    // of whitespaces and has a correct name
    var stringTrimForced = function (METHOD_NAME) {
      return fails$8(function () {
        return !!whitespaces[METHOD_NAME]()
          || non[METHOD_NAME]() !== non
          || (PROPER_FUNCTION_NAME$1 && whitespaces[METHOD_NAME].name !== METHOD_NAME);
      });
    };

    var $$i = _export;
    var $trim = stringTrim.trim;
    var forcedStringTrimMethod = stringTrimForced;

    // `String.prototype.trim` method
    // https://tc39.es/ecma262/#sec-string.prototype.trim
    $$i({ target: 'String', proto: true, forced: forcedStringTrimMethod('trim') }, {
      trim: function trim() {
        return $trim(this);
      }
    });

    var collection = collection$3;
    var collectionStrong = collectionStrong$2;

    // `Map` constructor
    // https://tc39.es/ecma262/#sec-map-objects
    collection('Map', function (init) {
      return function Map() { return init(this, arguments.length ? arguments[0] : undefined); };
    }, collectionStrong);

    var arraySlice = arraySliceSimple;

    var floor$1 = Math.floor;

    var mergeSort = function (array, comparefn) {
      var length = array.length;
      var middle = floor$1(length / 2);
      return length < 8 ? insertionSort(array, comparefn) : merge(
        array,
        mergeSort(arraySlice(array, 0, middle), comparefn),
        mergeSort(arraySlice(array, middle), comparefn),
        comparefn
      );
    };

    var insertionSort = function (array, comparefn) {
      var length = array.length;
      var i = 1;
      var element, j;

      while (i < length) {
        j = i;
        element = array[i];
        while (j && comparefn(array[j - 1], element) > 0) {
          array[j] = array[--j];
        }
        if (j !== i++) array[j] = element;
      } return array;
    };

    var merge = function (array, left, right, comparefn) {
      var llength = left.length;
      var rlength = right.length;
      var lindex = 0;
      var rindex = 0;

      while (lindex < llength || rindex < rlength) {
        array[lindex + rindex] = (lindex < llength && rindex < rlength)
          ? comparefn(left[lindex], right[rindex]) <= 0 ? left[lindex++] : right[rindex++]
          : lindex < llength ? left[lindex++] : right[rindex++];
      } return array;
    };

    var arraySort = mergeSort;

    var userAgent$1 = engineUserAgent;

    var firefox = userAgent$1.match(/firefox\/(\d+)/i);

    var engineFfVersion = !!firefox && +firefox[1];

    var UA = engineUserAgent;

    var engineIsIeOrEdge = /MSIE|Trident/.test(UA);

    var userAgent = engineUserAgent;

    var webkit = userAgent.match(/AppleWebKit\/(\d+)\./);

    var engineWebkitVersion = !!webkit && +webkit[1];

    var $$h = _export;
    var uncurryThis$2 = functionUncurryThis;
    var aCallable = aCallable$8;
    var toObject$2 = toObject$b;
    var lengthOfArrayLike$1 = lengthOfArrayLike$9;
    var deletePropertyOrThrow = deletePropertyOrThrow$2;
    var toString$2 = toString$g;
    var fails$7 = fails$F;
    var internalSort = arraySort;
    var arrayMethodIsStrict = arrayMethodIsStrict$3;
    var FF = engineFfVersion;
    var IE_OR_EDGE = engineIsIeOrEdge;
    var V8 = engineV8Version;
    var WEBKIT = engineWebkitVersion;

    var test = [];
    var un$Sort = uncurryThis$2(test.sort);
    var push = uncurryThis$2(test.push);

    // IE8-
    var FAILS_ON_UNDEFINED = fails$7(function () {
      test.sort(undefined);
    });
    // V8 bug
    var FAILS_ON_NULL = fails$7(function () {
      test.sort(null);
    });
    // Old WebKit
    var STRICT_METHOD = arrayMethodIsStrict('sort');

    var STABLE_SORT = !fails$7(function () {
      // feature detection can be too slow, so check engines versions
      if (V8) return V8 < 70;
      if (FF && FF > 3) return;
      if (IE_OR_EDGE) return true;
      if (WEBKIT) return WEBKIT < 603;

      var result = '';
      var code, chr, value, index;

      // generate an array with more 512 elements (Chakra and old V8 fails only in this case)
      for (code = 65; code < 76; code++) {
        chr = String.fromCharCode(code);

        switch (code) {
          case 66: case 69: case 70: case 72: value = 3; break;
          case 68: case 71: value = 4; break;
          default: value = 2;
        }

        for (index = 0; index < 47; index++) {
          test.push({ k: chr + index, v: value });
        }
      }

      test.sort(function (a, b) { return b.v - a.v; });

      for (index = 0; index < test.length; index++) {
        chr = test[index].k.charAt(0);
        if (result.charAt(result.length - 1) !== chr) result += chr;
      }

      return result !== 'DGBEFHACIJK';
    });

    var FORCED = FAILS_ON_UNDEFINED || !FAILS_ON_NULL || !STRICT_METHOD || !STABLE_SORT;

    var getSortCompare = function (comparefn) {
      return function (x, y) {
        if (y === undefined) return -1;
        if (x === undefined) return 1;
        if (comparefn !== undefined) return +comparefn(x, y) || 0;
        return toString$2(x) > toString$2(y) ? 1 : -1;
      };
    };

    // `Array.prototype.sort` method
    // https://tc39.es/ecma262/#sec-array.prototype.sort
    $$h({ target: 'Array', proto: true, forced: FORCED }, {
      sort: function sort(comparefn) {
        if (comparefn !== undefined) aCallable(comparefn);

        var array = toObject$2(this);

        if (STABLE_SORT) return comparefn === undefined ? un$Sort(array) : un$Sort(array, comparefn);

        var items = [];
        var arrayLength = lengthOfArrayLike$1(array);
        var itemsLength, index;

        for (index = 0; index < arrayLength; index++) {
          if (index in array) push(items, array[index]);
        }

        internalSort(items, getSortCompare(comparefn));

        itemsLength = items.length;
        index = 0;

        while (index < itemsLength) array[index] = items[index++];
        while (index < arrayLength) deletePropertyOrThrow(array, index++);

        return array;
      }
    });

    var DESCRIPTORS$2 = descriptors;
    var uncurryThis$1 = functionUncurryThis;
    var call$4 = functionCall;
    var fails$6 = fails$F;
    var objectKeys = objectKeys$3;
    var getOwnPropertySymbolsModule = objectGetOwnPropertySymbols;
    var propertyIsEnumerableModule = objectPropertyIsEnumerable;
    var toObject$1 = toObject$b;
    var IndexedObject = indexedObject;

    // eslint-disable-next-line es-x/no-object-assign -- safe
    var $assign = Object.assign;
    // eslint-disable-next-line es-x/no-object-defineproperty -- required for testing
    var defineProperty$1 = Object.defineProperty;
    var concat = uncurryThis$1([].concat);

    // `Object.assign` method
    // https://tc39.es/ecma262/#sec-object.assign
    var objectAssign = !$assign || fails$6(function () {
      // should have correct order of operations (Edge bug)
      if (DESCRIPTORS$2 && $assign({ b: 1 }, $assign(defineProperty$1({}, 'a', {
        enumerable: true,
        get: function () {
          defineProperty$1(this, 'b', {
            value: 3,
            enumerable: false
          });
        }
      }), { b: 2 })).b !== 1) return true;
      // should work with symbols and should have deterministic property order (V8 bug)
      var A = {};
      var B = {};
      // eslint-disable-next-line es-x/no-symbol -- safe
      var symbol = Symbol();
      var alphabet = 'abcdefghijklmnopqrst';
      A[symbol] = 7;
      alphabet.split('').forEach(function (chr) { B[chr] = chr; });
      return $assign({}, A)[symbol] != 7 || objectKeys($assign({}, B)).join('') != alphabet;
    }) ? function assign(target, source) { // eslint-disable-line no-unused-vars -- required for `.length`
      var T = toObject$1(target);
      var argumentsLength = arguments.length;
      var index = 1;
      var getOwnPropertySymbols = getOwnPropertySymbolsModule.f;
      var propertyIsEnumerable = propertyIsEnumerableModule.f;
      while (argumentsLength > index) {
        var S = IndexedObject(arguments[index++]);
        var keys = getOwnPropertySymbols ? concat(objectKeys(S), getOwnPropertySymbols(S)) : objectKeys(S);
        var length = keys.length;
        var j = 0;
        var key;
        while (length > j) {
          key = keys[j++];
          if (!DESCRIPTORS$2 || call$4(propertyIsEnumerable, S, key)) T[key] = S[key];
        }
      } return T;
    } : $assign;

    var $$g = _export;
    var assign = objectAssign;

    // `Object.assign` method
    // https://tc39.es/ecma262/#sec-object.assign
    // eslint-disable-next-line es-x/no-object-assign -- required for testing
    $$g({ target: 'Object', stat: true, arity: 2, forced: Object.assign !== assign }, {
      assign: assign
    });

    var getBuiltIn = getBuiltIn$c;
    var defineWellKnownSymbol$2 = defineWellKnownSymbol$4;
    var setToStringTag$2 = setToStringTag$8;

    // `Symbol.toStringTag` well-known symbol
    // https://tc39.es/ecma262/#sec-symbol.tostringtag
    defineWellKnownSymbol$2('toStringTag');

    // `Symbol.prototype[@@toStringTag]` property
    // https://tc39.es/ecma262/#sec-symbol.prototype-@@tostringtag
    setToStringTag$2(getBuiltIn('Symbol'), 'Symbol');

    var global$3 = global$w;
    var setToStringTag$1 = setToStringTag$8;

    // JSON[@@toStringTag] property
    // https://tc39.es/ecma262/#sec-json-@@tostringtag
    setToStringTag$1(global$3.JSON, 'JSON', true);

    var setToStringTag = setToStringTag$8;

    // Math[@@toStringTag] property
    // https://tc39.es/ecma262/#sec-math-@@tostringtag
    setToStringTag(Math, 'Math', true);

    var call$3 = functionCall;
    var hasOwn$3 = hasOwnProperty_1;
    var isPrototypeOf$1 = objectIsPrototypeOf;
    var regExpFlags = regexpFlags$1;

    var RegExpPrototype$2 = RegExp.prototype;

    var regexpGetFlags = function (R) {
      var flags = R.flags;
      return flags === undefined && !('flags' in RegExpPrototype$2) && !hasOwn$3(R, 'flags') && isPrototypeOf$1(RegExpPrototype$2, R)
        ? call$3(regExpFlags, R) : flags;
    };

    var defineProperty = objectDefineProperty.f;

    var proxyAccessor$1 = function (Target, Source, key) {
      key in Target || defineProperty(Target, key, {
        configurable: true,
        get: function () { return Source[key]; },
        set: function (it) { Source[key] = it; }
      });
    };

    var DESCRIPTORS$1 = descriptors;
    var global$2 = global$w;
    var uncurryThis = functionUncurryThis;
    var isForced = isForced_1;
    var inheritIfRequired = inheritIfRequired$3;
    var createNonEnumerableProperty = createNonEnumerableProperty$7;
    var getOwnPropertyNames$1 = objectGetOwnPropertyNames.f;
    var isPrototypeOf = objectIsPrototypeOf;
    var isRegExp = isRegexp;
    var toString$1 = toString$g;
    var getRegExpFlags$1 = regexpGetFlags;
    var stickyHelpers = regexpStickyHelpers;
    var proxyAccessor = proxyAccessor$1;
    var defineBuiltIn$1 = defineBuiltIn$e;
    var fails$5 = fails$F;
    var hasOwn$2 = hasOwnProperty_1;
    var enforceInternalState = internalState.enforce;
    var setSpecies = setSpecies$3;
    var wellKnownSymbol = wellKnownSymbol$q;
    var UNSUPPORTED_DOT_ALL = regexpUnsupportedDotAll;
    var UNSUPPORTED_NCG = regexpUnsupportedNcg;

    var MATCH = wellKnownSymbol('match');
    var NativeRegExp = global$2.RegExp;
    var RegExpPrototype$1 = NativeRegExp.prototype;
    var SyntaxError = global$2.SyntaxError;
    var exec = uncurryThis(RegExpPrototype$1.exec);
    var charAt = uncurryThis(''.charAt);
    var replace = uncurryThis(''.replace);
    var stringIndexOf = uncurryThis(''.indexOf);
    var stringSlice = uncurryThis(''.slice);
    // TODO: Use only proper RegExpIdentifierName
    var IS_NCG = /^\?<[^\s\d!#%&*+<=>@^][^\s!#%&*+<=>@^]*>/;
    var re1 = /a/g;
    var re2 = /a/g;

    // "new" should create a new object, old webkit bug
    var CORRECT_NEW = new NativeRegExp(re1) !== re1;

    var MISSED_STICKY = stickyHelpers.MISSED_STICKY;
    var UNSUPPORTED_Y = stickyHelpers.UNSUPPORTED_Y;

    var BASE_FORCED = DESCRIPTORS$1 &&
      (!CORRECT_NEW || MISSED_STICKY || UNSUPPORTED_DOT_ALL || UNSUPPORTED_NCG || fails$5(function () {
        re2[MATCH] = false;
        // RegExp constructor can alter flags and IsRegExp works correct with @@match
        return NativeRegExp(re1) != re1 || NativeRegExp(re2) == re2 || NativeRegExp(re1, 'i') != '/a/i';
      }));

    var handleDotAll = function (string) {
      var length = string.length;
      var index = 0;
      var result = '';
      var brackets = false;
      var chr;
      for (; index <= length; index++) {
        chr = charAt(string, index);
        if (chr === '\\') {
          result += chr + charAt(string, ++index);
          continue;
        }
        if (!brackets && chr === '.') {
          result += '[\\s\\S]';
        } else {
          if (chr === '[') {
            brackets = true;
          } else if (chr === ']') {
            brackets = false;
          } result += chr;
        }
      } return result;
    };

    var handleNCG = function (string) {
      var length = string.length;
      var index = 0;
      var result = '';
      var named = [];
      var names = {};
      var brackets = false;
      var ncg = false;
      var groupid = 0;
      var groupname = '';
      var chr;
      for (; index <= length; index++) {
        chr = charAt(string, index);
        if (chr === '\\') {
          chr = chr + charAt(string, ++index);
        } else if (chr === ']') {
          brackets = false;
        } else if (!brackets) switch (true) {
          case chr === '[':
            brackets = true;
            break;
          case chr === '(':
            if (exec(IS_NCG, stringSlice(string, index + 1))) {
              index += 2;
              ncg = true;
            }
            result += chr;
            groupid++;
            continue;
          case chr === '>' && ncg:
            if (groupname === '' || hasOwn$2(names, groupname)) {
              throw new SyntaxError('Invalid capture group name');
            }
            names[groupname] = true;
            named[named.length] = [groupname, groupid];
            ncg = false;
            groupname = '';
            continue;
        }
        if (ncg) groupname += chr;
        else result += chr;
      } return [result, named];
    };

    // `RegExp` constructor
    // https://tc39.es/ecma262/#sec-regexp-constructor
    if (isForced('RegExp', BASE_FORCED)) {
      var RegExpWrapper = function RegExp(pattern, flags) {
        var thisIsRegExp = isPrototypeOf(RegExpPrototype$1, this);
        var patternIsRegExp = isRegExp(pattern);
        var flagsAreUndefined = flags === undefined;
        var groups = [];
        var rawPattern = pattern;
        var rawFlags, dotAll, sticky, handled, result, state;

        if (!thisIsRegExp && patternIsRegExp && flagsAreUndefined && pattern.constructor === RegExpWrapper) {
          return pattern;
        }

        if (patternIsRegExp || isPrototypeOf(RegExpPrototype$1, pattern)) {
          pattern = pattern.source;
          if (flagsAreUndefined) flags = getRegExpFlags$1(rawPattern);
        }

        pattern = pattern === undefined ? '' : toString$1(pattern);
        flags = flags === undefined ? '' : toString$1(flags);
        rawPattern = pattern;

        if (UNSUPPORTED_DOT_ALL && 'dotAll' in re1) {
          dotAll = !!flags && stringIndexOf(flags, 's') > -1;
          if (dotAll) flags = replace(flags, /s/g, '');
        }

        rawFlags = flags;

        if (MISSED_STICKY && 'sticky' in re1) {
          sticky = !!flags && stringIndexOf(flags, 'y') > -1;
          if (sticky && UNSUPPORTED_Y) flags = replace(flags, /y/g, '');
        }

        if (UNSUPPORTED_NCG) {
          handled = handleNCG(pattern);
          pattern = handled[0];
          groups = handled[1];
        }

        result = inheritIfRequired(NativeRegExp(pattern, flags), thisIsRegExp ? this : RegExpPrototype$1, RegExpWrapper);

        if (dotAll || sticky || groups.length) {
          state = enforceInternalState(result);
          if (dotAll) {
            state.dotAll = true;
            state.raw = RegExpWrapper(handleDotAll(pattern), rawFlags);
          }
          if (sticky) state.sticky = true;
          if (groups.length) state.groups = groups;
        }

        if (pattern !== rawPattern) try {
          // fails in old engines, but we have no alternatives for unsupported regex syntax
          createNonEnumerableProperty(result, 'source', rawPattern === '' ? '(?:)' : rawPattern);
        } catch (error) { /* empty */ }

        return result;
      };

      for (var keys = getOwnPropertyNames$1(NativeRegExp), index = 0; keys.length > index;) {
        proxyAccessor(RegExpWrapper, NativeRegExp, keys[index++]);
      }

      RegExpPrototype$1.constructor = RegExpWrapper;
      RegExpWrapper.prototype = RegExpPrototype$1;
      defineBuiltIn$1(global$2, 'RegExp', RegExpWrapper, { constructor: true });
    }

    // https://tc39.es/ecma262/#sec-get-regexp-@@species
    setSpecies('RegExp');

    var PROPER_FUNCTION_NAME = functionName.PROPER;
    var defineBuiltIn = defineBuiltIn$e;
    var anObject$6 = anObject$o;
    var $toString = toString$g;
    var fails$4 = fails$F;
    var getRegExpFlags = regexpGetFlags;

    var TO_STRING = 'toString';
    var RegExpPrototype = RegExp.prototype;
    var n$ToString = RegExpPrototype[TO_STRING];

    var NOT_GENERIC = fails$4(function () { return n$ToString.call({ source: 'a', flags: 'b' }) != '/a/b'; });
    // FF44- RegExp#toString has a wrong name
    var INCORRECT_NAME = PROPER_FUNCTION_NAME && n$ToString.name != TO_STRING;

    // `RegExp.prototype.toString` method
    // https://tc39.es/ecma262/#sec-regexp.prototype.tostring
    if (NOT_GENERIC || INCORRECT_NAME) {
      defineBuiltIn(RegExp.prototype, TO_STRING, function toString() {
        var R = anObject$6(this);
        var pattern = $toString(R.source);
        var flags = $toString(getRegExpFlags(R));
        return '/' + pattern + '/' + flags;
      }, { unsafe: true });
    }

    var isObject$4 = isObject$n;

    var floor = Math.floor;

    // `IsIntegralNumber` abstract operation
    // https://tc39.es/ecma262/#sec-isintegralnumber
    // eslint-disable-next-line es-x/no-number-isinteger -- safe
    var isIntegralNumber$1 = Number.isInteger || function isInteger(it) {
      return !isObject$4(it) && isFinite(it) && floor(it) === it;
    };

    var $$f = _export;
    var isIntegralNumber = isIntegralNumber$1;

    // `Number.isInteger` method
    // https://tc39.es/ecma262/#sec-number.isinteger
    $$f({ target: 'Number', stat: true }, {
      isInteger: isIntegralNumber
    });

    var defineWellKnownSymbol$1 = defineWellKnownSymbol$4;

    // `Symbol.iterator` well-known symbol
    // https://tc39.es/ecma262/#sec-symbol.iterator
    defineWellKnownSymbol$1('iterator');

    var anObject$5 = anObject$o;
    var iteratorClose = iteratorClose$2;

    // call something on iterator step with safe closing on error
    var callWithSafeIterationClosing$1 = function (iterator, fn, value, ENTRIES) {
      try {
        return ENTRIES ? fn(anObject$5(value)[0], value[1]) : fn(value);
      } catch (error) {
        iteratorClose(iterator, 'throw', error);
      }
    };

    var bind = functionBindContext;
    var call$2 = functionCall;
    var toObject = toObject$b;
    var callWithSafeIterationClosing = callWithSafeIterationClosing$1;
    var isArrayIteratorMethod = isArrayIteratorMethod$2;
    var isConstructor = isConstructor$4;
    var lengthOfArrayLike = lengthOfArrayLike$9;
    var createProperty = createProperty$5;
    var getIterator = getIterator$2;
    var getIteratorMethod = getIteratorMethod$3;

    var $Array = Array;

    // `Array.from` method implementation
    // https://tc39.es/ecma262/#sec-array.from
    var arrayFrom = function from(arrayLike /* , mapfn = undefined, thisArg = undefined */) {
      var O = toObject(arrayLike);
      var IS_CONSTRUCTOR = isConstructor(this);
      var argumentsLength = arguments.length;
      var mapfn = argumentsLength > 1 ? arguments[1] : undefined;
      var mapping = mapfn !== undefined;
      if (mapping) mapfn = bind(mapfn, argumentsLength > 2 ? arguments[2] : undefined);
      var iteratorMethod = getIteratorMethod(O);
      var index = 0;
      var length, result, step, iterator, next, value;
      // if the target is not iterable or it's an array with the default iterator - use a simple case
      if (iteratorMethod && !(this === $Array && isArrayIteratorMethod(iteratorMethod))) {
        iterator = getIterator(O, iteratorMethod);
        next = iterator.next;
        result = IS_CONSTRUCTOR ? new this() : [];
        for (;!(step = call$2(next, iterator)).done; index++) {
          value = mapping ? callWithSafeIterationClosing(iterator, mapfn, [step.value, index], true) : step.value;
          createProperty(result, index, value);
        }
      } else {
        length = lengthOfArrayLike(O);
        result = IS_CONSTRUCTOR ? new this(length) : $Array(length);
        for (;length > index; index++) {
          value = mapping ? mapfn(O[index], index) : O[index];
          createProperty(result, index, value);
        }
      }
      result.length = index;
      return result;
    };

    var $$e = _export;
    var from = arrayFrom;
    var checkCorrectnessOfIteration = checkCorrectnessOfIteration$3;

    var INCORRECT_ITERATION = !checkCorrectnessOfIteration(function (iterable) {
      // eslint-disable-next-line es-x/no-array-from -- required for testing
      Array.from(iterable);
    });

    // `Array.from` method
    // https://tc39.es/ecma262/#sec-array.from
    $$e({ target: 'Array', stat: true, forced: INCORRECT_ITERATION }, {
      from: from
    });

    var $$d = _export;
    var DESCRIPTORS = descriptors;
    var anObject$4 = anObject$o;
    var toPropertyKey = toPropertyKey$5;
    var definePropertyModule$1 = objectDefineProperty;
    var fails$3 = fails$F;

    // MS Edge has broken Reflect.defineProperty - throwing instead of returning false
    var ERROR_INSTEAD_OF_FALSE = fails$3(function () {
      // eslint-disable-next-line es-x/no-reflect -- required for testing
      Reflect.defineProperty(definePropertyModule$1.f({}, 1, { value: 1 }), 1, { value: 2 });
    });

    // `Reflect.defineProperty` method
    // https://tc39.es/ecma262/#sec-reflect.defineproperty
    $$d({ target: 'Reflect', stat: true, forced: ERROR_INSTEAD_OF_FALSE, sham: !DESCRIPTORS }, {
      defineProperty: function defineProperty(target, propertyKey, attributes) {
        anObject$4(target);
        var key = toPropertyKey(propertyKey);
        anObject$4(attributes);
        try {
          definePropertyModule$1.f(target, key, attributes);
          return true;
        } catch (error) {
          return false;
        }
      }
    });

    var $$c = _export;
    var ownKeys$1 = ownKeys$3;

    // `Reflect.ownKeys` method
    // https://tc39.es/ecma262/#sec-reflect.ownkeys
    $$c({ target: 'Reflect', stat: true }, {
      ownKeys: ownKeys$1
    });

    var defineWellKnownSymbol = defineWellKnownSymbol$4;

    // `Symbol.unscopables` well-known symbol
    // https://tc39.es/ecma262/#sec-symbol.unscopables
    defineWellKnownSymbol('unscopables');

    var $$b = _export;
    var $findIndex = arrayIteration.findIndex;
    var addToUnscopables = addToUnscopables$3;

    var FIND_INDEX = 'findIndex';
    var SKIPS_HOLES = true;

    // Shouldn't skip holes
    if (FIND_INDEX in []) Array(1)[FIND_INDEX](function () { SKIPS_HOLES = false; });

    // `Array.prototype.findIndex` method
    // https://tc39.es/ecma262/#sec-array.prototype.findindex
    $$b({ target: 'Array', proto: true, forced: SKIPS_HOLES }, {
      findIndex: function findIndex(callbackfn /* , that = undefined */) {
        return $findIndex(this, callbackfn, arguments.length > 1 ? arguments[1] : undefined);
      }
    });

    // https://tc39.es/ecma262/#sec-array.prototype-@@unscopables
    addToUnscopables(FIND_INDEX);

    var $$a = _export;
    var FREEZING = freezing;
    var fails$2 = fails$F;
    var isObject$3 = isObject$n;
    var onFreeze = internalMetadata.exports.onFreeze;

    // eslint-disable-next-line es-x/no-object-freeze -- safe
    var $freeze = Object.freeze;
    var FAILS_ON_PRIMITIVES$1 = fails$2(function () { $freeze(1); });

    // `Object.freeze` method
    // https://tc39.es/ecma262/#sec-object.freeze
    $$a({ target: 'Object', stat: true, forced: FAILS_ON_PRIMITIVES$1, sham: !FREEZING }, {
      freeze: function freeze(it) {
        return $freeze && isObject$3(it) ? $freeze(onFreeze(it)) : it;
      }
    });

    var $$9 = _export;
    var fails$1 = fails$F;
    var getOwnPropertyNames = objectGetOwnPropertyNamesExternal.f;

    // eslint-disable-next-line es-x/no-object-getownpropertynames -- required for testing
    var FAILS_ON_PRIMITIVES = fails$1(function () { return !Object.getOwnPropertyNames(1); });

    // `Object.getOwnPropertyNames` method
    // https://tc39.es/ecma262/#sec-object.getownpropertynames
    $$9({ target: 'Object', stat: true, forced: FAILS_ON_PRIMITIVES }, {
      getOwnPropertyNames: getOwnPropertyNames
    });

    var hasOwn$1 = hasOwnProperty_1;

    var isDataDescriptor$2 = function (descriptor) {
      return descriptor !== undefined && (hasOwn$1(descriptor, 'value') || hasOwn$1(descriptor, 'writable'));
    };

    var $$8 = _export;
    var call$1 = functionCall;
    var isObject$2 = isObject$n;
    var anObject$3 = anObject$o;
    var isDataDescriptor$1 = isDataDescriptor$2;
    var getOwnPropertyDescriptorModule$1 = objectGetOwnPropertyDescriptor;
    var getPrototypeOf$1 = objectGetPrototypeOf$1;

    // `Reflect.get` method
    // https://tc39.es/ecma262/#sec-reflect.get
    function get$2(target, propertyKey /* , receiver */) {
      var receiver = arguments.length < 3 ? target : arguments[2];
      var descriptor, prototype;
      if (anObject$3(target) === receiver) return target[propertyKey];
      descriptor = getOwnPropertyDescriptorModule$1.f(target, propertyKey);
      if (descriptor) return isDataDescriptor$1(descriptor)
        ? descriptor.value
        : descriptor.get === undefined ? undefined : call$1(descriptor.get, receiver);
      if (isObject$2(prototype = getPrototypeOf$1(target))) return get$2(prototype, propertyKey, receiver);
    }

    $$8({ target: 'Reflect', stat: true }, {
      get: get$2
    });

    var $$7 = _export;
    var call = functionCall;
    var anObject$2 = anObject$o;
    var isObject$1 = isObject$n;
    var isDataDescriptor = isDataDescriptor$2;
    var fails = fails$F;
    var definePropertyModule = objectDefineProperty;
    var getOwnPropertyDescriptorModule = objectGetOwnPropertyDescriptor;
    var getPrototypeOf = objectGetPrototypeOf$1;
    var createPropertyDescriptor = createPropertyDescriptor$6;

    // `Reflect.set` method
    // https://tc39.es/ecma262/#sec-reflect.set
    function set$2(target, propertyKey, V /* , receiver */) {
      var receiver = arguments.length < 4 ? target : arguments[3];
      var ownDescriptor = getOwnPropertyDescriptorModule.f(anObject$2(target), propertyKey);
      var existingDescriptor, prototype, setter;
      if (!ownDescriptor) {
        if (isObject$1(prototype = getPrototypeOf(target))) {
          return set$2(prototype, propertyKey, V, receiver);
        }
        ownDescriptor = createPropertyDescriptor(0);
      }
      if (isDataDescriptor(ownDescriptor)) {
        if (ownDescriptor.writable === false || !isObject$1(receiver)) return false;
        if (existingDescriptor = getOwnPropertyDescriptorModule.f(receiver, propertyKey)) {
          if (existingDescriptor.get || existingDescriptor.set || existingDescriptor.writable === false) return false;
          existingDescriptor.value = V;
          definePropertyModule.f(receiver, propertyKey, existingDescriptor);
        } else definePropertyModule.f(receiver, propertyKey, createPropertyDescriptor(0, V));
      } else {
        setter = ownDescriptor.set;
        if (setter === undefined) return false;
        call(setter, receiver, V);
      } return true;
    }

    // MS Edge 17-18 Reflect.set allows setting the property to object
    // with non-writable property on the prototype
    var MS_EDGE_BUG = fails(function () {
      var Constructor = function () { /* empty */ };
      var object = definePropertyModule.f(new Constructor(), 'a', { configurable: true });
      // eslint-disable-next-line es-x/no-reflect -- required for testing
      return Reflect.set(Constructor.prototype, 'a', 1, object) !== false;
    });

    $$7({ target: 'Reflect', stat: true, forced: MS_EDGE_BUG }, {
      set: set$2
    });

    var $$6 = _export;
    var anObject$1 = anObject$o;
    var getOwnPropertyDescriptor = objectGetOwnPropertyDescriptor.f;

    // `Reflect.deleteProperty` method
    // https://tc39.es/ecma262/#sec-reflect.deleteproperty
    $$6({ target: 'Reflect', stat: true }, {
      deleteProperty: function deleteProperty(target, propertyKey) {
        var descriptor = getOwnPropertyDescriptor(anObject$1(target), propertyKey);
        return descriptor && !descriptor.configurable ? false : delete target[propertyKey];
      }
    });

    var $$5 = _export;

    // `Reflect.has` method
    // https://tc39.es/ecma262/#sec-reflect.has
    $$5({ target: 'Reflect', stat: true }, {
      has: function has(target, propertyKey) {
        return propertyKey in target;
      }
    });

    var $$4 = _export;
    var anObject = anObject$o;
    var objectGetPrototypeOf = objectGetPrototypeOf$1;
    var CORRECT_PROTOTYPE_GETTER = correctPrototypeGetter;

    // `Reflect.getPrototypeOf` method
    // https://tc39.es/ecma262/#sec-reflect.getprototypeof
    $$4({ target: 'Reflect', stat: true, sham: !CORRECT_PROTOTYPE_GETTER }, {
      getPrototypeOf: function getPrototypeOf(target) {
        return objectGetPrototypeOf(anObject(target));
      }
    });

    var $$3 = _export;
    var $isExtensible = objectIsExtensible;

    // `Object.isExtensible` method
    // https://tc39.es/ecma262/#sec-object.isextensible
    // eslint-disable-next-line es-x/no-object-isextensible -- safe
    $$3({ target: 'Object', stat: true, forced: Object.isExtensible !== $isExtensible }, {
      isExtensible: $isExtensible
    });

    var toIntegerOrInfinity = toIntegerOrInfinity$6;
    var toString = toString$g;
    var requireObjectCoercible = requireObjectCoercible$c;

    var $RangeError = RangeError;

    // `String.prototype.repeat` method implementation
    // https://tc39.es/ecma262/#sec-string.prototype.repeat
    var stringRepeat = function repeat(count) {
      var str = toString(requireObjectCoercible(this));
      var result = '';
      var n = toIntegerOrInfinity(count);
      if (n < 0 || n == Infinity) throw $RangeError('Wrong number of repetitions');
      for (;n > 0; (n >>>= 1) && (str += str)) if (n & 1) result += str;
      return result;
    };

    var $$2 = _export;
    var repeat = stringRepeat;

    // `String.prototype.repeat` method
    // https://tc39.es/ecma262/#sec-string.prototype.repeat
    $$2({ target: 'String', proto: true }, {
      repeat: repeat
    });

    // `SameValue` abstract operation
    // https://tc39.es/ecma262/#sec-samevalue
    // eslint-disable-next-line es-x/no-object-is -- safe
    var sameValue = Object.is || function is(x, y) {
      // eslint-disable-next-line no-self-compare -- NaN check
      return x === y ? x !== 0 || 1 / x === 1 / y : x != x && y != y;
    };

    var $$1 = _export;
    var is = sameValue;

    // `Object.is` method
    // https://tc39.es/ecma262/#sec-object.is
    $$1({ target: 'Object', stat: true }, {
      is: is
    });

    var $ = _export;
    var global$1 = global$w;

    // `globalThis` object
    // https://tc39.es/ecma262/#sec-globalthis
    $({ global: true }, {
      globalThis: global$1
    });

    var _PatchFlagNames, _slotFlagsText;

    /**
     * Make a map and return a function for checking if a key
     * is in that map.
     * IMPORTANT: all calls of this function must be prefixed with
     * \/\*#\_\_PURE\_\_\*\/
     * So that rollup can tree-shake them if necessary.
     */
    function makeMap(str, expectsLowerCase) {
      var map = Object.create(null);
      var list = str.split(',');

      for (var i = 0; i < list.length; i++) {
        map[list[i]] = true;
      }

      return expectsLowerCase ? function (val) {
        return !!map[val.toLowerCase()];
      } : function (val) {
        return !!map[val];
      };
    }
    /**
     * dev only flag -> name mapping
     */


    (_PatchFlagNames = {}, _defineProperty(_PatchFlagNames, 1
    /* TEXT */
    , "TEXT"), _defineProperty(_PatchFlagNames, 2
    /* CLASS */
    , "CLASS"), _defineProperty(_PatchFlagNames, 4
    /* STYLE */
    , "STYLE"), _defineProperty(_PatchFlagNames, 8
    /* PROPS */
    , "PROPS"), _defineProperty(_PatchFlagNames, 16
    /* FULL_PROPS */
    , "FULL_PROPS"), _defineProperty(_PatchFlagNames, 32
    /* HYDRATE_EVENTS */
    , "HYDRATE_EVENTS"), _defineProperty(_PatchFlagNames, 64
    /* STABLE_FRAGMENT */
    , "STABLE_FRAGMENT"), _defineProperty(_PatchFlagNames, 128
    /* KEYED_FRAGMENT */
    , "KEYED_FRAGMENT"), _defineProperty(_PatchFlagNames, 256
    /* UNKEYED_FRAGMENT */
    , "UNKEYED_FRAGMENT"), _defineProperty(_PatchFlagNames, 512
    /* NEED_PATCH */
    , "NEED_PATCH"), _defineProperty(_PatchFlagNames, 1024
    /* DYNAMIC_SLOTS */
    , "DYNAMIC_SLOTS"), _defineProperty(_PatchFlagNames, 2048
    /* DEV_ROOT_FRAGMENT */
    , "DEV_ROOT_FRAGMENT"), _defineProperty(_PatchFlagNames, -1
    /* HOISTED */
    , "HOISTED"), _defineProperty(_PatchFlagNames, -2
    /* BAIL */
    , "BAIL"), _PatchFlagNames);
    /**
     * Dev only
     */

    (_slotFlagsText = {}, _defineProperty(_slotFlagsText, 1
    /* STABLE */
    , 'STABLE'), _defineProperty(_slotFlagsText, 2
    /* DYNAMIC */
    , 'DYNAMIC'), _defineProperty(_slotFlagsText, 3
    /* FORWARDED */
    , 'FORWARDED'), _slotFlagsText);

    function normalizeStyle(value) {
      if (isArray(value)) {
        var res = {};

        for (var i = 0; i < value.length; i++) {
          var item = value[i];
          var normalized = isString(item) ? parseStringStyle(item) : normalizeStyle(item);

          if (normalized) {
            for (var key in normalized) {
              res[key] = normalized[key];
            }
          }
        }

        return res;
      } else if (isString(value)) {
        return value;
      } else if (isObject(value)) {
        return value;
      }
    }

    var listDelimiterRE = /;(?![^(]*\))/g;
    var propertyDelimiterRE = /:(.+)/;

    function parseStringStyle(cssText) {
      var ret = {};
      cssText.split(listDelimiterRE).forEach(function (item) {
        if (item) {
          var tmp = item.split(propertyDelimiterRE);
          tmp.length > 1 && (ret[tmp[0].trim()] = tmp[1].trim());
        }
      });
      return ret;
    }

    function normalizeClass(value) {
      var res = '';

      if (isString(value)) {
        res = value;
      } else if (isArray(value)) {
        for (var i = 0; i < value.length; i++) {
          var normalized = normalizeClass(value[i]);

          if (normalized) {
            res += normalized + ' ';
          }
        }
      } else if (isObject(value)) {
        for (var name in value) {
          if (value[name]) {
            res += name + ' ';
          }
        }
      }

      return res.trim();
    }

    var EMPTY_OBJ = process.env.NODE_ENV !== 'production' ? Object.freeze({}) : {};
    process.env.NODE_ENV !== 'production' ? Object.freeze([]) : [];

    var NOOP = function NOOP() {};

    var onRE = /^on[^a-z]/;

    var isOn = function isOn(key) {
      return onRE.test(key);
    };

    var extend = Object.assign;

    var remove = function remove(arr, el) {
      var i = arr.indexOf(el);

      if (i > -1) {
        arr.splice(i, 1);
      }
    };

    var hasOwnProperty = Object.prototype.hasOwnProperty;

    var hasOwn = function hasOwn(val, key) {
      return hasOwnProperty.call(val, key);
    };

    var isArray = Array.isArray;

    var isMap = function isMap(val) {
      return toTypeString(val) === '[object Map]';
    };

    var isSet = function isSet(val) {
      return toTypeString(val) === '[object Set]';
    };

    var isFunction = function isFunction(val) {
      return typeof val === 'function';
    };

    var isString = function isString(val) {
      return typeof val === 'string';
    };

    var isSymbol = function isSymbol(val) {
      return _typeof(val) === 'symbol';
    };

    var isObject = function isObject(val) {
      return val !== null && _typeof(val) === 'object';
    };

    var isPromise = function isPromise(val) {
      return isObject(val) && isFunction(val.then) && isFunction(val["catch"]);
    };

    var objectToString = Object.prototype.toString;

    var toTypeString = function toTypeString(value) {
      return objectToString.call(value);
    };

    var toRawType = function toRawType(value) {
      // extract "RawType" from strings like "[object RawType]"
      return toTypeString(value).slice(8, -1);
    };

    var isPlainObject = function isPlainObject(val) {
      return toTypeString(val) === '[object Object]';
    };

    var isIntegerKey = function isIntegerKey(key) {
      return isString(key) && key !== 'NaN' && key[0] !== '-' && '' + parseInt(key, 10) === key;
    };

    var cacheStringFunction = function cacheStringFunction(fn) {
      var cache = Object.create(null);
      return function (str) {
        var hit = cache[str];
        return hit || (cache[str] = fn(str));
      };
    };
    /**
     * @private
     */

    var capitalize = cacheStringFunction(function (str) {
      return str.charAt(0).toUpperCase() + str.slice(1);
    });

    var hasChanged = function hasChanged(value, oldValue) {
      return !Object.is(value, oldValue);
    };

    var def = function def(obj, key, value) {
      Object.defineProperty(obj, key, {
        configurable: true,
        enumerable: false,
        value: value
      });
    };

    var _globalThis;

    var getGlobalThis = function getGlobalThis() {
      return _globalThis || (_globalThis = typeof globalThis !== 'undefined' ? globalThis : typeof self !== 'undefined' ? self : typeof window !== 'undefined' ? window : typeof global !== 'undefined' ? global : {});
    };

    function warn$1(msg) {
      var _console;

      for (var _len = arguments.length, args = new Array(_len > 1 ? _len - 1 : 0), _key2 = 1; _key2 < _len; _key2++) {
        args[_key2 - 1] = arguments[_key2];
      }

      (_console = console).warn.apply(_console, ["[Vue warn] ".concat(msg)].concat(args));
    }

    var activeEffectScope;

    function recordEffectScope(effect) {
      var scope = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : activeEffectScope;

      if (scope && scope.active) {
        scope.effects.push(effect);
      }
    }

    var createDep = function createDep(effects) {
      var dep = new Set(effects);
      dep.w = 0;
      dep.n = 0;
      return dep;
    };

    var wasTracked = function wasTracked(dep) {
      return (dep.w & trackOpBit) > 0;
    };

    var newTracked = function newTracked(dep) {
      return (dep.n & trackOpBit) > 0;
    };

    var initDepMarkers = function initDepMarkers(_ref) {
      var deps = _ref.deps;

      if (deps.length) {
        for (var i = 0; i < deps.length; i++) {
          deps[i].w |= trackOpBit; // set was tracked
        }
      }
    };

    var finalizeDepMarkers = function finalizeDepMarkers(effect) {
      var deps = effect.deps;

      if (deps.length) {
        var ptr = 0;

        for (var i = 0; i < deps.length; i++) {
          var dep = deps[i];

          if (wasTracked(dep) && !newTracked(dep)) {
            dep["delete"](effect);
          } else {
            deps[ptr++] = dep;
          } // clear bits


          dep.w &= ~trackOpBit;
          dep.n &= ~trackOpBit;
        }

        deps.length = ptr;
      }
    };

    var targetMap = new WeakMap(); // The number of effects currently being tracked recursively.

    var effectTrackDepth = 0;
    var trackOpBit = 1;
    /**
     * The bitwise track markers support at most 30 levels of recursion.
     * This value is chosen to enable modern JS engines to use a SMI on all platforms.
     * When recursion depth is greater, fall back to using a full cleanup.
     */

    var maxMarkerBits = 30;
    var activeEffect;
    var ITERATE_KEY = Symbol(process.env.NODE_ENV !== 'production' ? 'iterate' : '');
    var MAP_KEY_ITERATE_KEY = Symbol(process.env.NODE_ENV !== 'production' ? 'Map key iterate' : '');

    var ReactiveEffect = /*#__PURE__*/function () {
      function ReactiveEffect(fn) {
        var scheduler = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
        var scope = arguments.length > 2 ? arguments[2] : undefined;

        _classCallCheck(this, ReactiveEffect);

        this.fn = fn;
        this.scheduler = scheduler;
        this.active = true;
        this.deps = [];
        this.parent = undefined;
        recordEffectScope(this, scope);
      }

      _createClass(ReactiveEffect, [{
        key: "run",
        value: function run() {
          if (!this.active) {
            return this.fn();
          }

          var parent = activeEffect;
          var lastShouldTrack = shouldTrack;

          while (parent) {
            if (parent === this) {
              return;
            }

            parent = parent.parent;
          }

          try {
            this.parent = activeEffect;
            activeEffect = this;
            shouldTrack = true;
            trackOpBit = 1 << ++effectTrackDepth;

            if (effectTrackDepth <= maxMarkerBits) {
              initDepMarkers(this);
            } else {
              cleanupEffect(this);
            }

            return this.fn();
          } finally {
            if (effectTrackDepth <= maxMarkerBits) {
              finalizeDepMarkers(this);
            }

            trackOpBit = 1 << --effectTrackDepth;
            activeEffect = this.parent;
            shouldTrack = lastShouldTrack;
            this.parent = undefined;

            if (this.deferStop) {
              this.stop();
            }
          }
        }
      }, {
        key: "stop",
        value: function stop() {
          // stopped while running itself - defer the cleanup
          if (activeEffect === this) {
            this.deferStop = true;
          } else if (this.active) {
            cleanupEffect(this);

            if (this.onStop) {
              this.onStop();
            }

            this.active = false;
          }
        }
      }]);

      return ReactiveEffect;
    }();

    function cleanupEffect(effect) {
      var deps = effect.deps;

      if (deps.length) {
        for (var i = 0; i < deps.length; i++) {
          deps[i]["delete"](effect);
        }

        deps.length = 0;
      }
    }

    var shouldTrack = true;
    var trackStack = [];

    function pauseTracking() {
      trackStack.push(shouldTrack);
      shouldTrack = false;
    }

    function resetTracking() {
      var last = trackStack.pop();
      shouldTrack = last === undefined ? true : last;
    }

    function track(target, type, key) {
      if (shouldTrack && activeEffect) {
        var depsMap = targetMap.get(target);

        if (!depsMap) {
          targetMap.set(target, depsMap = new Map());
        }

        var dep = depsMap.get(key);

        if (!dep) {
          depsMap.set(key, dep = createDep());
        }

        var eventInfo = process.env.NODE_ENV !== 'production' ? {
          effect: activeEffect,
          target: target,
          type: type,
          key: key
        } : undefined;
        trackEffects(dep, eventInfo);
      }
    }

    function trackEffects(dep, debuggerEventExtraInfo) {
      var shouldTrack = false;

      if (effectTrackDepth <= maxMarkerBits) {
        if (!newTracked(dep)) {
          dep.n |= trackOpBit; // set newly tracked

          shouldTrack = !wasTracked(dep);
        }
      } else {
        // Full cleanup mode.
        shouldTrack = !dep.has(activeEffect);
      }

      if (shouldTrack) {
        dep.add(activeEffect);
        activeEffect.deps.push(dep);

        if (process.env.NODE_ENV !== 'production' && activeEffect.onTrack) {
          activeEffect.onTrack(Object.assign({
            effect: activeEffect
          }, debuggerEventExtraInfo));
        }
      }
    }

    function trigger(target, type, key, newValue, oldValue, oldTarget) {
      var depsMap = targetMap.get(target);

      if (!depsMap) {
        // never been tracked
        return;
      }

      var deps = [];

      if (type === "clear"
      /* CLEAR */
      ) {
        // collection being cleared
        // trigger all effects for target
        deps = _toConsumableArray(depsMap.values());
      } else if (key === 'length' && isArray(target)) {
        depsMap.forEach(function (dep, key) {
          if (key === 'length' || key >= newValue) {
            deps.push(dep);
          }
        });
      } else {
        // schedule runs for SET | ADD | DELETE
        if (key !== void 0) {
          deps.push(depsMap.get(key));
        } // also run for iteration key on ADD | DELETE | Map.SET


        switch (type) {
          case "add"
          /* ADD */
          :
            if (!isArray(target)) {
              deps.push(depsMap.get(ITERATE_KEY));

              if (isMap(target)) {
                deps.push(depsMap.get(MAP_KEY_ITERATE_KEY));
              }
            } else if (isIntegerKey(key)) {
              // new index added to array -> length changes
              deps.push(depsMap.get('length'));
            }

            break;

          case "delete"
          /* DELETE */
          :
            if (!isArray(target)) {
              deps.push(depsMap.get(ITERATE_KEY));

              if (isMap(target)) {
                deps.push(depsMap.get(MAP_KEY_ITERATE_KEY));
              }
            }

            break;

          case "set"
          /* SET */
          :
            if (isMap(target)) {
              deps.push(depsMap.get(ITERATE_KEY));
            }

            break;
        }
      }

      var eventInfo = process.env.NODE_ENV !== 'production' ? {
        target: target,
        type: type,
        key: key,
        newValue: newValue,
        oldValue: oldValue,
        oldTarget: oldTarget
      } : undefined;

      if (deps.length === 1) {
        if (deps[0]) {
          if (process.env.NODE_ENV !== 'production') {
            triggerEffects(deps[0], eventInfo);
          } else {
            triggerEffects(deps[0]);
          }
        }
      } else {
        var effects = [];

        var _iterator = _createForOfIteratorHelper(deps),
            _step;

        try {
          for (_iterator.s(); !(_step = _iterator.n()).done;) {
            var dep = _step.value;

            if (dep) {
              effects.push.apply(effects, _toConsumableArray(dep));
            }
          }
        } catch (err) {
          _iterator.e(err);
        } finally {
          _iterator.f();
        }

        if (process.env.NODE_ENV !== 'production') {
          triggerEffects(createDep(effects), eventInfo);
        } else {
          triggerEffects(createDep(effects));
        }
      }
    }

    function triggerEffects(dep, debuggerEventExtraInfo) {
      // spread into array for stabilization
      var effects = isArray(dep) ? dep : _toConsumableArray(dep);

      var _iterator2 = _createForOfIteratorHelper(effects),
          _step2;

      try {
        for (_iterator2.s(); !(_step2 = _iterator2.n()).done;) {
          var _effect2 = _step2.value;

          if (_effect2.computed) {
            triggerEffect(_effect2, debuggerEventExtraInfo);
          }
        }
      } catch (err) {
        _iterator2.e(err);
      } finally {
        _iterator2.f();
      }

      var _iterator3 = _createForOfIteratorHelper(effects),
          _step3;

      try {
        for (_iterator3.s(); !(_step3 = _iterator3.n()).done;) {
          var _effect3 = _step3.value;

          if (!_effect3.computed) {
            triggerEffect(_effect3, debuggerEventExtraInfo);
          }
        }
      } catch (err) {
        _iterator3.e(err);
      } finally {
        _iterator3.f();
      }
    }

    function triggerEffect(effect, debuggerEventExtraInfo) {
      if (effect !== activeEffect || effect.allowRecurse) {
        if (process.env.NODE_ENV !== 'production' && effect.onTrigger) {
          effect.onTrigger(extend({
            effect: effect
          }, debuggerEventExtraInfo));
        }

        if (effect.scheduler) {
          effect.scheduler();
        } else {
          effect.run();
        }
      }
    }

    var isNonTrackableKeys = /*#__PURE__*/makeMap("__proto__,__v_isRef,__isVue");
    var builtInSymbols = new Set( /*#__PURE__*/Object.getOwnPropertyNames(Symbol) // ios10.x Object.getOwnPropertyNames(Symbol) can enumerate 'arguments' and 'caller'
    // but accessing them on Symbol leads to TypeError because Symbol is a strict mode
    // function
    .filter(function (key) {
      return key !== 'arguments' && key !== 'caller';
    }).map(function (key) {
      return Symbol[key];
    }).filter(isSymbol));
    var get = /*#__PURE__*/createGetter();
    var readonlyGet = /*#__PURE__*/createGetter(true);
    var shallowReadonlyGet = /*#__PURE__*/createGetter(true, true);
    var arrayInstrumentations = /*#__PURE__*/createArrayInstrumentations();

    function createArrayInstrumentations() {
      var instrumentations = {};
      ['includes', 'indexOf', 'lastIndexOf'].forEach(function (key) {
        instrumentations[key] = function () {
          var arr = toRaw(this);

          for (var i = 0, l = this.length; i < l; i++) {
            track(arr, "get"
            /* GET */
            , i + '');
          } // we run the method using the original args first (which may be reactive)


          for (var _len2 = arguments.length, args = new Array(_len2), _key3 = 0; _key3 < _len2; _key3++) {
            args[_key3] = arguments[_key3];
          }

          var res = arr[key].apply(arr, args);

          if (res === -1 || res === false) {
            // if that didn't work, run it again using raw values.
            return arr[key].apply(arr, _toConsumableArray(args.map(toRaw)));
          } else {
            return res;
          }
        };
      });
      ['push', 'pop', 'shift', 'unshift', 'splice'].forEach(function (key) {
        instrumentations[key] = function () {
          pauseTracking();

          for (var _len3 = arguments.length, args = new Array(_len3), _key4 = 0; _key4 < _len3; _key4++) {
            args[_key4] = arguments[_key4];
          }

          var res = toRaw(this)[key].apply(this, args);
          resetTracking();
          return res;
        };
      });
      return instrumentations;
    }

    function createGetter() {
      var isReadonly = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;
      var shallow = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;
      return function get(target, key, receiver) {
        if (key === "__v_isReactive"
        /* IS_REACTIVE */
        ) {
          return !isReadonly;
        } else if (key === "__v_isReadonly"
        /* IS_READONLY */
        ) {
          return isReadonly;
        } else if (key === "__v_isShallow"
        /* IS_SHALLOW */
        ) {
          return shallow;
        } else if (key === "__v_raw"
        /* RAW */
        && receiver === (isReadonly ? shallow ? shallowReadonlyMap : readonlyMap : shallow ? shallowReactiveMap : reactiveMap).get(target)) {
          return target;
        }

        var targetIsArray = isArray(target);

        if (!isReadonly && targetIsArray && hasOwn(arrayInstrumentations, key)) {
          return Reflect.get(arrayInstrumentations, key, receiver);
        }

        var res = Reflect.get(target, key, receiver);

        if (isSymbol(key) ? builtInSymbols.has(key) : isNonTrackableKeys(key)) {
          return res;
        }

        if (!isReadonly) {
          track(target, "get"
          /* GET */
          , key);
        }

        if (shallow) {
          return res;
        }

        if (isRef(res)) {
          // ref unwrapping - skip unwrap for Array + integer key.
          return targetIsArray && isIntegerKey(key) ? res : res.value;
        }

        if (isObject(res)) {
          // Convert returned value into a proxy as well. we do the isObject check
          // here to avoid invalid value warning. Also need to lazy access readonly
          // and reactive here to avoid circular dependency.
          return isReadonly ? readonly(res) : reactive(res);
        }

        return res;
      };
    }

    var set = /*#__PURE__*/createSetter();

    function createSetter() {
      var shallow = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;
      return function set(target, key, value, receiver) {
        var oldValue = target[key];

        if (isReadonly(oldValue) && isRef(oldValue) && !isRef(value)) {
          return false;
        }

        if (!shallow && !isReadonly(value)) {
          if (!isShallow$1(value)) {
            value = toRaw(value);
            oldValue = toRaw(oldValue);
          }

          if (!isArray(target) && isRef(oldValue) && !isRef(value)) {
            oldValue.value = value;
            return true;
          }
        }

        var hadKey = isArray(target) && isIntegerKey(key) ? Number(key) < target.length : hasOwn(target, key);
        var result = Reflect.set(target, key, value, receiver); // don't trigger if target is something up in the prototype chain of original

        if (target === toRaw(receiver)) {
          if (!hadKey) {
            trigger(target, "add"
            /* ADD */
            , key, value);
          } else if (hasChanged(value, oldValue)) {
            trigger(target, "set"
            /* SET */
            , key, value, oldValue);
          }
        }

        return result;
      };
    }

    function deleteProperty(target, key) {
      var hadKey = hasOwn(target, key);
      var oldValue = target[key];
      var result = Reflect.deleteProperty(target, key);

      if (result && hadKey) {
        trigger(target, "delete"
        /* DELETE */
        , key, undefined, oldValue);
      }

      return result;
    }

    function has(target, key) {
      var result = Reflect.has(target, key);

      if (!isSymbol(key) || !builtInSymbols.has(key)) {
        track(target, "has"
        /* HAS */
        , key);
      }

      return result;
    }

    function ownKeys(target) {
      track(target, "iterate"
      /* ITERATE */
      , isArray(target) ? 'length' : ITERATE_KEY);
      return Reflect.ownKeys(target);
    }

    var mutableHandlers = {
      get: get,
      set: set,
      deleteProperty: deleteProperty,
      has: has,
      ownKeys: ownKeys
    };
    var readonlyHandlers = {
      get: readonlyGet,
      set: function set(target, key) {
        if (process.env.NODE_ENV !== 'production') {
          warn$1("Set operation on key \"".concat(String(key), "\" failed: target is readonly."), target);
        }

        return true;
      },
      deleteProperty: function deleteProperty(target, key) {
        if (process.env.NODE_ENV !== 'production') {
          warn$1("Delete operation on key \"".concat(String(key), "\" failed: target is readonly."), target);
        }

        return true;
      }
    };
    // refs (in order to allow refs to be explicitly passed down), but should
    // retain the reactivity of the normal readonly object.

    var shallowReadonlyHandlers = /*#__PURE__*/extend({}, readonlyHandlers, {
      get: shallowReadonlyGet
    });

    var toShallow = function toShallow(value) {
      return value;
    };

    var getProto = function getProto(v) {
      return Reflect.getPrototypeOf(v);
    };

    function get$1(target, key) {
      var isReadonly = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;
      var isShallow = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : false;
      // #1772: readonly(reactive(Map)) should return readonly + reactive version
      // of the value
      target = target["__v_raw"
      /* RAW */
      ];
      var rawTarget = toRaw(target);
      var rawKey = toRaw(key);

      if (!isReadonly) {
        if (key !== rawKey) {
          track(rawTarget, "get"
          /* GET */
          , key);
        }

        track(rawTarget, "get"
        /* GET */
        , rawKey);
      }

      var _getProto = getProto(rawTarget),
          has = _getProto.has;

      var wrap = isShallow ? toShallow : isReadonly ? toReadonly : toReactive;

      if (has.call(rawTarget, key)) {
        return wrap(target.get(key));
      } else if (has.call(rawTarget, rawKey)) {
        return wrap(target.get(rawKey));
      } else if (target !== rawTarget) {
        // #3602 readonly(reactive(Map))
        // ensure that the nested reactive `Map` can do tracking for itself
        target.get(key);
      }
    }

    function has$1(key) {
      var isReadonly = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;
      var target = this["__v_raw"
      /* RAW */
      ];
      var rawTarget = toRaw(target);
      var rawKey = toRaw(key);

      if (!isReadonly) {
        if (key !== rawKey) {
          track(rawTarget, "has"
          /* HAS */
          , key);
        }

        track(rawTarget, "has"
        /* HAS */
        , rawKey);
      }

      return key === rawKey ? target.has(key) : target.has(key) || target.has(rawKey);
    }

    function size(target) {
      var isReadonly = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;
      target = target["__v_raw"
      /* RAW */
      ];
      !isReadonly && track(toRaw(target), "iterate"
      /* ITERATE */
      , ITERATE_KEY);
      return Reflect.get(target, 'size', target);
    }

    function add(value) {
      value = toRaw(value);
      var target = toRaw(this);
      var proto = getProto(target);
      var hadKey = proto.has.call(target, value);

      if (!hadKey) {
        target.add(value);
        trigger(target, "add"
        /* ADD */
        , value, value);
      }

      return this;
    }

    function set$1(key, value) {
      value = toRaw(value);
      var target = toRaw(this);

      var _getProto2 = getProto(target),
          has = _getProto2.has,
          get = _getProto2.get;

      var hadKey = has.call(target, key);

      if (!hadKey) {
        key = toRaw(key);
        hadKey = has.call(target, key);
      } else if (process.env.NODE_ENV !== 'production') {
        checkIdentityKeys(target, has, key);
      }

      var oldValue = get.call(target, key);
      target.set(key, value);

      if (!hadKey) {
        trigger(target, "add"
        /* ADD */
        , key, value);
      } else if (hasChanged(value, oldValue)) {
        trigger(target, "set"
        /* SET */
        , key, value, oldValue);
      }

      return this;
    }

    function deleteEntry(key) {
      var target = toRaw(this);

      var _getProto3 = getProto(target),
          has = _getProto3.has,
          get = _getProto3.get;

      var hadKey = has.call(target, key);

      if (!hadKey) {
        key = toRaw(key);
        hadKey = has.call(target, key);
      } else if (process.env.NODE_ENV !== 'production') {
        checkIdentityKeys(target, has, key);
      }

      var oldValue = get ? get.call(target, key) : undefined; // forward the operation before queueing reactions

      var result = target["delete"](key);

      if (hadKey) {
        trigger(target, "delete"
        /* DELETE */
        , key, undefined, oldValue);
      }

      return result;
    }

    function clear() {
      var target = toRaw(this);
      var hadItems = target.size !== 0;
      var oldTarget = process.env.NODE_ENV !== 'production' ? isMap(target) ? new Map(target) : new Set(target) : undefined; // forward the operation before queueing reactions

      var result = target.clear();

      if (hadItems) {
        trigger(target, "clear"
        /* CLEAR */
        , undefined, undefined, oldTarget);
      }

      return result;
    }

    function createForEach(isReadonly, isShallow) {
      return function forEach(callback, thisArg) {
        var observed = this;
        var target = observed["__v_raw"
        /* RAW */
        ];
        var rawTarget = toRaw(target);
        var wrap = isShallow ? toShallow : isReadonly ? toReadonly : toReactive;
        !isReadonly && track(rawTarget, "iterate"
        /* ITERATE */
        , ITERATE_KEY);
        return target.forEach(function (value, key) {
          // important: make sure the callback is
          // 1. invoked with the reactive map as `this` and 3rd arg
          // 2. the value received should be a corresponding reactive/readonly.
          return callback.call(thisArg, wrap(value), wrap(key), observed);
        });
      };
    }

    function createIterableMethod(method, isReadonly, isShallow) {
      return function () {
        var target = this["__v_raw"
        /* RAW */
        ];
        var rawTarget = toRaw(target);
        var targetIsMap = isMap(rawTarget);
        var isPair = method === 'entries' || method === Symbol.iterator && targetIsMap;
        var isKeyOnly = method === 'keys' && targetIsMap;
        var innerIterator = target[method].apply(target, arguments);
        var wrap = isShallow ? toShallow : isReadonly ? toReadonly : toReactive;
        !isReadonly && track(rawTarget, "iterate"
        /* ITERATE */
        , isKeyOnly ? MAP_KEY_ITERATE_KEY : ITERATE_KEY); // return a wrapped iterator which returns observed versions of the
        // values emitted from the real iterator

        return _defineProperty({
          // iterator protocol
          next: function next() {
            var _innerIterator$next = innerIterator.next(),
                value = _innerIterator$next.value,
                done = _innerIterator$next.done;

            return done ? {
              value: value,
              done: done
            } : {
              value: isPair ? [wrap(value[0]), wrap(value[1])] : wrap(value),
              done: done
            };
          }
        }, Symbol.iterator, function () {
          return this;
        });
      };
    }

    function createReadonlyMethod(type) {
      return function () {
        if (process.env.NODE_ENV !== 'production') {
          var key = (arguments.length <= 0 ? undefined : arguments[0]) ? "on key \"".concat(arguments.length <= 0 ? undefined : arguments[0], "\" ") : "";
          console.warn("".concat(capitalize(type), " operation ").concat(key, "failed: target is readonly."), toRaw(this));
        }

        return type === "delete"
        /* DELETE */
        ? false : this;
      };
    }

    function createInstrumentations() {
      var mutableInstrumentations = {
        get: function get(key) {
          return get$1(this, key);
        },

        get size() {
          return size(this);
        },

        has: has$1,
        add: add,
        set: set$1,
        "delete": deleteEntry,
        clear: clear,
        forEach: createForEach(false, false)
      };
      var shallowInstrumentations = {
        get: function get(key) {
          return get$1(this, key, false, true);
        },

        get size() {
          return size(this);
        },

        has: has$1,
        add: add,
        set: set$1,
        "delete": deleteEntry,
        clear: clear,
        forEach: createForEach(false, true)
      };
      var readonlyInstrumentations = {
        get: function get(key) {
          return get$1(this, key, true);
        },

        get size() {
          return size(this, true);
        },

        has: function has(key) {
          return has$1.call(this, key, true);
        },
        add: createReadonlyMethod("add"
        /* ADD */
        ),
        set: createReadonlyMethod("set"
        /* SET */
        ),
        "delete": createReadonlyMethod("delete"
        /* DELETE */
        ),
        clear: createReadonlyMethod("clear"
        /* CLEAR */
        ),
        forEach: createForEach(true, false)
      };
      var shallowReadonlyInstrumentations = {
        get: function get(key) {
          return get$1(this, key, true, true);
        },

        get size() {
          return size(this, true);
        },

        has: function has(key) {
          return has$1.call(this, key, true);
        },
        add: createReadonlyMethod("add"
        /* ADD */
        ),
        set: createReadonlyMethod("set"
        /* SET */
        ),
        "delete": createReadonlyMethod("delete"
        /* DELETE */
        ),
        clear: createReadonlyMethod("clear"
        /* CLEAR */
        ),
        forEach: createForEach(true, true)
      };
      var iteratorMethods = ['keys', 'values', 'entries', Symbol.iterator];
      iteratorMethods.forEach(function (method) {
        mutableInstrumentations[method] = createIterableMethod(method, false, false);
        readonlyInstrumentations[method] = createIterableMethod(method, true, false);
        shallowInstrumentations[method] = createIterableMethod(method, false, true);
        shallowReadonlyInstrumentations[method] = createIterableMethod(method, true, true);
      });
      return [mutableInstrumentations, readonlyInstrumentations, shallowInstrumentations, shallowReadonlyInstrumentations];
    }

    var _createInstrumentatio = /* #__PURE__*/createInstrumentations(),
        _createInstrumentatio2 = _slicedToArray(_createInstrumentatio, 4),
        mutableInstrumentations = _createInstrumentatio2[0],
        readonlyInstrumentations = _createInstrumentatio2[1],
        shallowInstrumentations = _createInstrumentatio2[2],
        shallowReadonlyInstrumentations = _createInstrumentatio2[3];

    function createInstrumentationGetter(isReadonly, shallow) {
      var instrumentations = shallow ? isReadonly ? shallowReadonlyInstrumentations : shallowInstrumentations : isReadonly ? readonlyInstrumentations : mutableInstrumentations;
      return function (target, key, receiver) {
        if (key === "__v_isReactive"
        /* IS_REACTIVE */
        ) {
          return !isReadonly;
        } else if (key === "__v_isReadonly"
        /* IS_READONLY */
        ) {
          return isReadonly;
        } else if (key === "__v_raw"
        /* RAW */
        ) {
          return target;
        }

        return Reflect.get(hasOwn(instrumentations, key) && key in target ? instrumentations : target, key, receiver);
      };
    }

    var mutableCollectionHandlers = {
      get: /*#__PURE__*/createInstrumentationGetter(false, false)
    };
    var readonlyCollectionHandlers = {
      get: /*#__PURE__*/createInstrumentationGetter(true, false)
    };
    var shallowReadonlyCollectionHandlers = {
      get: /*#__PURE__*/createInstrumentationGetter(true, true)
    };

    function checkIdentityKeys(target, has, key) {
      var rawKey = toRaw(key);

      if (rawKey !== key && has.call(target, rawKey)) {
        var type = toRawType(target);
        console.warn("Reactive ".concat(type, " contains both the raw and reactive ") + "versions of the same object".concat(type === "Map" ? " as keys" : "", ", ") + "which can lead to inconsistencies. " + "Avoid differentiating between the raw and reactive versions " + "of an object and only use the reactive version if possible.");
      }
    }

    var reactiveMap = new WeakMap();
    var shallowReactiveMap = new WeakMap();
    var readonlyMap = new WeakMap();
    var shallowReadonlyMap = new WeakMap();

    function targetTypeMap(rawType) {
      switch (rawType) {
        case 'Object':
        case 'Array':
          return 1
          /* COMMON */
          ;

        case 'Map':
        case 'Set':
        case 'WeakMap':
        case 'WeakSet':
          return 2
          /* COLLECTION */
          ;

        default:
          return 0
          /* INVALID */
          ;
      }
    }

    function getTargetType(value) {
      return value["__v_skip"
      /* SKIP */
      ] || !Object.isExtensible(value) ? 0
      /* INVALID */
      : targetTypeMap(toRawType(value));
    }

    function reactive(target) {
      // if trying to observe a readonly proxy, return the readonly version.
      if (isReadonly(target)) {
        return target;
      }

      return createReactiveObject(target, false, mutableHandlers, mutableCollectionHandlers, reactiveMap);
    }
    /**
     * Creates a readonly copy of the original object. Note the returned copy is not
     * made reactive, but `readonly` can be called on an already reactive object.
     */


    function readonly(target) {
      return createReactiveObject(target, true, readonlyHandlers, readonlyCollectionHandlers, readonlyMap);
    }
    /**
     * Returns a reactive-copy of the original object, where only the root level
     * properties are readonly, and does NOT unwrap refs nor recursively convert
     * returned properties.
     * This is used for creating the props proxy object for stateful components.
     */


    function shallowReadonly(target) {
      return createReactiveObject(target, true, shallowReadonlyHandlers, shallowReadonlyCollectionHandlers, shallowReadonlyMap);
    }

    function createReactiveObject(target, isReadonly, baseHandlers, collectionHandlers, proxyMap) {
      if (!isObject(target)) {
        if (process.env.NODE_ENV !== 'production') {
          console.warn("value cannot be made reactive: ".concat(String(target)));
        }

        return target;
      } // target is already a Proxy, return it.
      // exception: calling readonly() on a reactive object


      if (target["__v_raw"
      /* RAW */
      ] && !(isReadonly && target["__v_isReactive"
      /* IS_REACTIVE */
      ])) {
        return target;
      } // target already has corresponding Proxy


      var existingProxy = proxyMap.get(target);

      if (existingProxy) {
        return existingProxy;
      } // only specific value types can be observed.


      var targetType = getTargetType(target);

      if (targetType === 0
      /* INVALID */
      ) {
        return target;
      }

      var proxy = new Proxy(target, targetType === 2
      /* COLLECTION */
      ? collectionHandlers : baseHandlers);
      proxyMap.set(target, proxy);
      return proxy;
    }

    function isReactive(value) {
      if (isReadonly(value)) {
        return isReactive(value["__v_raw"
        /* RAW */
        ]);
      }

      return !!(value && value["__v_isReactive"
      /* IS_REACTIVE */
      ]);
    }

    function isReadonly(value) {
      return !!(value && value["__v_isReadonly"
      /* IS_READONLY */
      ]);
    }

    function isShallow$1(value) {
      return !!(value && value["__v_isShallow"
      /* IS_SHALLOW */
      ]);
    }

    function isProxy(value) {
      return isReactive(value) || isReadonly(value);
    }

    function toRaw(observed) {
      var raw = observed && observed["__v_raw"
      /* RAW */
      ];
      return raw ? toRaw(raw) : observed;
    }

    function markRaw(value) {
      def(value, "__v_skip"
      /* SKIP */
      , true);
      return value;
    }

    var toReactive = function toReactive(value) {
      return isObject(value) ? reactive(value) : value;
    };

    var toReadonly = function toReadonly(value) {
      return isObject(value) ? readonly(value) : value;
    };

    function isRef(r) {
      return !!(r && r.__v_isRef === true);
    }

    function unref(ref) {
      return isRef(ref) ? ref.value : ref;
    }

    var shallowUnwrapHandlers = {
      get: function get(target, key, receiver) {
        return unref(Reflect.get(target, key, receiver));
      },
      set: function set(target, key, value, receiver) {
        var oldValue = target[key];

        if (isRef(oldValue) && !isRef(value)) {
          oldValue.value = value;
          return true;
        } else {
          return Reflect.set(target, key, value, receiver);
        }
      }
    };

    function proxyRefs(objectWithRefs) {
      return isReactive(objectWithRefs) ? objectWithRefs : new Proxy(objectWithRefs, shallowUnwrapHandlers);
    }

    var _ErrorTypeStrings;
    var stack = [];

    function pushWarningContext(vnode) {
      stack.push(vnode);
    }

    function popWarningContext() {
      stack.pop();
    }

    function warn(msg) {
      // avoid props formatting or warn handler tracking deps that might be mutated
      // during patch, leading to infinite recursion.
      pauseTracking();
      var instance = stack.length ? stack[stack.length - 1].component : null;
      var appWarnHandler = instance && instance.appContext.config.warnHandler;
      var trace = getComponentTrace();

      for (var _len = arguments.length, args = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
        args[_key - 1] = arguments[_key];
      }

      if (appWarnHandler) {
        callWithErrorHandling(appWarnHandler, instance, 11
        /* APP_WARN_HANDLER */
        , [msg + args.join(''), instance && instance.proxy, trace.map(function (_ref) {
          var vnode = _ref.vnode;
          return "at <".concat(formatComponentName(instance, vnode.type), ">");
        }).join('\n'), trace]);
      } else {
        var _console;

        var warnArgs = ["[Vue warn]: ".concat(msg)].concat(args);
        /* istanbul ignore if */

        if (trace.length && // avoid spamming console during tests
        !false) {
          warnArgs.push.apply(warnArgs, ["\n"].concat(_toConsumableArray(formatTrace(trace))));
        }

        (_console = console).warn.apply(_console, _toConsumableArray(warnArgs));
      }

      resetTracking();
    }

    function getComponentTrace() {
      var currentVNode = stack[stack.length - 1];

      if (!currentVNode) {
        return [];
      } // we can't just use the stack because it will be incomplete during updates
      // that did not start from the root. Re-construct the parent chain using
      // instance parent pointers.


      var normalizedStack = [];

      while (currentVNode) {
        var last = normalizedStack[0];

        if (last && last.vnode === currentVNode) {
          last.recurseCount++;
        } else {
          normalizedStack.push({
            vnode: currentVNode,
            recurseCount: 0
          });
        }

        var parentInstance = currentVNode.component && currentVNode.component.parent;
        currentVNode = parentInstance && parentInstance.vnode;
      }

      return normalizedStack;
    }
    /* istanbul ignore next */


    function formatTrace(trace) {
      var logs = [];
      trace.forEach(function (entry, i) {
        logs.push.apply(logs, _toConsumableArray(i === 0 ? [] : ["\n"]).concat(_toConsumableArray(formatTraceEntry(entry))));
      });
      return logs;
    }

    function formatTraceEntry(_ref2) {
      var vnode = _ref2.vnode,
          recurseCount = _ref2.recurseCount;
      var postfix = recurseCount > 0 ? "... (".concat(recurseCount, " recursive calls)") : "";
      var isRoot = vnode.component ? vnode.component.parent == null : false;
      var open = " at <".concat(formatComponentName(vnode.component, vnode.type, isRoot));
      var close = ">" + postfix;
      return vnode.props ? [open].concat(_toConsumableArray(formatProps(vnode.props)), [close]) : [open + close];
    }
    /* istanbul ignore next */


    function formatProps(props) {
      var res = [];
      var keys = Object.keys(props);
      keys.slice(0, 3).forEach(function (key) {
        res.push.apply(res, _toConsumableArray(formatProp(key, props[key])));
      });

      if (keys.length > 3) {
        res.push(" ...");
      }

      return res;
    }
    /* istanbul ignore next */


    function formatProp(key, value, raw) {
      if (isString(value)) {
        value = JSON.stringify(value);
        return raw ? value : ["".concat(key, "=").concat(value)];
      } else if (typeof value === 'number' || typeof value === 'boolean' || value == null) {
        return raw ? value : ["".concat(key, "=").concat(value)];
      } else if (isRef(value)) {
        value = formatProp(key, toRaw(value.value), true);
        return raw ? value : ["".concat(key, "=Ref<"), value, ">"];
      } else if (isFunction(value)) {
        return ["".concat(key, "=fn").concat(value.name ? "<".concat(value.name, ">") : "")];
      } else {
        value = toRaw(value);
        return raw ? value : ["".concat(key, "="), value];
      }
    }

    var ErrorTypeStrings = (_ErrorTypeStrings = {}, _defineProperty(_ErrorTypeStrings, "sp"
    /* SERVER_PREFETCH */
    , 'serverPrefetch hook'), _defineProperty(_ErrorTypeStrings, "bc"
    /* BEFORE_CREATE */
    , 'beforeCreate hook'), _defineProperty(_ErrorTypeStrings, "c"
    /* CREATED */
    , 'created hook'), _defineProperty(_ErrorTypeStrings, "bm"
    /* BEFORE_MOUNT */
    , 'beforeMount hook'), _defineProperty(_ErrorTypeStrings, "m"
    /* MOUNTED */
    , 'mounted hook'), _defineProperty(_ErrorTypeStrings, "bu"
    /* BEFORE_UPDATE */
    , 'beforeUpdate hook'), _defineProperty(_ErrorTypeStrings, "u"
    /* UPDATED */
    , 'updated'), _defineProperty(_ErrorTypeStrings, "bum"
    /* BEFORE_UNMOUNT */
    , 'beforeUnmount hook'), _defineProperty(_ErrorTypeStrings, "um"
    /* UNMOUNTED */
    , 'unmounted hook'), _defineProperty(_ErrorTypeStrings, "a"
    /* ACTIVATED */
    , 'activated hook'), _defineProperty(_ErrorTypeStrings, "da"
    /* DEACTIVATED */
    , 'deactivated hook'), _defineProperty(_ErrorTypeStrings, "ec"
    /* ERROR_CAPTURED */
    , 'errorCaptured hook'), _defineProperty(_ErrorTypeStrings, "rtc"
    /* RENDER_TRACKED */
    , 'renderTracked hook'), _defineProperty(_ErrorTypeStrings, "rtg"
    /* RENDER_TRIGGERED */
    , 'renderTriggered hook'), _defineProperty(_ErrorTypeStrings, 0
    /* SETUP_FUNCTION */
    , 'setup function'), _defineProperty(_ErrorTypeStrings, 1
    /* RENDER_FUNCTION */
    , 'render function'), _defineProperty(_ErrorTypeStrings, 2
    /* WATCH_GETTER */
    , 'watcher getter'), _defineProperty(_ErrorTypeStrings, 3
    /* WATCH_CALLBACK */
    , 'watcher callback'), _defineProperty(_ErrorTypeStrings, 4
    /* WATCH_CLEANUP */
    , 'watcher cleanup function'), _defineProperty(_ErrorTypeStrings, 5
    /* NATIVE_EVENT_HANDLER */
    , 'native event handler'), _defineProperty(_ErrorTypeStrings, 6
    /* COMPONENT_EVENT_HANDLER */
    , 'component event handler'), _defineProperty(_ErrorTypeStrings, 7
    /* VNODE_HOOK */
    , 'vnode hook'), _defineProperty(_ErrorTypeStrings, 8
    /* DIRECTIVE_HOOK */
    , 'directive hook'), _defineProperty(_ErrorTypeStrings, 9
    /* TRANSITION_HOOK */
    , 'transition hook'), _defineProperty(_ErrorTypeStrings, 10
    /* APP_ERROR_HANDLER */
    , 'app errorHandler'), _defineProperty(_ErrorTypeStrings, 11
    /* APP_WARN_HANDLER */
    , 'app warnHandler'), _defineProperty(_ErrorTypeStrings, 12
    /* FUNCTION_REF */
    , 'ref function'), _defineProperty(_ErrorTypeStrings, 13
    /* ASYNC_COMPONENT_LOADER */
    , 'async component loader'), _defineProperty(_ErrorTypeStrings, 14
    /* SCHEDULER */
    , 'scheduler flush. This is likely a Vue internals bug. ' + 'Please open an issue at https://new-issue.vuejs.org/?repo=vuejs/core'), _ErrorTypeStrings);

    function callWithErrorHandling(fn, instance, type, args) {
      var res;

      try {
        res = args ? fn.apply(void 0, _toConsumableArray(args)) : fn();
      } catch (err) {
        handleError(err, instance, type);
      }

      return res;
    }

    function callWithAsyncErrorHandling(fn, instance, type, args) {
      if (isFunction(fn)) {
        var res = callWithErrorHandling(fn, instance, type, args);

        if (res && isPromise(res)) {
          res["catch"](function (err) {
            handleError(err, instance, type);
          });
        }

        return res;
      }

      var values = [];

      for (var i = 0; i < fn.length; i++) {
        values.push(callWithAsyncErrorHandling(fn[i], instance, type, args));
      }

      return values;
    }

    function handleError(err, instance, type) {
      var throwInDev = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : true;
      var contextVNode = instance ? instance.vnode : null;

      if (instance) {
        var cur = instance.parent; // the exposed instance is the render proxy to keep it consistent with 2.x

        var exposedInstance = instance.proxy; // in production the hook receives only the error code

        var errorInfo = process.env.NODE_ENV !== 'production' ? ErrorTypeStrings[type] : type;

        while (cur) {
          var errorCapturedHooks = cur.ec;

          if (errorCapturedHooks) {
            for (var i = 0; i < errorCapturedHooks.length; i++) {
              if (errorCapturedHooks[i](err, exposedInstance, errorInfo) === false) {
                return;
              }
            }
          }

          cur = cur.parent;
        } // app-level handling


        var appErrorHandler = instance.appContext.config.errorHandler;

        if (appErrorHandler) {
          callWithErrorHandling(appErrorHandler, null, 10
          /* APP_ERROR_HANDLER */
          , [err, exposedInstance, errorInfo]);
          return;
        }
      }

      logError(err, type, contextVNode, throwInDev);
    }

    function logError(err, type, contextVNode) {
      var throwInDev = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : true;

      if (process.env.NODE_ENV !== 'production') {
        var info = ErrorTypeStrings[type];

        if (contextVNode) {
          pushWarningContext(contextVNode);
        }

        warn("Unhandled error".concat(info ? " during execution of ".concat(info) : ""));

        if (contextVNode) {
          popWarningContext();
        } // crash in dev by default so it's more noticeable


        if (throwInDev) {
          throw err;
        } else {
          console.error(err);
        }
      } else {
        // recover in prod to reduce the impact on end-user
        console.error(err);
      }
    }

    var isFlushing = false;
    var isFlushPending = false;
    var queue = [];
    var flushIndex = 0;
    var pendingPreFlushCbs = [];
    var activePreFlushCbs = null;
    var preFlushIndex = 0;
    var pendingPostFlushCbs = [];
    var activePostFlushCbs = null;
    var postFlushIndex = 0;
    var resolvedPromise = /*#__PURE__*/Promise.resolve();
    var currentFlushPromise = null;
    var currentPreFlushParentJob = null;
    var RECURSION_LIMIT = 100;

    function nextTick(fn) {
      var p = currentFlushPromise || resolvedPromise;
      return fn ? p.then(this ? fn.bind(this) : fn) : p;
    } // #2768
    // Use binary-search to find a suitable position in the queue,
    // so that the queue maintains the increasing order of job's id,
    // which can prevent the job from being skipped and also can avoid repeated patching.


    function findInsertionIndex(id) {
      // the start index should be `flushIndex + 1`
      var start = flushIndex + 1;
      var end = queue.length;

      while (start < end) {
        var middle = start + end >>> 1;
        var middleJobId = getId(queue[middle]);
        middleJobId < id ? start = middle + 1 : end = middle;
      }

      return start;
    }

    function queueJob(job) {
      // the dedupe search uses the startIndex argument of Array.includes()
      // by default the search index includes the current job that is being run
      // so it cannot recursively trigger itself again.
      // if the job is a watch() callback, the search will start with a +1 index to
      // allow it recursively trigger itself - it is the user's responsibility to
      // ensure it doesn't end up in an infinite loop.
      if ((!queue.length || !queue.includes(job, isFlushing && job.allowRecurse ? flushIndex + 1 : flushIndex)) && job !== currentPreFlushParentJob) {
        if (job.id == null) {
          queue.push(job);
        } else {
          queue.splice(findInsertionIndex(job.id), 0, job);
        }

        queueFlush();
      }
    }

    function queueFlush() {
      if (!isFlushing && !isFlushPending) {
        isFlushPending = true;
        currentFlushPromise = resolvedPromise.then(flushJobs);
      }
    }

    function queueCb(cb, activeQueue, pendingQueue, index) {
      if (!isArray(cb)) {
        if (!activeQueue || !activeQueue.includes(cb, cb.allowRecurse ? index + 1 : index)) {
          pendingQueue.push(cb);
        }
      } else {
        // if cb is an array, it is a component lifecycle hook which can only be
        // triggered by a job, which is already deduped in the main queue, so
        // we can skip duplicate check here to improve perf
        pendingQueue.push.apply(pendingQueue, _toConsumableArray(cb));
      }

      queueFlush();
    }

    function queuePreFlushCb(cb) {
      queueCb(cb, activePreFlushCbs, pendingPreFlushCbs, preFlushIndex);
    }

    function queuePostFlushCb(cb) {
      queueCb(cb, activePostFlushCbs, pendingPostFlushCbs, postFlushIndex);
    }

    function flushPreFlushCbs(seen) {
      var parentJob = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;

      if (pendingPreFlushCbs.length) {
        currentPreFlushParentJob = parentJob;
        activePreFlushCbs = _toConsumableArray(new Set(pendingPreFlushCbs));
        pendingPreFlushCbs.length = 0;

        if (process.env.NODE_ENV !== 'production') {
          seen = seen || new Map();
        }

        for (preFlushIndex = 0; preFlushIndex < activePreFlushCbs.length; preFlushIndex++) {
          if (process.env.NODE_ENV !== 'production' && checkRecursiveUpdates(seen, activePreFlushCbs[preFlushIndex])) {
            continue;
          }

          activePreFlushCbs[preFlushIndex]();
        }

        activePreFlushCbs = null;
        preFlushIndex = 0;
        currentPreFlushParentJob = null; // recursively flush until it drains

        flushPreFlushCbs(seen, parentJob);
      }
    }

    function flushPostFlushCbs(seen) {
      // flush any pre cbs queued during the flush (e.g. pre watchers)
      flushPreFlushCbs();

      if (pendingPostFlushCbs.length) {
        var deduped = _toConsumableArray(new Set(pendingPostFlushCbs));

        pendingPostFlushCbs.length = 0; // #1947 already has active queue, nested flushPostFlushCbs call

        if (activePostFlushCbs) {
          var _activePostFlushCbs;

          (_activePostFlushCbs = activePostFlushCbs).push.apply(_activePostFlushCbs, _toConsumableArray(deduped));

          return;
        }

        activePostFlushCbs = deduped;

        if (process.env.NODE_ENV !== 'production') {
          seen = seen || new Map();
        }

        activePostFlushCbs.sort(function (a, b) {
          return getId(a) - getId(b);
        });

        for (postFlushIndex = 0; postFlushIndex < activePostFlushCbs.length; postFlushIndex++) {
          if (process.env.NODE_ENV !== 'production' && checkRecursiveUpdates(seen, activePostFlushCbs[postFlushIndex])) {
            continue;
          }

          activePostFlushCbs[postFlushIndex]();
        }

        activePostFlushCbs = null;
        postFlushIndex = 0;
      }
    }

    var getId = function getId(job) {
      return job.id == null ? Infinity : job.id;
    };

    function flushJobs(seen) {
      isFlushPending = false;
      isFlushing = true;

      if (process.env.NODE_ENV !== 'production') {
        seen = seen || new Map();
      }

      flushPreFlushCbs(seen); // Sort queue before flush.
      // This ensures that:
      // 1. Components are updated from parent to child. (because parent is always
      //    created before the child so its render effect will have smaller
      //    priority number)
      // 2. If a component is unmounted during a parent component's update,
      //    its update can be skipped.

      queue.sort(function (a, b) {
        return getId(a) - getId(b);
      }); // conditional usage of checkRecursiveUpdate must be determined out of
      // try ... catch block since Rollup by default de-optimizes treeshaking
      // inside try-catch. This can leave all warning code unshaked. Although
      // they would get eventually shaken by a minifier like terser, some minifiers
      // would fail to do that (e.g. https://github.com/evanw/esbuild/issues/1610)

      var check = process.env.NODE_ENV !== 'production' ? function (job) {
        return checkRecursiveUpdates(seen, job);
      } : NOOP;

      try {
        for (flushIndex = 0; flushIndex < queue.length; flushIndex++) {
          var job = queue[flushIndex];

          if (job && job.active !== false) {
            if (process.env.NODE_ENV !== 'production' && check(job)) {
              continue;
            } // console.log(`running:`, job.id)


            callWithErrorHandling(job, null, 14
            /* SCHEDULER */
            );
          }
        }
      } finally {
        flushIndex = 0;
        queue.length = 0;
        flushPostFlushCbs(seen);
        isFlushing = false;
        currentFlushPromise = null; // some postFlushCb queued jobs!
        // keep flushing until it drains.

        if (queue.length || pendingPreFlushCbs.length || pendingPostFlushCbs.length) {
          flushJobs(seen);
        }
      }
    }

    function checkRecursiveUpdates(seen, fn) {
      if (!seen.has(fn)) {
        seen.set(fn, 1);
      } else {
        var count = seen.get(fn);

        if (count > RECURSION_LIMIT) {
          var instance = fn.ownerInstance;
          var componentName = instance && getComponentName(instance.type);
          warn("Maximum recursive updates exceeded".concat(componentName ? " in component <".concat(componentName, ">") : "", ". ") + "This means you have a reactive effect that is mutating its own " + "dependencies and thus recursively triggering itself. Possible sources " + "include component template, render function, updated hook or " + "watcher source function.");
          return true;
        } else {
          seen.set(fn, count + 1);
        }
      }
    }
    var hmrDirtyComponents = new Set(); // Expose the HMR runtime on the global object
    // This makes it entirely tree-shakable without polluting the exports and makes
    // it easier to be used in toolings like vue-loader
    // Note: for a component to be eligible for HMR it also needs the __hmrId option
    // to be set so that its instances can be registered / removed.

    if (process.env.NODE_ENV !== 'production') {
      getGlobalThis().__VUE_HMR_RUNTIME__ = {
        createRecord: tryWrap(createRecord),
        rerender: tryWrap(rerender),
        reload: tryWrap(reload)
      };
    }

    var map = new Map();

    function createRecord(id, initialDef) {
      if (map.has(id)) {
        return false;
      }

      map.set(id, {
        initialDef: normalizeClassComponent(initialDef),
        instances: new Set()
      });
      return true;
    }

    function normalizeClassComponent(component) {
      return isClassComponent(component) ? component.__vccOpts : component;
    }

    function rerender(id, newRender) {
      var record = map.get(id);

      if (!record) {
        return;
      } // update initial record (for not-yet-rendered component)


      record.initialDef.render = newRender;

      _toConsumableArray(record.instances).forEach(function (instance) {
        if (newRender) {
          instance.render = newRender;
          normalizeClassComponent(instance.type).render = newRender;
        }

        instance.renderCache = []; // this flag forces child components with slot content to update
        instance.update();
      });
    }

    function reload(id, newComp) {
      var record = map.get(id);
      if (!record) return;
      newComp = normalizeClassComponent(newComp); // update initial def (for not-yet-rendered components)

      updateComponentDef(record.initialDef, newComp); // create a snapshot which avoids the set being mutated during updates

      var instances = _toConsumableArray(record.instances);

      var _iterator = _createForOfIteratorHelper(instances),
          _step;

      try {
        for (_iterator.s(); !(_step = _iterator.n()).done;) {
          var instance = _step.value;
          var oldComp = normalizeClassComponent(instance.type);

          if (!hmrDirtyComponents.has(oldComp)) {
            // 1. Update existing comp definition to match new one
            if (oldComp !== record.initialDef) {
              updateComponentDef(oldComp, newComp);
            } // 2. mark definition dirty. This forces the renderer to replace the
            // component on patch.


            hmrDirtyComponents.add(oldComp);
          } // 3. invalidate options resolution cache


          instance.appContext.optionsCache["delete"](instance.type); // 4. actually update

          if (instance.ceReload) {
            // custom element
            hmrDirtyComponents.add(oldComp);
            instance.ceReload(newComp.styles);
            hmrDirtyComponents["delete"](oldComp);
          } else if (instance.parent) {
            // 4. Force the parent instance to re-render. This will cause all updated
            // components to be unmounted and re-mounted. Queue the update so that we
            // don't end up forcing the same parent to re-render multiple times.
            queueJob(instance.parent.update); // instance is the inner component of an async custom element
            // invoke to reset styles

            if (instance.parent.type.__asyncLoader && instance.parent.ceReload) {
              instance.parent.ceReload(newComp.styles);
            }
          } else if (instance.appContext.reload) {
            // root instance mounted via createApp() has a reload method
            instance.appContext.reload();
          } else if (typeof window !== 'undefined') {
            // root instance inside tree created via raw render(). Force reload.
            window.location.reload();
          } else {
            console.warn('[HMR] Root or manually mounted instance modified. Full reload required.');
          }
        } // 5. make sure to cleanup dirty hmr components after update

      } catch (err) {
        _iterator.e(err);
      } finally {
        _iterator.f();
      }

      queuePostFlushCb(function () {
        var _iterator2 = _createForOfIteratorHelper(instances),
            _step2;

        try {
          for (_iterator2.s(); !(_step2 = _iterator2.n()).done;) {
            var instance = _step2.value;
            hmrDirtyComponents["delete"](normalizeClassComponent(instance.type));
          }
        } catch (err) {
          _iterator2.e(err);
        } finally {
          _iterator2.f();
        }
      });
    }

    function updateComponentDef(oldComp, newComp) {
      extend(oldComp, newComp);

      for (var key in oldComp) {
        if (key !== '__file' && !(key in newComp)) {
          delete oldComp[key];
        }
      }
    }

    function tryWrap(fn) {
      return function (id, arg) {
        try {
          return fn(id, arg);
        } catch (e) {
          console.error(e);
          console.warn("[HMR] Something went wrong during Vue component hot-reload. " + "Full reload required.");
        }
      };
    }
    /**
     * mark the current rendering instance for asset resolution (e.g.
     * resolveComponent, resolveDirective) during render
     */


    var currentRenderingInstance = null;
    var currentScopeId = null;

    function markAttrsAccessed() {
    }

    var isSuspense = function isSuspense(type) {
      return type.__isSuspense;
    }; // Suspense exposes a component-like API, and is treated like a component

    function queueEffectWithSuspense(fn, suspense) {
      if (suspense && suspense.pendingBranch) {
        if (isArray(fn)) {
          var _suspense$effects;

          (_suspense$effects = suspense.effects).push.apply(_suspense$effects, _toConsumableArray(fn));
        } else {
          suspense.effects.push(fn);
        }
      } else {
        queuePostFlushCb(fn);
      }
    }

    function inject(key, defaultValue) {
      var treatDefaultAsFactory = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;
      // fallback to `currentRenderingInstance` so that this can be called in
      // a functional component
      var instance = currentInstance || currentRenderingInstance;

      if (instance) {
        // #2400
        // to support `app.use` plugins,
        // fallback to appContext's `provides` if the instance is at root
        var provides = instance.parent == null ? instance.vnode.appContext && instance.vnode.appContext.provides : instance.parent.provides;

        if (provides && key in provides) {
          // TS doesn't allow symbol as index type
          return provides[key];
        } else if (arguments.length > 1) {
          return treatDefaultAsFactory && isFunction(defaultValue) ? defaultValue.call(instance.proxy) : defaultValue;
        } else if (process.env.NODE_ENV !== 'production') {
          warn("injection \"".concat(String(key), "\" not found."));
        }
      } else if (process.env.NODE_ENV !== 'production') {
        warn("inject() can only be used inside setup() or functional components.");
      }
    } // Simple effect.


    var INITIAL_WATCHER_VALUE = {}; // implementation

    function doWatch(source, cb) {
      var _ref7 = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : EMPTY_OBJ,
          immediate = _ref7.immediate,
          deep = _ref7.deep,
          flush = _ref7.flush,
          onTrack = _ref7.onTrack,
          onTrigger = _ref7.onTrigger;

      if (process.env.NODE_ENV !== 'production' && !cb) {
        if (immediate !== undefined) {
          warn("watch() \"immediate\" option is only respected when using the " + "watch(source, callback, options?) signature.");
        }

        if (deep !== undefined) {
          warn("watch() \"deep\" option is only respected when using the " + "watch(source, callback, options?) signature.");
        }
      }

      var warnInvalidSource = function warnInvalidSource(s) {
        warn("Invalid watch source: ", s, "A watch source can only be a getter/effect function, a ref, " + "a reactive object, or an array of these types.");
      };

      var instance = currentInstance;
      var getter;
      var forceTrigger = false;
      var isMultiSource = false;

      if (isRef(source)) {
        getter = function getter() {
          return source.value;
        };

        forceTrigger = isShallow$1(source);
      } else if (isReactive(source)) {
        getter = function getter() {
          return source;
        };

        deep = true;
      } else if (isArray(source)) {
        isMultiSource = true;
        forceTrigger = source.some(function (s) {
          return isReactive(s) || isShallow$1(s);
        });

        getter = function getter() {
          return source.map(function (s) {
            if (isRef(s)) {
              return s.value;
            } else if (isReactive(s)) {
              return traverse(s);
            } else if (isFunction(s)) {
              return callWithErrorHandling(s, instance, 2
              /* WATCH_GETTER */
              );
            } else {
              process.env.NODE_ENV !== 'production' && warnInvalidSource(s);
            }
          });
        };
      } else if (isFunction(source)) {
        if (cb) {
          // getter with cb
          getter = function getter() {
            return callWithErrorHandling(source, instance, 2
            /* WATCH_GETTER */
            );
          };
        } else {
          // no cb -> simple effect
          getter = function getter() {
            if (instance && instance.isUnmounted) {
              return;
            }

            if (cleanup) {
              cleanup();
            }

            return callWithAsyncErrorHandling(source, instance, 3
            /* WATCH_CALLBACK */
            , [onCleanup]);
          };
        }
      } else {
        getter = NOOP;
        process.env.NODE_ENV !== 'production' && warnInvalidSource(source);
      }

      if (cb && deep) {
        var baseGetter = getter;

        getter = function getter() {
          return traverse(baseGetter());
        };
      }

      var cleanup;

      var onCleanup = function onCleanup(fn) {
        cleanup = effect.onStop = function () {
          callWithErrorHandling(fn, instance, 4
          /* WATCH_CLEANUP */
          );
        };
      }; // in SSR there is no need to setup an actual effect, and it should be noop

      var oldValue = isMultiSource ? [] : INITIAL_WATCHER_VALUE;

      var job = function job() {
        if (!effect.active) {
          return;
        }

        if (cb) {
          // watch(source, cb)
          var newValue = effect.run();

          if (deep || forceTrigger || (isMultiSource ? newValue.some(function (v, i) {
            return hasChanged(v, oldValue[i]);
          }) : hasChanged(newValue, oldValue)) || false) {
            // cleanup before running cb again
            if (cleanup) {
              cleanup();
            }

            callWithAsyncErrorHandling(cb, instance, 3
            /* WATCH_CALLBACK */
            , [newValue, // pass undefined as the old value when it's changed for the first time
            oldValue === INITIAL_WATCHER_VALUE ? undefined : oldValue, onCleanup]);
            oldValue = newValue;
          }
        } else {
          // watchEffect
          effect.run();
        }
      }; // important: mark the job as a watcher callback so that scheduler knows
      // it is allowed to self-trigger (#1727)


      job.allowRecurse = !!cb;
      var scheduler;

      if (flush === 'sync') {
        scheduler = job; // the scheduler function gets called directly
      } else if (flush === 'post') {
        scheduler = function scheduler() {
          return queuePostRenderEffect(job, instance && instance.suspense);
        };
      } else {
        // default: 'pre'
        scheduler = function scheduler() {
          return queuePreFlushCb(job);
        };
      }

      var effect = new ReactiveEffect(getter, scheduler);

      if (process.env.NODE_ENV !== 'production') {
        effect.onTrack = onTrack;
        effect.onTrigger = onTrigger;
      } // initial run


      if (cb) {
        if (immediate) {
          job();
        } else {
          oldValue = effect.run();
        }
      } else if (flush === 'post') {
        queuePostRenderEffect(effect.run.bind(effect), instance && instance.suspense);
      } else {
        effect.run();
      }

      return function () {
        effect.stop();

        if (instance && instance.scope) {
          remove(instance.scope.effects, effect);
        }
      };
    } // this.$watch


    function instanceWatch(source, value, options) {
      var publicThis = this.proxy;
      var getter = isString(source) ? source.includes('.') ? createPathGetter(publicThis, source) : function () {
        return publicThis[source];
      } : source.bind(publicThis, publicThis);
      var cb;

      if (isFunction(value)) {
        cb = value;
      } else {
        cb = value.handler;
        options = value;
      }

      var cur = currentInstance;
      setCurrentInstance(this);
      var res = doWatch(getter, cb.bind(publicThis), options);

      if (cur) {
        setCurrentInstance(cur);
      } else {
        unsetCurrentInstance();
      }

      return res;
    }

    function createPathGetter(ctx, path) {
      var segments = path.split('.');
      return function () {
        var cur = ctx;

        for (var i = 0; i < segments.length && cur; i++) {
          cur = cur[segments[i]];
        }

        return cur;
      };
    }

    function traverse(value, seen) {
      if (!isObject(value) || value["__v_skip"
      /* SKIP */
      ]) {
        return value;
      }

      seen = seen || new Set();

      if (seen.has(value)) {
        return value;
      }

      seen.add(value);

      if (isRef(value)) {
        traverse(value.value, seen);
      } else if (isArray(value)) {
        for (var i = 0; i < value.length; i++) {
          traverse(value[i], seen);
        }
      } else if (isSet(value) || isMap(value)) {
        value.forEach(function (v) {
          traverse(v, seen);
        });
      } else if (isPlainObject(value)) {
        for (var key in value) {
          traverse(value[key], seen);
        }
      }

      return value;
    }

    var NULL_DYNAMIC_COMPONENT = Symbol();
    /**
     * #2437 In Vue 3, functional components do not have a public instance proxy but
     * they exist in the internal parent chain. For code that relies on traversing
     * public $parent chains, skip functional ones and go to the parent instead.
     */


    var getPublicInstance = function getPublicInstance(i) {
      if (!i) return null;
      if (isStatefulComponent(i)) return getExposeProxy(i) || i.proxy;
      return getPublicInstance(i.parent);
    };

    var publicPropertiesMap = // Move PURE marker to new line to workaround compiler discarding it
    // due to type annotation

    /*#__PURE__*/
    extend(Object.create(null), {
      $: function $(i) {
        return i;
      },
      $el: function $el(i) {
        return i.vnode.el;
      },
      $data: function $data(i) {
        return i.data;
      },
      $props: function $props(i) {
        return process.env.NODE_ENV !== 'production' ? shallowReadonly(i.props) : i.props;
      },
      $attrs: function $attrs(i) {
        return process.env.NODE_ENV !== 'production' ? shallowReadonly(i.attrs) : i.attrs;
      },
      $slots: function $slots(i) {
        return process.env.NODE_ENV !== 'production' ? shallowReadonly(i.slots) : i.slots;
      },
      $refs: function $refs(i) {
        return process.env.NODE_ENV !== 'production' ? shallowReadonly(i.refs) : i.refs;
      },
      $parent: function $parent(i) {
        return getPublicInstance(i.parent);
      },
      $root: function $root(i) {
        return getPublicInstance(i.root);
      },
      $emit: function $emit(i) {
        return i.emit;
      },
      $options: function $options(i) {
        return __VUE_OPTIONS_API__ ? resolveMergedOptions(i) : i.type;
      },
      $forceUpdate: function $forceUpdate(i) {
        return i.f || (i.f = function () {
          return queueJob(i.update);
        });
      },
      $nextTick: function $nextTick(i) {
        return i.n || (i.n = nextTick.bind(i.proxy));
      },
      $watch: function $watch(i) {
        return __VUE_OPTIONS_API__ ? instanceWatch.bind(i) : NOOP;
      }
    });

    var isReservedPrefix = function isReservedPrefix(key) {
      return key === '_' || key === '$';
    };

    var PublicInstanceProxyHandlers = {
      get: function get(_ref13, key) {
        var instance = _ref13._;
        var ctx = instance.ctx,
            setupState = instance.setupState,
            data = instance.data,
            props = instance.props,
            accessCache = instance.accessCache,
            type = instance.type,
            appContext = instance.appContext; // for internal formatters to know that this is a Vue instance

        if (process.env.NODE_ENV !== 'production' && key === '__isVue') {
          return true;
        } // prioritize <script setup> bindings during dev.
        // this allows even properties that start with _ or $ to be used - so that
        // it aligns with the production behavior where the render fn is inlined and
        // indeed has access to all declared variables.


        if (process.env.NODE_ENV !== 'production' && setupState !== EMPTY_OBJ && setupState.__isScriptSetup && hasOwn(setupState, key)) {
          return setupState[key];
        } // data / props / ctx
        // This getter gets called for every property access on the render context
        // during render and is a major hotspot. The most expensive part of this
        // is the multiple hasOwn() calls. It's much faster to do a simple property
        // access on a plain object, so we use an accessCache object (with null
        // prototype) to memoize what access type a key corresponds to.


        var normalizedProps;

        if (key[0] !== '$') {
          var n = accessCache[key];

          if (n !== undefined) {
            switch (n) {
              case 1
              /* SETUP */
              :
                return setupState[key];

              case 2
              /* DATA */
              :
                return data[key];

              case 4
              /* CONTEXT */
              :
                return ctx[key];

              case 3
              /* PROPS */
              :
                return props[key];
              // default: just fallthrough
            }
          } else if (setupState !== EMPTY_OBJ && hasOwn(setupState, key)) {
            accessCache[key] = 1
            /* SETUP */
            ;
            return setupState[key];
          } else if (data !== EMPTY_OBJ && hasOwn(data, key)) {
            accessCache[key] = 2
            /* DATA */
            ;
            return data[key];
          } else if ( // only cache other properties when instance has declared (thus stable)
          // props
          (normalizedProps = instance.propsOptions[0]) && hasOwn(normalizedProps, key)) {
            accessCache[key] = 3
            /* PROPS */
            ;
            return props[key];
          } else if (ctx !== EMPTY_OBJ && hasOwn(ctx, key)) {
            accessCache[key] = 4
            /* CONTEXT */
            ;
            return ctx[key];
          } else if (!__VUE_OPTIONS_API__ || shouldCacheAccess) {
            accessCache[key] = 0
            /* OTHER */
            ;
          }
        }

        var publicGetter = publicPropertiesMap[key];
        var cssModule, globalProperties; // public $xxx properties

        if (publicGetter) {
          if (key === '$attrs') {
            track(instance, "get"
            /* GET */
            , key);
            process.env.NODE_ENV !== 'production' && markAttrsAccessed();
          }

          return publicGetter(instance);
        } else if ( // css module (injected by vue-loader)
        (cssModule = type.__cssModules) && (cssModule = cssModule[key])) {
          return cssModule;
        } else if (ctx !== EMPTY_OBJ && hasOwn(ctx, key)) {
          // user may set custom properties to `this` that start with `$`
          accessCache[key] = 4
          /* CONTEXT */
          ;
          return ctx[key];
        } else if ( // global properties
        globalProperties = appContext.config.globalProperties, hasOwn(globalProperties, key)) {
          {
            return globalProperties[key];
          }
        } else if (process.env.NODE_ENV !== 'production' && currentRenderingInstance && (!isString(key) || // #1091 avoid internal isRef/isVNode checks on component instance leading
        // to infinite warning loop
        key.indexOf('__v') !== 0)) {
          if (data !== EMPTY_OBJ && isReservedPrefix(key[0]) && hasOwn(data, key)) {
            warn("Property ".concat(JSON.stringify(key), " must be accessed via $data because it starts with a reserved ") + "character (\"$\" or \"_\") and is not proxied on the render context.");
          } else if (instance === currentRenderingInstance) {
            warn("Property ".concat(JSON.stringify(key), " was accessed during render ") + "but is not defined on instance.");
          }
        }
      },
      set: function set(_ref14, key, value) {
        var instance = _ref14._;
        var data = instance.data,
            setupState = instance.setupState,
            ctx = instance.ctx;

        if (setupState !== EMPTY_OBJ && hasOwn(setupState, key)) {
          setupState[key] = value;
          return true;
        } else if (data !== EMPTY_OBJ && hasOwn(data, key)) {
          data[key] = value;
          return true;
        } else if (hasOwn(instance.props, key)) {
          process.env.NODE_ENV !== 'production' && warn("Attempting to mutate prop \"".concat(key, "\". Props are readonly."), instance);
          return false;
        }

        if (key[0] === '$' && key.slice(1) in instance) {
          process.env.NODE_ENV !== 'production' && warn("Attempting to mutate public property \"".concat(key, "\". ") + "Properties starting with $ are reserved and readonly.", instance);
          return false;
        } else {
          if (process.env.NODE_ENV !== 'production' && key in instance.appContext.config.globalProperties) {
            Object.defineProperty(ctx, key, {
              enumerable: true,
              configurable: true,
              value: value
            });
          } else {
            ctx[key] = value;
          }
        }

        return true;
      },
      has: function has(_ref15, key) {
        var _ref15$_ = _ref15._,
            data = _ref15$_.data,
            setupState = _ref15$_.setupState,
            accessCache = _ref15$_.accessCache,
            ctx = _ref15$_.ctx,
            appContext = _ref15$_.appContext,
            propsOptions = _ref15$_.propsOptions;
        var normalizedProps;
        return !!accessCache[key] || data !== EMPTY_OBJ && hasOwn(data, key) || setupState !== EMPTY_OBJ && hasOwn(setupState, key) || (normalizedProps = propsOptions[0]) && hasOwn(normalizedProps, key) || hasOwn(ctx, key) || hasOwn(publicPropertiesMap, key) || hasOwn(appContext.config.globalProperties, key);
      },
      defineProperty: function defineProperty(target, key, descriptor) {
        if (descriptor.get != null) {
          // invalidate key cache of a getter based property #5417
          target._.accessCache[key] = 0;
        } else if (hasOwn(descriptor, 'value')) {
          this.set(target, key, descriptor.value, null);
        }

        return Reflect.defineProperty(target, key, descriptor);
      }
    };

    if (process.env.NODE_ENV !== 'production' && !false) {
      PublicInstanceProxyHandlers.ownKeys = function (target) {
        warn("Avoid app logic that relies on enumerating keys on a component instance. " + "The keys will be empty in production mode to avoid performance overhead.");
        return Reflect.ownKeys(target);
      };
    }

    var shouldCacheAccess = true;
    /**
     * Resolve merged options and cache it on the component.
     * This is done only once per-component since the merging does not involve
     * instances.
     */


    function resolveMergedOptions(instance) {
      var base = instance.type;
      var mixins = base.mixins,
          extendsOptions = base["extends"];
      var _instance$appContext = instance.appContext,
          globalMixins = _instance$appContext.mixins,
          cache = _instance$appContext.optionsCache,
          optionMergeStrategies = _instance$appContext.config.optionMergeStrategies;
      var cached = cache.get(base);
      var resolved;

      if (cached) {
        resolved = cached;
      } else if (!globalMixins.length && !mixins && !extendsOptions) {
        {
          resolved = base;
        }
      } else {
        resolved = {};

        if (globalMixins.length) {
          globalMixins.forEach(function (m) {
            return mergeOptions(resolved, m, optionMergeStrategies, true);
          });
        }

        mergeOptions(resolved, base, optionMergeStrategies);
      }

      cache.set(base, resolved);
      return resolved;
    }

    function mergeOptions(to, from, strats) {
      var asMixin = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : false;
      var mixins = from.mixins,
          extendsOptions = from["extends"];

      if (extendsOptions) {
        mergeOptions(to, extendsOptions, strats, true);
      }

      if (mixins) {
        mixins.forEach(function (m) {
          return mergeOptions(to, m, strats, true);
        });
      }

      for (var key in from) {
        if (asMixin && key === 'expose') {
          process.env.NODE_ENV !== 'production' && warn("\"expose\" option is ignored when declared in mixins or extends. " + "It should only be declared in the base component itself.");
        } else {
          var strat = internalOptionMergeStrats[key] || strats && strats[key];
          to[key] = strat ? strat(to[key], from[key]) : from[key];
        }
      }

      return to;
    }

    var internalOptionMergeStrats = {
      data: mergeDataFn,
      props: mergeObjectOptions,
      emits: mergeObjectOptions,
      // objects
      methods: mergeObjectOptions,
      computed: mergeObjectOptions,
      // lifecycle
      beforeCreate: mergeAsArray,
      created: mergeAsArray,
      beforeMount: mergeAsArray,
      mounted: mergeAsArray,
      beforeUpdate: mergeAsArray,
      updated: mergeAsArray,
      beforeDestroy: mergeAsArray,
      beforeUnmount: mergeAsArray,
      destroyed: mergeAsArray,
      unmounted: mergeAsArray,
      activated: mergeAsArray,
      deactivated: mergeAsArray,
      errorCaptured: mergeAsArray,
      serverPrefetch: mergeAsArray,
      // assets
      components: mergeObjectOptions,
      directives: mergeObjectOptions,
      // watch
      watch: mergeWatchOptions,
      // provide / inject
      provide: mergeDataFn,
      inject: mergeInject
    };

    function mergeDataFn(to, from) {
      if (!from) {
        return to;
      }

      if (!to) {
        return from;
      }

      return function mergedDataFn() {
        return extend(isFunction(to) ? to.call(this, this) : to, isFunction(from) ? from.call(this, this) : from);
      };
    }

    function mergeInject(to, from) {
      return mergeObjectOptions(normalizeInject(to), normalizeInject(from));
    }

    function normalizeInject(raw) {
      if (isArray(raw)) {
        var res = {};

        for (var i = 0; i < raw.length; i++) {
          res[raw[i]] = raw[i];
        }

        return res;
      }

      return raw;
    }

    function mergeAsArray(to, from) {
      return to ? _toConsumableArray(new Set([].concat(to, from))) : from;
    }

    function mergeObjectOptions(to, from) {
      return to ? extend(extend(Object.create(null), to), from) : from;
    }

    function mergeWatchOptions(to, from) {
      if (!to) return from;
      if (!from) return to;
      var merged = extend(Object.create(null), to);

      for (var key in from) {
        merged[key] = mergeAsArray(to[key], from[key]);
      }

      return merged;
    }

    var queuePostRenderEffect = queueEffectWithSuspense;

    var isTeleport = function isTeleport(type) {
      return type.__isTeleport;
    };
    var Fragment = Symbol(process.env.NODE_ENV !== 'production' ? 'Fragment' : undefined);
    var Text = Symbol(process.env.NODE_ENV !== 'production' ? 'Text' : undefined);
    var Comment = Symbol(process.env.NODE_ENV !== 'production' ? 'Comment' : undefined);
    Symbol(process.env.NODE_ENV !== 'production' ? 'Static' : undefined); // Since v-if and v-for are the two possible ways node structure can dynamically
    var currentBlock = null;

    function isVNode(value) {
      return value ? value.__v_isVNode === true : false;
    }

    var createVNodeWithArgsTransform = function createVNodeWithArgsTransform() {
      for (var _len7 = arguments.length, args = new Array(_len7), _key15 = 0; _key15 < _len7; _key15++) {
        args[_key15] = arguments[_key15];
      }

      return _createVNode.apply(void 0, _toConsumableArray(args));
    };

    var InternalObjectKey = "__vInternal";

    var normalizeKey = function normalizeKey(_ref22) {
      var key = _ref22.key;
      return key != null ? key : null;
    };

    var normalizeRef = function normalizeRef(_ref23) {
      var ref = _ref23.ref,
          ref_key = _ref23.ref_key,
          ref_for = _ref23.ref_for;
      return ref != null ? isString(ref) || isRef(ref) || isFunction(ref) ? {
        i: currentRenderingInstance,
        r: ref,
        k: ref_key,
        f: !!ref_for
      } : ref : null;
    };

    function createBaseVNode(type) {
      var props = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
      var children = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;
      var patchFlag = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : 0;
      var dynamicProps = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : null;
      var shapeFlag = arguments.length > 5 && arguments[5] !== undefined ? arguments[5] : type === Fragment ? 0 : 1;
      var isBlockNode = arguments.length > 6 && arguments[6] !== undefined ? arguments[6] : false;
      var needFullChildrenNormalization = arguments.length > 7 && arguments[7] !== undefined ? arguments[7] : false;
      var vnode = {
        __v_isVNode: true,
        __v_skip: true,
        type: type,
        props: props,
        key: props && normalizeKey(props),
        ref: props && normalizeRef(props),
        scopeId: currentScopeId,
        slotScopeIds: null,
        children: children,
        component: null,
        suspense: null,
        ssContent: null,
        ssFallback: null,
        dirs: null,
        transition: null,
        el: null,
        anchor: null,
        target: null,
        targetAnchor: null,
        staticCount: 0,
        shapeFlag: shapeFlag,
        patchFlag: patchFlag,
        dynamicProps: dynamicProps,
        dynamicChildren: null,
        appContext: null
      };

      if (needFullChildrenNormalization) {
        normalizeChildren(vnode, children); // normalize suspense children

        if (shapeFlag & 128
        /* SUSPENSE */
        ) {
          type.normalize(vnode);
        }
      } else if (children) {
        // compiled element vnode - if children is passed, only possible types are
        // string or Array.
        vnode.shapeFlag |= isString(children) ? 8
        /* TEXT_CHILDREN */
        : 16
        /* ARRAY_CHILDREN */
        ;
      } // validate key


      if (process.env.NODE_ENV !== 'production' && vnode.key !== vnode.key) {
        warn("VNode created with invalid key (NaN). VNode type:", vnode.type);
      } // track vnode for block tree


      if (// avoid a block node from tracking itself
      !isBlockNode && // has current parent block
      currentBlock && ( // presence of a patch flag indicates this node needs patching on updates.
      // component nodes also should always be patched, because even if the
      // component doesn't need to update, it needs to persist the instance on to
      // the next vnode so that it can be properly unmounted later.
      vnode.patchFlag > 0 || shapeFlag & 6
      /* COMPONENT */
      ) && // the EVENTS flag is only for hydration and if it is the only flag, the
      // vnode should not be considered dynamic due to handler caching.
      vnode.patchFlag !== 32
      /* HYDRATE_EVENTS */
      ) {
        currentBlock.push(vnode);
      }

      return vnode;
    }

    var createVNode = process.env.NODE_ENV !== 'production' ? createVNodeWithArgsTransform : _createVNode;

    function _createVNode(type) {
      var props = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
      var children = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;
      var patchFlag = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : 0;
      var dynamicProps = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : null;
      var isBlockNode = arguments.length > 5 && arguments[5] !== undefined ? arguments[5] : false;

      if (!type || type === NULL_DYNAMIC_COMPONENT) {
        if (process.env.NODE_ENV !== 'production' && !type) {
          warn("Invalid vnode type when creating vnode: ".concat(type, "."));
        }

        type = Comment;
      }

      if (isVNode(type)) {
        // createVNode receiving an existing vnode. This happens in cases like
        // <component :is="vnode"/>
        // #2078 make sure to merge refs during the clone instead of overwriting it
        var cloned = cloneVNode(type, props, true
        /* mergeRef: true */
        );

        if (children) {
          normalizeChildren(cloned, children);
        }

        if (!isBlockNode && currentBlock) {
          if (cloned.shapeFlag & 6
          /* COMPONENT */
          ) {
            currentBlock[currentBlock.indexOf(type)] = cloned;
          } else {
            currentBlock.push(cloned);
          }
        }

        cloned.patchFlag |= -2
        /* BAIL */
        ;
        return cloned;
      } // class component normalization.


      if (isClassComponent(type)) {
        type = type.__vccOpts;
      } // class & style normalization.


      if (props) {
        // for reactive or proxy objects, we need to clone it to enable mutation.
        props = guardReactiveProps(props);
        var _props = props,
            klass = _props["class"],
            style = _props.style;

        if (klass && !isString(klass)) {
          props["class"] = normalizeClass(klass);
        }

        if (isObject(style)) {
          // reactive state objects need to be cloned since they are likely to be
          // mutated
          if (isProxy(style) && !isArray(style)) {
            style = extend({}, style);
          }

          props.style = normalizeStyle(style);
        }
      } // encode the vnode type information into a bitmap


      var shapeFlag = isString(type) ? 1
      /* ELEMENT */
      : isSuspense(type) ? 128
      /* SUSPENSE */
      : isTeleport(type) ? 64
      /* TELEPORT */
      : isObject(type) ? 4
      /* STATEFUL_COMPONENT */
      : isFunction(type) ? 2
      /* FUNCTIONAL_COMPONENT */
      : 0;

      if (process.env.NODE_ENV !== 'production' && shapeFlag & 4
      /* STATEFUL_COMPONENT */
      && isProxy(type)) {
        type = toRaw(type);
        warn("Vue received a Component which was made a reactive object. This can " + "lead to unnecessary performance overhead, and should be avoided by " + "marking the component with `markRaw` or using `shallowRef` " + "instead of `ref`.", "\nComponent that was made reactive: ", type);
      }

      return createBaseVNode(type, props, children, patchFlag, dynamicProps, shapeFlag, isBlockNode, true);
    }

    function guardReactiveProps(props) {
      if (!props) return null;
      return isProxy(props) || InternalObjectKey in props ? extend({}, props) : props;
    }

    function cloneVNode(vnode, extraProps) {
      var mergeRef = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;
      // This is intentionally NOT using spread or extend to avoid the runtime
      // key enumeration cost.
      var props = vnode.props,
          ref = vnode.ref,
          patchFlag = vnode.patchFlag,
          children = vnode.children;
      var mergedProps = extraProps ? mergeProps(props || {}, extraProps) : props;
      var cloned = {
        __v_isVNode: true,
        __v_skip: true,
        type: vnode.type,
        props: mergedProps,
        key: mergedProps && normalizeKey(mergedProps),
        ref: extraProps && extraProps.ref ? // #2078 in the case of <component :is="vnode" ref="extra"/>
        // if the vnode itself already has a ref, cloneVNode will need to merge
        // the refs so the single vnode can be set on multiple refs
        mergeRef && ref ? isArray(ref) ? ref.concat(normalizeRef(extraProps)) : [ref, normalizeRef(extraProps)] : normalizeRef(extraProps) : ref,
        scopeId: vnode.scopeId,
        slotScopeIds: vnode.slotScopeIds,
        children: process.env.NODE_ENV !== 'production' && patchFlag === -1
        /* HOISTED */
        && isArray(children) ? children.map(deepCloneVNode) : children,
        target: vnode.target,
        targetAnchor: vnode.targetAnchor,
        staticCount: vnode.staticCount,
        shapeFlag: vnode.shapeFlag,
        // if the vnode is cloned with extra props, we can no longer assume its
        // existing patch flag to be reliable and need to add the FULL_PROPS flag.
        // note: preserve flag for fragments since they use the flag for children
        // fast paths only.
        patchFlag: extraProps && vnode.type !== Fragment ? patchFlag === -1 // hoisted node
        ? 16
        /* FULL_PROPS */
        : patchFlag | 16
        /* FULL_PROPS */
        : patchFlag,
        dynamicProps: vnode.dynamicProps,
        dynamicChildren: vnode.dynamicChildren,
        appContext: vnode.appContext,
        dirs: vnode.dirs,
        transition: vnode.transition,
        // These should technically only be non-null on mounted VNodes. However,
        // they *should* be copied for kept-alive vnodes. So we just always copy
        // them since them being non-null during a mount doesn't affect the logic as
        // they will simply be overwritten.
        component: vnode.component,
        suspense: vnode.suspense,
        ssContent: vnode.ssContent && cloneVNode(vnode.ssContent),
        ssFallback: vnode.ssFallback && cloneVNode(vnode.ssFallback),
        el: vnode.el,
        anchor: vnode.anchor
      };
      return cloned;
    }
    /**
     * Dev only, for HMR of hoisted vnodes reused in v-for
     * https://github.com/vitejs/vite/issues/2022
     */


    function deepCloneVNode(vnode) {
      var cloned = cloneVNode(vnode);

      if (isArray(vnode.children)) {
        cloned.children = vnode.children.map(deepCloneVNode);
      }

      return cloned;
    }
    /**
     * @private
     */


    function createTextVNode() {
      var text = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : ' ';
      var flag = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0;
      return createVNode(Text, null, text, flag);
    }

    function normalizeChildren(vnode, children) {
      var type = 0;
      var shapeFlag = vnode.shapeFlag;

      if (children == null) {
        children = null;
      } else if (isArray(children)) {
        type = 16
        /* ARRAY_CHILDREN */
        ;
      } else if (_typeof(children) === 'object') {
        if (shapeFlag & (1
        /* ELEMENT */
        | 64
        /* TELEPORT */
        )) {
          // Normalize slot to plain children for plain element and Teleport
          var slot = children["default"];

          if (slot) {
            // _c marker is added by withCtx() indicating this is a compiled slot
            slot._c && (slot._d = false);
            normalizeChildren(vnode, slot());
            slot._c && (slot._d = true);
          }

          return;
        } else {
          type = 32
          /* SLOTS_CHILDREN */
          ;
          var slotFlag = children._;

          if (!slotFlag && !(InternalObjectKey in children)) {
            children._ctx = currentRenderingInstance;
          } else if (slotFlag === 3
          /* FORWARDED */
          && currentRenderingInstance) {
            // a child component receives forwarded slots from the parent.
            // its slot type is determined by its parent's slot type.
            if (currentRenderingInstance.slots._ === 1
            /* STABLE */
            ) {
              children._ = 1
              /* STABLE */
              ;
            } else {
              children._ = 2
              /* DYNAMIC */
              ;
              vnode.patchFlag |= 1024
              /* DYNAMIC_SLOTS */
              ;
            }
          }
        }
      } else if (isFunction(children)) {
        children = {
          "default": children,
          _ctx: currentRenderingInstance
        };
        type = 32
        /* SLOTS_CHILDREN */
        ;
      } else {
        children = String(children); // force teleport children to array so it can be moved around

        if (shapeFlag & 64
        /* TELEPORT */
        ) {
          type = 16
          /* ARRAY_CHILDREN */
          ;
          children = [createTextVNode(children)];
        } else {
          type = 8
          /* TEXT_CHILDREN */
          ;
        }
      }

      vnode.children = children;
      vnode.shapeFlag |= type;
    }

    function mergeProps() {
      var ret = {};

      for (var i = 0; i < arguments.length; i++) {
        var toMerge = i < 0 || arguments.length <= i ? undefined : arguments[i];

        for (var key in toMerge) {
          if (key === 'class') {
            if (ret["class"] !== toMerge["class"]) {
              ret["class"] = normalizeClass([ret["class"], toMerge["class"]]);
            }
          } else if (key === 'style') {
            ret.style = normalizeStyle([ret.style, toMerge.style]);
          } else if (isOn(key)) {
            var existing = ret[key];
            var incoming = toMerge[key];

            if (incoming && existing !== incoming && !(isArray(existing) && existing.includes(incoming))) {
              ret[key] = existing ? [].concat(existing, incoming) : incoming;
            }
          } else if (key !== '') {
            ret[key] = toMerge[key];
          }
        }
      }

      return ret;
    }

    var currentInstance = null;

    var getCurrentInstance = function getCurrentInstance() {
      return currentInstance || currentRenderingInstance;
    };

    var setCurrentInstance = function setCurrentInstance(instance) {
      currentInstance = instance;
      instance.scope.on();
    };

    var unsetCurrentInstance = function unsetCurrentInstance() {
      currentInstance && currentInstance.scope.off();
      currentInstance = null;
    };

    function isStatefulComponent(instance) {
      return instance.vnode.shapeFlag & 4
      /* STATEFUL_COMPONENT */
      ;
    }

    function getExposeProxy(instance) {
      if (instance.exposed) {
        return instance.exposeProxy || (instance.exposeProxy = new Proxy(proxyRefs(markRaw(instance.exposed)), {
          get: function get(target, key) {
            if (key in target) {
              return target[key];
            } else if (key in publicPropertiesMap) {
              return publicPropertiesMap[key](instance);
            }
          }
        }));
      }
    }

    var classifyRE = /(?:^|[-_])(\w)/g;

    var classify = function classify(str) {
      return str.replace(classifyRE, function (c) {
        return c.toUpperCase();
      }).replace(/[-_]/g, '');
    };

    function getComponentName(Component) {
      var includeInferred = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;
      return isFunction(Component) ? Component.displayName || Component.name : Component.name || includeInferred && Component.__name;
    }
    /* istanbul ignore next */


    function formatComponentName(instance, Component) {
      var isRoot = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;
      var name = getComponentName(Component);

      if (!name && Component.__file) {
        var match = Component.__file.match(/([^/\\]+)\.\w+$/);

        if (match) {
          name = match[1];
        }
      }

      if (!name && instance && instance.parent) {
        // try to infer the name based on reverse resolution
        var inferFromRegistry = function inferFromRegistry(registry) {
          for (var key in registry) {
            if (registry[key] === Component) {
              return key;
            }
          }
        };

        name = inferFromRegistry(instance.components || instance.parent.type.components) || inferFromRegistry(instance.appContext.components);
      }

      return name ? classify(name) : isRoot ? "App" : "Anonymous";
    }

    function isClassComponent(value) {
      return isFunction(value) && '__vccOpts' in value;
    }

    Symbol(process.env.NODE_ENV !== 'production' ? "ssrContext" : "");

    function isShallow(value) {
      return !!(value && value["__v_isShallow"
      /* IS_SHALLOW */
      ]);
    }

    function initCustomFormatter() {
      /* eslint-disable no-restricted-globals */
      if (!(process.env.NODE_ENV !== 'production') || typeof window === 'undefined') {
        return;
      }

      var vueStyle = {
        style: 'color:#3ba776'
      };
      var numberStyle = {
        style: 'color:#0b1bc9'
      };
      var stringStyle = {
        style: 'color:#b62e24'
      };
      var keywordStyle = {
        style: 'color:#9d288c'
      }; // custom formatter for Chrome
      // https://www.mattzeunert.com/2016/02/19/custom-chrome-devtools-object-formatters.html

      var formatter = {
        header: function header(obj) {
          // TODO also format ComponentPublicInstance & ctx.slots/attrs in setup
          if (!isObject(obj)) {
            return null;
          }

          if (obj.__isVue) {
            return ['div', vueStyle, "VueInstance"];
          } else if (isRef(obj)) {
            return ['div', {}, ['span', vueStyle, genRefFlag(obj)], '<', formatValue(obj.value), ">"];
          } else if (isReactive(obj)) {
            return ['div', {}, ['span', vueStyle, isShallow(obj) ? 'ShallowReactive' : 'Reactive'], '<', formatValue(obj), ">".concat(isReadonly(obj) ? " (readonly)" : "")];
          } else if (isReadonly(obj)) {
            return ['div', {}, ['span', vueStyle, isShallow(obj) ? 'ShallowReadonly' : 'Readonly'], '<', formatValue(obj), '>'];
          }

          return null;
        },
        hasBody: function hasBody(obj) {
          return obj && obj.__isVue;
        },
        body: function body(obj) {
          if (obj && obj.__isVue) {
            return ['div', {}].concat(_toConsumableArray(formatInstance(obj.$)));
          }
        }
      };

      function formatInstance(instance) {
        var blocks = [];

        if (instance.type.props && instance.props) {
          blocks.push(createInstanceBlock('props', toRaw(instance.props)));
        }

        if (instance.setupState !== EMPTY_OBJ) {
          blocks.push(createInstanceBlock('setup', instance.setupState));
        }

        if (instance.data !== EMPTY_OBJ) {
          blocks.push(createInstanceBlock('data', toRaw(instance.data)));
        }

        var computed = extractKeys(instance, 'computed');

        if (computed) {
          blocks.push(createInstanceBlock('computed', computed));
        }

        var injected = extractKeys(instance, 'inject');

        if (injected) {
          blocks.push(createInstanceBlock('injected', injected));
        }

        blocks.push(['div', {}, ['span', {
          style: keywordStyle.style + ';opacity:0.66'
        }, '$ (internal): '], ['object', {
          object: instance
        }]]);
        return blocks;
      }

      function createInstanceBlock(type, target) {
        target = extend({}, target);

        if (!Object.keys(target).length) {
          return ['span', {}];
        }

        return ['div', {
          style: 'line-height:1.25em;margin-bottom:0.6em'
        }, ['div', {
          style: 'color:#476582'
        }, type], ['div', {
          style: 'padding-left:1.25em'
        }].concat(_toConsumableArray(Object.keys(target).map(function (key) {
          return ['div', {}, ['span', keywordStyle, key + ': '], formatValue(target[key], false)];
        })))];
      }

      function formatValue(v) {
        var asRaw = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;

        if (typeof v === 'number') {
          return ['span', numberStyle, v];
        } else if (typeof v === 'string') {
          return ['span', stringStyle, JSON.stringify(v)];
        } else if (typeof v === 'boolean') {
          return ['span', keywordStyle, v];
        } else if (isObject(v)) {
          return ['object', {
            object: asRaw ? toRaw(v) : v
          }];
        } else {
          return ['span', stringStyle, String(v)];
        }
      }

      function extractKeys(instance, type) {
        var Comp = instance.type;

        if (isFunction(Comp)) {
          return;
        }

        var extracted = {};

        for (var key in instance.ctx) {
          if (isKeyOfType(Comp, key, type)) {
            extracted[key] = instance.ctx[key];
          }
        }

        return extracted;
      }

      function isKeyOfType(Comp, key, type) {
        var opts = Comp[type];

        if (isArray(opts) && opts.includes(key) || isObject(opts) && key in opts) {
          return true;
        }

        if (Comp["extends"] && isKeyOfType(Comp["extends"], key, type)) {
          return true;
        }

        if (Comp.mixins && Comp.mixins.some(function (m) {
          return isKeyOfType(m, key, type);
        })) {
          return true;
        }
      }

      function genRefFlag(v) {
        if (isShallow(v)) {
          return "ShallowRef";
        }

        if (v.effect) {
          return "ComputedRef";
        }

        return "Ref";
      }

      if (window.devtoolsFormatters) {
        window.devtoolsFormatters.push(formatter);
      } else {
        window.devtoolsFormatters = [formatter];
      }
    }

    var _ref = /*#__PURE__*/function () {
      var _getNow = Date.now;
      var skipTimestampCheck = false;

      if (typeof window !== 'undefined') {
        // Determine what event timestamp the browser is using. Annoyingly, the
        // timestamp can either be hi-res (relative to page load) or low-res
        // (relative to UNIX epoch), so in order to compare time we have to use the
        // same timestamp type when saving the flush timestamp.
        if (Date.now() > document.createEvent('Event').timeStamp) {
          // if the low-res timestamp which is bigger than the event timestamp
          // (which is evaluated AFTER) it means the event is using a hi-res timestamp,
          // and we need to use the hi-res version for event listeners as well.
          _getNow = performance.now.bind(performance);
        } // #3485: Firefox <= 53 has incorrect Event.timeStamp implementation
        // and does not fire microtasks in between event propagation, so safe to exclude.


        var ffMatch = navigator.userAgent.match(/firefox\/(\d+)/i);
        skipTimestampCheck = !!(ffMatch && Number(ffMatch[1]) <= 53);
      }

      return [_getNow, skipTimestampCheck];
    }(),
        _ref2 = _slicedToArray(_ref, 2);
        _ref2[0];
        _ref2[1]; // To avoid the overhead of repeatedly calling performance.now(), we cache

    function initDev() {
      {
        initCustomFormatter();
      }
    } // This entry exports the runtime only, and is built as


    if (process.env.NODE_ENV !== 'production') {
      initDev();
    }

    Vue;

    exports.debug = process.env.NODE_ENV !== 'production';
    /**
     * 调试打印日志, 默认为在开发模式下启用
     */

    var setDebug = function setDebug(status) {
      return exports.debug = status;
    };

    /**
     * activeFetch must be called to handle SSR at the top of functions like
     * `fetch`, `setup`, `serverPrefetch` and others
     */
    exports.activeFetch = void 0;
    /**
     * Set or unset active fetch, Used in SSR and internally when calling
     * actions and getters
     * @param fetch Fetch instance
     */

    var setActiveFetch = function setActiveFetch(fetch) {
      return exports.activeFetch = fetch;
    };
    /**
     * Get the currently active fetch if there is any.
     */

    var getActiveFetch = function getActiveFetch() {
      return getCurrentInstance() && inject(FetchSymbol) || exports.activeFetch;
    };
    var FetchSymbol = exports.debug ? Symbol["for"]('__Fetch__') : Symbol();

    function createFetch(client, options) {
      var registApis = registApi(client, options.apis, options.prefix);
      var fetch = markRaw({
        install: function install(app) {
          // this allows calling useFetch() outside of a component setup after
          setActiveFetch(fetch);

          {
            fetch._a = app;
            app.provide(FetchSymbol, fetch);
            app.config.globalProperties.$fetch = fetch;
          }
        },
        client: client,
        registApis: registApis,
        // it's actually undefined here
        // @ts-expect-error
        _a: null,
        _o: options
      });
      return fetch;
    }

    function useFetch() {
      return getActiveFetch();
    }

    function FetchVuePlugin(Vue) {
      // Used to avoid multiple mixins being setup
      // when in dev mode and hot module reload
      // https://github.com/vuejs/vue/issues/5089#issuecomment-284260111
      if (Vue.$__fetch_installed__) return; // eslint-disable-next-line @typescript-eslint/camelcase

      Vue.$__fetch_installed__ = true; // Equivalent of
      // app.config.globalProperties.$fetch = fetch

      Vue.mixin({
        beforeCreate: function beforeCreate() {
          var options = this.$options;

          if (options.fetch) {
            var fetch = options.fetch; // HACK: taken from provide(): https://github.com/vuejs/composition-api/blob/main/src/apis/inject.ts#L31

            if (!this._provided) {
              var provideCache = {};
              Object.defineProperty(this, '_provided', {
                get: function get() {
                  return provideCache;
                },
                set: function set(v) {
                  return Object.assign(provideCache, v);
                }
              });
            }

            this._provided[FetchSymbol] = fetch; // propagate the fetch instance in an SSR friendly way
            // avoid adding it to nuxt twice

            if (!this.$pinia) {
              this.$fetch = fetch;
            }

            fetch._a = this;
          } else {
            this.$fetch = options.parent && options.parent.$fetch || this;
          }
        }
      });
    } // Auto install if it is not done yet and `window` has `Vue` in Vue2.
    // To allow users to avoid auto-installation in some cases,

    if (typeof window !== 'undefined' && window.Vue) {
      window.Vue.use(FetchVuePlugin);
    } // @internal

    var version = "0.1.0-alpha.0";

    exports.FetchSymbol = FetchSymbol;
    exports.FetchVuePlugin = FetchVuePlugin;
    exports.createFetch = createFetch;
    exports.defineApi = defineApi;
    exports.getActiveFetch = getActiveFetch;
    exports.registApi = registApi;
    exports.setActiveFetch = setActiveFetch;
    exports.setDebug = setDebug;
    exports.typedUrl = typedUrl;
    exports.useFetch = useFetch;
    exports.version = version;

    Object.defineProperty(exports, '__esModule', { value: true });

}));
//# sourceMappingURL=fetch.umd.development.js.map
